/*------------------------------------------------------------------------------
#
#	Apple Macintosh Developer Technical Support
#
#	DTS.Draw.r	-	Rez Source
#
#	Copyright  1989-1992 Apple Computer, Inc.
#	All rights reserved.
#
#	Version:
#				1.0b3				1/92
#
------------------------------------------------------------------------------*/


#include "Types.r"
#include "SysTypes.r"
#include "BalloonTypes.r"
#include "App.Common.h"
#include "App.Menu.h"
#include "UtilitiesCommon.h"

include "::DTS.Lib:teCDEF" 'CDEF' ("teCDEF") as 
		'CDEF' (rTECtl, "teCDEF");

include "::DTS.Lib:listCDEF" 'CDEF' ("listCDEF") as 
		'CDEF' (rListCtl, "listCDEF");

include "WorldScript II.WDEF" 'WDEF' ("WorldScript II.WDEF") as 
		'WDEF' (0x400, "WorldScript II.WDEF");

include "TearOff.MDEF" 'MDEF' ("TearOff.MDEF") as 
		'MDEF' (512, "TearOff.MDEF");


resource 'STR ' (-16396) {
	"DTS.Draw"
};
type kDocCreator as 'STR ';			/* Put all 'STR ' resources before this!! */
resource kDocCreator (0) {
	"DTS.Draw - Version 1.0b3 - System 7.0"
};
resource 'vers' (1, purgeable) {
	0x01,
	0x03,
	beta,
	0x01,
	verUs,
	"1.0b3",
	"DTS.Draw - Version 1.0b3 - 7.0"
};




resource 'MBAR' (rMenuBar, preload) { { mApple, mFile, mEdit, mArrange, mToolPalette } };
resource 'MENU' (mApple, preload) {
	mApple, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable dashed line, enable About and DAs */
	enabled, apple,
	{
		"About DTS.Draw 1.0",	noicon, nokey, nomark, plain;
		"-",					noicon, nokey, nomark, plain
	}
};
resource 'MENU' (mFile, preload) { mFile, textMenuProc, AllItems, enabled, "File",
	{
		"New",				noicon, "N", nomark, plain;
		"Open",			noicon, "O", nomark, plain;
		"-",				noicon, nokey, nomark, plain;
		"Close",			noicon, "W", nomark, plain;
		"Save",				noicon, "S", nomark, plain;
		"Save As",			noicon, nokey, nomark, plain;
		"Duplicate",		noicon, "D", nomark, plain;
		"-",				noicon, nokey, nomark, plain;
		"Page Setup",		noicon, nokey, nomark, plain;
		"Print",			noicon, "P", nomark, plain;
		"-",				noicon, nokey, nomark, plain;
		"Quit",				noicon, "Q", nomark, plain
	}
};
resource 'MENU' (mEdit, preload) { mEdit, textMenuProc, AllItems, enabled, "Edit",
	{
		"Undo",						noicon, "Z", nomark, plain;
		"Redo",						noicon, "A", nomark, plain;
		"-",						noicon, nokey, nomark, plain;
		"Cut",						noicon, "X", nomark, plain;
		"Copy",						noicon, "C", nomark, plain;
		"Paste",					noicon, "V", nomark, plain;
		"Clear",					noicon, nokey, nomark, plain;
		"-",						noicon, nokey, nomark, plain;
		"Show,Hide, Clipboard",		noicon, nokey, nomark, plain;
#if VH_VERSION
		"-",						noicon, nokey, nomark, plain;
		"View Hierarchy",			noicon, nokey, nomark, plain;
#endif
	}
};
resource 'MENU' (mArrange, preload) { mArrange, textMenuProc, AllItems, enabled, "Arrange",
	{
		"Show,Hide, Tool Palette",	noicon, "T", nomark, plain;
		"-",						noicon, nokey, nomark, plain;
		"Move Forward",				noicon, "F", nomark, plain;
		"Move To Front",			noicon, nokey, nomark, plain;
		"Move Backward",			noicon, "B", nomark, plain;
		"Move To Back",				noicon, nokey, nomark, plain;
		"-",						noicon, nokey, nomark, plain;
		"Group",					noicon, nokey, nomark, plain;
		"Ungroup",					noicon, nokey, nomark, plain;
	}
};
resource 'MENU' (mToolPalette, preload) { mToolPalette, 512, AllItems, enabled, "Tools",
	{
		"300,350",						noIcon, noKey, noMark, plain,
		"301,351,401",					noIcon, noKey, noMark, plain,
		"302,352,402",					noIcon, noKey, noMark, plain,
		"303,353,403",					noIcon, noKey, noMark, plain,
		"304,354,404",					noIcon, noKey, noMark, plain,
		"TearRect,20,32,20,32,0,0,2,2",	noIcon, noKey, noMark, plain
	}
};



/***************************************************************************/



#if VH_VERSION
resource 'CNTL' (rNewViewCtl) { {10, 420, 30, 480}, 0, visible, 0, 0, pushButProc, 1, "Display" };
#endif



/***************************************************************************/



resource 'ALRT' (rAboutAlert, purgeable) {
	{40, 20, 206, 341},
	rAboutAlert,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};
resource 'DITL' (rAboutAlert, purgeable) {
	{ /* array DITLarray: 5 elements */
		{135, 228, 155, 308},	Button { enabled, "OK" },
		{8, 8, 44, 308},		StaticText { disabled, "DTS.Draw 1.0b3 (7.0 compatible)"},
		{42, 8, 58, 308},		StaticText { disabled, "Copyright  1989-1992 Apple Computer" },
		{84, 8, 124, 308},		StaticText { disabled, "Written by:  Eric Soldan\nAny problems "
													   "or suggestions, let me know."  },
		{130, 8, 150, 209},		StaticText { disabled, "  (AppleLink: SOLDAN)" }
	}
};



/***************************************************************************/



resource 'ALRT' (rErrorAlert, purgeable) {
	{40, 20, 120, 360},
	rErrorAlert,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};
resource 'DITL' (rErrorAlert, purgeable) {
	{
		{50, 250, 70, 330},	Button { enabled, "OK" },
		{10, 60, 30, 360},	StaticText { disabled, "DTS.Draw - Error occurred!" },
		{8, 8, 40, 40},		Icon { disabled, 2 }
	}
};



/***************************************************************************/



resource 'DLOG' (rYesNoCancel, purgeable) {
	{40, 20, 144, 400}, dBoxProc, visible, noGoAway, 0x0, rYesNoCancel, "" };
resource 'DITL' (rYesNoCancel, purgeable) {
	{
		{71, 315, 91, 367},		Button { enabled, "Save" },
		{0, -1000, 20, 2},		StaticText { disabled, "=S190001,=s190001,=D190003,=d190003,=.190104,1B190004" },
		{71, 80, 91, 162},		Button { enabled, "Dont Save" },
		{71, 244, 91, 302},		Button { enabled, "Cancel" },
		{11, 78, 61, 366},		StaticText { disabled, "Save changes to the DTS.Draw document ^0 before ^1?" },
		{11, 23, 43, 55},		Icon { disabled, 2 }
	}
};



/***************************************************************************/



resource 'DLOG' (rOpenReadOnly, purgeable) {
	{40, 20, 144, 355}, dBoxProc, visible, noGoAway, 0x0, rOpenReadOnly, "" };
resource 'DITL' (rOpenReadOnly, purgeable) {
	{
		{71, 261, 91, 322},		Button { enabled, "Open" },
		{0, -1000, 20, 2},		StaticText { disabled, "=.190103,1B190003" },
		{71, 174, 91, 248},		Button { enabled, "Cancel" },
		{11, 78, 61, 320},		StaticText { disabled, "Open the DTS.Draw document ^0 as read-only?" },
		{11, 23, 43, 55},		Icon { disabled, 2 }
	}
};



/***************************************************************************/



resource 'DLOG' (rPrStatusDlg) {
	{110, 40, 219, 423}, dBoxProc, visible, goAway, 0x0, rPrStatusDlg, "" };
resource 'DITL' (rPrStatusDlg) {
	{
		{72, 24, 92, 104},		Button { enabled, "Proceed" },
		{72, 128, 92, 208},		Button { enabled, "Pause" },
		{72, 232, 92, 362},		Button { enabled, "Cancel Printing" },
		{16, 24, 56, 300},		StaticText { disabled, "Document ^0 is being printed." }
	}
};



/***************************************************************************/



resource 'WIND' (rWindow, preload, purgeable) {
	{rWindowYPos, rWindowXPos, rWindowYPos + rWindowHeight, rWindowXPos + rWindowWidth},
	zoomDocProc, visible, goAway, 0x0, "DTS.Draw"
};
resource 'WIND' (rVHWindow, preload, purgeable) {
	{rWindowYPos, rWindowXPos, rWindowYPos + rWindowHeight, rWindowXPos + rWindowWidth},
	zoomDocProc, visible, goAway, 0x0, "DTS.Draw"
};
resource 'WIND' (rToolWindow, preload, purgeable) {
	{0, 0, 99, 32},
	16384, visible, goAway, 0x0, ""
};
resource 'WIND' (rClipboardWindow, preload, purgeable) {
	{rWindowYPos, rWindowXPos, rWindowYPos + rWindowHeight, rWindowXPos + rWindowWidth},
	zoomDocProc, invisible, goAway, 0x0, "Clipboard"
};



/***************************************************************************/



resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* Can properly use background null events	*/
	doesActivateOnFGSwitch,		/* We do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* This is definitely not a background-only application! */
	dontGetFrontClicks,			/* Change this is if you want "do first click" behavior like the Finder */
	ignoreAppDiedEvents,		/* Essentially, I'm not a debugger (sub-launching) */
	is32BitCompatible,			/* This app can be run in 32-bit address space */
	isHighLevelEventAware,		/* does Post/AcceptHighLevelEvent */
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	kPrefSize * 2048,
	kMinSize * 2048
};



/***************************************************************************/



resource 'STR#' (rFileIOStrings, purgeable) {
	{
		"Save File As:",
		"closing",
		"quitting"
	}
};

resource 'STR#' (rDefaultTitles, purgeable) {
	{
		"Untitled #"
	}
};

resource 'STR#'(rBadNewsStrings, purgeable) {
	{
	/* [1] */	"This program needs to run on a Macintosh with 128K or better";
	/* [2] */	"Your heap is too small to run this application";
	/* [3] */	"Your heap is too small to run this application";
	/* [4] */	"An error has occured";
	}
};



/***************************************************************************/



resource 'FREF' (129) {
	kDocFileType,
	1,
	""
};
resource 'FREF' (128) {
	'APPL',
	0,
	""
};
resource 'BNDL' (128) {
	kDocCreator, 0, {
		'ICN#', { 0, 128, 1, 129 },
		'FREF', { 0, 128, 1, 129 }
	}
};



/***************************************************************************/



resource 'icl4' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF FFFF FF00"
	$"0000 0000 0000 0000 0000 00FF FFFF FF00"
	$"0000 0000 0000 0000 0000 00FF FFFF FF00"
	$"0000 0000 0000 0000 0000 00F0 0000 F000"
	$"0000 0000 0000 0000 0000 0F00 0000 F000"
	$"0000 0000 0000 0000 0000 F000 000F 0000"
	$"0000 0000 0000 0000 000F 0000 000F 0000"
	$"0000 0000 0000 0000 00F0 00F0 000F 0000"
	$"0000 0000 0000 0000 0F00 00F0 000F 0000"
	$"0000 0000 0000 0000 0F00 00F0 000F 0000"
	$"0000 0000 0000 0000 0F00 00F0 000F 0000"
	$"0000 0000 0000 0000 0F00 0FF0 000F 0000"
	$"0000 0000 0000 0000 0F00 F0FF 000F 0000"
	$"0000 0000 0000 0000 0F00 F0FF 00F0 0000"
	$"0000 0000 0000 0000 00F0 0FF0 00F0 0000"
	$"0000 0000 00FF FFFF 000F 0F00 0F00 0000"
	$"0000 0000 FF00 0000 FF00 FF00 F000 0000"
	$"0000 000F 0000 0000 00F0 00FF 00F0 0F00"
	$"0000 000F 0000 0000 000F 00F0 0F00 F000"
	$"0000 00F0 0000 0000 000F 00F0 0F00 F000"
	$"0000 00F0 0000 FFF0 0000 F0F0 0F00 F000"
	$"0000 00F0 000F 000F 0000 F000 FFFF F000"
	$"0000 00F0 000F 0000 F000 F00F 0000 0F00"
	$"0000 00F0 0000 F000 F000 FFF0 000F 00F0"
	$"0000 00F0 0000 0000 F000 0000 0F00 00F0"
	$"000F FF0F 0000 0000 F000 0000 00FF FFF0"
	$"00F0 0000 F000 000F 0000 0000 0000 00F0"
	$"0FFF FFFF 0FFF FFF0 FFFF FFFF FFFF FF"
};

resource 'icl4' (129) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 00FF FFFF 0000 0000 0000 0000"
	$"0000 0000 FF00 0000 FF00 0000 0000 0000"
	$"0000 000F 0000 0000 00F0 0000 00F0 0F00"
	$"0000 000F 0000 0000 000F 0000 0F00 F000"
	$"0000 00F0 0000 0000 000F 0000 0F00 F000"
	$"0000 00F0 0000 FFF0 0000 F000 0F00 F000"
	$"0000 00F0 000F 000F 0000 F000 FFFF F000"
	$"0000 00F0 000F 0000 F000 F00F 0000 0F00"
	$"0000 00F0 0000 F000 F000 FFF0 000F 00F0"
	$"0000 00F0 0000 0000 F000 0000 0F00 00F0"
	$"000F FF0F 0000 0000 F000 0000 00FF FFF0"
	$"00F0 0000 F000 000F 0000 0000 0000 00F0"
	$"0FFF FFFF 0FFF FFF0 FFFF FFFF FFFF FF"
};

resource 'icl8' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FFFF FFFF FFFF FFFF 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FFFF FFFF FFFF FFFF 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FFFF FFFF FFFF FFFF 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FF00 0000 0000 FF00 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 00FF 0000 0000 0000 FF00 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 FF00 0000 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 00FF 0000 0000 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 FF00 0000 FF00 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF 0000 0000 FF00 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF 0000 0000 FF00 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF 0000 0000 FF00 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF 0000 00FF FF00 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF 0000 FF00 FFFF 0000 00FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF 0000 FF00 FFFF 0000 FF00 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 FF00 00FF FF00 0000 FF00 0000 0000"
	$"0000 0000 0000 0000 0000 FFFF FFFF FFFF"
	$"0000 00FF 00FF 0000 00FF 0000 0000 0000"
	$"0000 0000 0000 0000 FFFF 0000 0000 0000"
	$"FFFF 0000 FFFF 0000 FF00 0000 0000 0000"
	$"0000 0000 0000 00FF 0000 0000 0000 0000"
	$"0000 FF00 0000 FFFF 0000 FF00 00FF 0000"
	$"0000 0000 0000 00FF 0000 0000 0000 0000"
	$"0000 00FF 0000 FF00 00FF 0000 FF00 0000"
	$"0000 0000 0000 FF00 0000 0000 0000 0000"
	$"0000 00FF 0000 FF00 00FF 0000 FF00 0000"
	$"0000 0000 0000 FF00 0000 0000 FFFF FF00"
	$"0000 0000 FF00 FF00 00FF 0000 FF00 0000"
	$"0000 0000 0000 FF00 0000 00FF 0000 00FF"
	$"0000 0000 FF00 0000 FFFF FFFF FF00 0000"
	$"0000 0000 0000 FF00 0000 00FF 0000 0000"
	$"FF00 0000 FF00 00FF 0000 0000 00FF 0000"
	$"0000 0000 0000 FF00 0000 0000 FF00 0000"
	$"FF00 0000 FFFF FF00 0000 00FF 0000 FF00"
	$"0000 0000 0000 FF00 0000 0000 0000 0000"
	$"FF00 0000 0000 0000 00FF 0000 0000 FF00"
	$"0000 00FF FFFF 00FF 0000 0000 0000 0000"
	$"FF00 0000 0000 0000 0000 FFFF FFFF FF00"
	$"0000 FF00 0000 0000 FF00 0000 0000 00FF"
	$"0000 0000 0000 0000 0000 0000 0000 FF00"
	$"00FF FFFF FFFF FFFF 00FF FFFF FFFF FF00"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'icl8' (129) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FFFF FFFF FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FFFF 0000 0000 0000"
	$"FFFF 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF 0000 0000 0000 0000"
	$"0000 FF00 0000 0000 0000 FF00 00FF 0000"
	$"0000 0000 0000 00FF 0000 0000 0000 0000"
	$"0000 00FF 0000 0000 00FF 0000 FF00 0000"
	$"0000 0000 0000 FF00 0000 0000 0000 0000"
	$"0000 00FF 0000 0000 00FF 0000 FF00 0000"
	$"0000 0000 0000 FF00 0000 0000 FFFF FF00"
	$"0000 0000 FF00 0000 00FF 0000 FF00 0000"
	$"0000 0000 0000 FF00 0000 00FF 0000 00FF"
	$"0000 0000 FF00 0000 FFFF FFFF FF00 0000"
	$"0000 0000 0000 FF00 0000 00FF 0000 0000"
	$"FF00 0000 FF00 00FF 0000 0000 00FF 0000"
	$"0000 0000 0000 FF00 0000 0000 FF00 0000"
	$"FF00 0000 FFFF FF00 0000 00FF 0000 FF00"
	$"0000 0000 0000 FF00 0000 0000 0000 0000"
	$"FF00 0000 0000 0000 00FF 0000 0000 FF00"
	$"0000 00FF FFFF 00FF 0000 0000 0000 0000"
	$"FF00 0000 0000 0000 0000 FFFF FFFF FF00"
	$"0000 FF00 0000 0000 FF00 0000 0000 00FF"
	$"0000 0000 0000 0000 0000 0000 0000 FF00"
	$"00FF FFFF FFFF FFFF 00FF FFFF FFFF FF00"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ICN#' (128) {
	{	$"0000 0000 0000 0000 0000 0000 0000 03FC"
		$"0000 03FC 0000 03FC 0000 0208 0000 0408"
		$"0000 0810 0000 1010 0000 2210 0000 4210"
		$"0000 4210 0000 4210 0000 4610 0000 4B10"
		$"0000 4B20 0000 2620 003F 1440 00C0 CC80"
		$"0100 2324 0100 1248 0200 1248 020E 0A48"
		$"0211 08F8 0210 8904 0208 8E12 0200 8042"
		$"1D00 803E 2081 0002 7F7E FFFC",
		$"0000 0000 0000 0000 0000 0000 0000 03FC"
		$"0000 03FC 0000 03FC 0000 03F8 0000 07F8"
		$"0000 0FF0 0000 1FF0 0000 3FF0 0000 7FF0"
		$"0000 7FF0 0000 7FF0 0000 7FF0 0000 7FF0"
		$"0000 7FE0 0000 3FE0 003F 1FC0 00FF CF80"
		$"01FF E324 01FF F248 03FF F248 03FF FA48"
		$"03FF F8F8 03FF F9FC 03FF FFFE 03FF FFFE"
		$"1FFF FFFE 3FFF FFFE 7F7E FFFC"
	}
};

resource 'ICN#' (129) {
	{	$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 003F 0000 00C0 C000"
		$"0100 2024 0100 1048 0200 1048 020E 0848"
		$"0211 08F8 0210 8904 0208 8E12 0200 8042"
		$"1D00 803E 2081 0002 7F7E FFFC",
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 003F 0000 00FF C000"
		$"01FF E024 01FF F048 03FF F048 03FF F848"
		$"03FF F8F8 03FF F9FC 03FF FFFE 03FF FFFE"
		$"1FFF FFFE 3FFF FFFE 7F7E FFFC"
	}
};

resource 'ICN#' (rArrowIcon) {
	{	$"0000 0000 0000 0000 0000 0000 0010 0000"
		$"0018 0000 001C 0000 001E 0000 001F 0000"
		$"001F 8000 001F C000 001F E000 001F 0000"
		$"001B 0000 0011 8000 0001 8000 0000 C000"
		$"0000 C0",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rRectIcon) {
	{	$"0000 0000 0000 0000 0000 0000 07FF FFC0"
		$"0400 0040 0400 0040 0400 0040 0400 0040"
		$"0400 0040 0400 0040 0400 0040 0400 0040"
		$"0400 0040 0400 0040 0400 0040 07FF FFC0",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rRRectIcon) {
	{	$"0000 0000 0000 0000 0000 0000 01FF FF00"
		$"0200 0080 0400 0040 0400 0040 0400 0040"
		$"0400 0040 0400 0040 0400 0040 0400 0040"
		$"0400 0040 0400 0040 0200 0080 01FF FF",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rOvalIcon) {
	{	$"0000 0000 0000 0000 0000 0000 001F F000"
		$"0060 0C00 0180 0300 0200 0080 0200 0080"
		$"0400 0040 0400 0040 0400 0040 0200 0080"
		$"0200 0080 0180 0300 0060 0C00 001F F0",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rPieIcon) {
	{	$"0000 0000 0000 0000 003E 0000 00C2 0000"
		$"0302 F800 0402 8600 0402 8180 0802 8040"
		$"0FFE 8040 0000 8020 03FF 8020 0200 0020"
		$"0100 0040 0100 0040 00C0 0180 0030 0600"
		$"000F F8",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rArrowIcon + 50) {
	{	$"8888 8888 2222 2222 8888 8888 2232 2222"
		$"8898 8888 223E 2222 889E 8888 223F 2222"
		$"889F 8888 223F E222 889F E888 223F 2222"
		$"889B 8888 2233 A222 8889 8888 2222 E222"
		$"8888 C888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rRectIcon + 50) {
	{	$"8888 8888 2222 2222 8888 8888 27FF FFE2"
		$"8C88 88C8 2622 2262 8C88 88C8 2622 2262"
		$"8C88 88C8 2622 2262 8C88 88C8 2622 2262"
		$"8C88 88C8 2622 2262 8C88 88C8 27FF FFE2"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rRRectIcon + 50) {
	{	$"8888 8888 2222 2222 8888 8888 23FF FF22"
		$"8A88 8888 2622 2262 8C88 88C8 2622 2262"
		$"8C88 88C8 2622 2262 8C88 88C8 2622 2262"
		$"8C88 88C8 2622 2262 8A88 8888 23FF FF22"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rOvalIcon + 50) {
	{	$"8888 8888 2222 2222 8888 8888 223F F222"
		$"88E8 8C88 23A2 2322 8A88 8888 2222 22A2"
		$"8C88 88C8 2622 2262 8C88 88C8 2222 22A2"
		$"8A88 8888 23A2 2322 88E8 8C88 223F F222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rPieIcon + 50) {
	{	$"8888 8888 2222 2222 88BE 8888 22E2 2222"
		$"8B8A F888 2622 A622 8C8A 8988 2A22 A262"
		$"8FFE 88C8 2222 A222 8BFF 88A8 2222 2222"
		$"8988 88C8 2322 2262 88C8 8988 2232 2622"
		$"888F F888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222"
		$"8888 8888 2222 2222 8888 8888 2222 2222",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rRectIcon + 100) {
	{	$"FFFF FFFF FFFF FFFF FFFF FFFF F800 003F"
		$"FBFF FFBF FBFF FFBF FBFF FFBF FBFF FFBF"
		$"FBFF FFBF FBFF FFBF FBFF FFBF FBFF FFBF"
		$"FBFF FFBF FBFF FFBF FBFF FFBF F800 003F"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rRRectIcon + 100) {
	{	$"FFFF FFFF FFFF FFFF FFFF FFFF FE00 00FF"
		$"FDFF FF7F FBFF FFBF FBFF FFBF FBFF FFBF"
		$"FBFF FFBF FBFF FFBF FBFF FFBF FBFF FFBF"
		$"FBFF FFBF FBFF FFBF FDFF FF7F FE00 00FF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rOvalIcon + 100) {
	{	$"FFFF FFFF FFFF FFFF FFFF FFFF FFE0 0FFF"
		$"FF8F E3FF FE3F F8FF FCFF FE7F FDFF FF7F"
		$"F9FF FF3F FBFF FFBF F9FF FF3F FDFF FF7F"
		$"FCFF FE7F FE3F F8FF FF8F E3FF FFE0 0FFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (rPieIcon + 100) {
	{	$"FFFF FFFF FFFF FFFF FFC1 FFFF FF3D FFFF"
		$"FCFD 07FF FBFD 79FF FBFD 7E7F F7FD 7FBF"
		$"F001 7FBF FFFF 7FDF FC00 7FDF FDFF FFDF"
		$"FEFF FFBF FEFF FFBF FF3F FE7F FFCF F9FF"
		$"FFF0 07FF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ics#' (128) {
	{	$"0000 007C 007C 0078 0028 0048 0048 0070"
		$"0020 0FA0 1045 132A 14AA 10BE 0941 7FFE",
		$"0000 007C 007C 0078 0038 0078 0078 0070"
		$"0020 0FA0 1FC5 1FEE 1FEE 1FFE 0FFF 7FFE"
	}
};

resource 'ics#' (129) {
	{	$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0F80 1045 132A 14AA 10BE 0941 7FFE",
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0F80 1FC5 1FEE 1FEE 1FFE 0FFF 7FFE"
	}
};

resource 'ics4' (128) {
	$"0000 0000 0000 0000 0000 0000 0FFF FF00"
	$"0000 0000 0FFF FF00 0000 0000 0FFF F000"
	$"0000 0000 00F0 F000 0000 0000 0F00 F000"
	$"0000 0000 0F00 F000 0000 0000 0FFF 0000"
	$"0000 0000 00F0 0000 0000 FFFF F0F0 0000"
	$"000F 0000 0F00 0F0F 000F 00FF 00F0 F0F0"
	$"000F 0F00 F0F0 F0F0 000F 0000 F0FF FFF0"
	$"0000 F00F 0F00 000F 0FFF FFFF FFFF FFF0"
};

resource 'ics4' (129) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FFFF F000 0000"
	$"000F 0000 0F00 0F0F 000F 00FF 00F0 F0F0"
	$"000F 0F00 F0F0 F0F0 000F 0000 F0FF FFF0"
	$"0000 F00F 0F00 000F 0FFF FFFF FFFF FFF0"
};

resource 'ics8' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FF FFFF FFFF 0000"
	$"0000 0000 0000 0000 00FF FFFF FFFF 0000"
	$"0000 0000 0000 0000 00FF FFFF FF00 0000"
	$"0000 0000 0000 0000 0000 FF00 FF00 0000"
	$"0000 0000 0000 0000 00FF 0000 FF00 0000"
	$"0000 0000 0000 0000 00FF 0000 FF00 0000"
	$"0000 0000 0000 0000 00FF FFFF 0000 0000"
	$"0000 0000 0000 0000 0000 FF00 0000 0000"
	$"0000 0000 FFFF FFFF FF00 FF00 0000 0000"
	$"0000 00FF 0000 0000 00FF 0000 00FF 00FF"
	$"0000 00FF 0000 FFFF 0000 FF00 FF00 FF00"
	$"0000 00FF 00FF 0000 FF00 FF00 FF00 FF00"
	$"0000 00FF 0000 0000 FF00 FFFF FFFF FF00"
	$"0000 0000 FF00 00FF 00FF 0000 0000 00FF"
	$"00FF FFFF FFFF FFFF FFFF FFFF FFFF FF"
};

resource 'ics8' (129) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 FFFF FFFF FF00 0000 0000 0000"
	$"0000 00FF 0000 0000 00FF 0000 00FF 00FF"
	$"0000 00FF 0000 FFFF 0000 FF00 FF00 FF00"
	$"0000 00FF 00FF 0000 FF00 FF00 FF00 FF00"
	$"0000 00FF 0000 0000 FF00 FFFF FFFF FF00"
	$"0000 0000 FF00 00FF 00FF 0000 0000 00FF"
	$"00FF FFFF FFFF FFFF FFFF FFFF FFFF FF"
};

resource 'SICN' (128) {
	{	$"0000 007C 007C 0078 0028 0048 0048 0070"
		$"0020 0FA0 1045 132A 14AA 10BE 0941 7FFE"
	}
};




/***************************************************************************/



resource 'CURS' (addObjCursor) {
	$"0800 0800 0800 0800 FF80 0800 0800 0800"
	$"08",
	$"0800 0800 0800 0800 FF80 0800 0800 0800"
	$"08",
	{4, 4}
};



/***************************************************************************/
/***************************************************************************/
/***************************************************************************/



resource 'STR#' (mApple) {
	{
/*  1 */	"Displays version and other information about this application."
	};
};


resource 'hmnu' (mApple, "\0x14") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* Menu title */
		HMStringResItem {
			mApple,0,				/* menu item message					*/
			mApple,0,				/* disabled item message				*/
			mApple,0,				/* reserved message						*/
			mApple,0				/* reserved message						*/
		},

		/* About item */
		HMStringResItem {
			mApple,1,				/* menu item message					*/
			mApple,1,				/* disabled item message				*/
			mApple,0,				/* reserved message						*/
			mApple,0				/* reserved message						*/
		}
	};
};

resource 'STR#' (mFile) {
	{
/*  1 */	"Operations related to documents.",
/*  2 */	"Creates a new document.",
/*  3 */	"Opens an existing document.",
/*  4 */	"Closes the current document.",
/*  5 */	"Closes the current document.  To enable this item, "
			"choose New or Open from the File menu.",
/*  6 */	"Saves the current document.",
/*  7 */	"Saves the current document.  This item is enabled when a change has "
			"occured to the current window since it was opened, or since the last save.",
/*  8 */	"Saves the current document under a different name.",
/*  9 */	"Saves the current document under a different name.  To enable this item, "
			"choose New or Open from the File menu.",
/* 10 */	"Duplicates the current document.",
/* 11 */	"Duplicates the current document.  To enable this item, "
			"choose New or Open from the File menu.",
/* 12 */	"Sets up paper size, orientation, and other printing options.",
/* 13 */	"Sets up paper size, orientation, and other printing options.  To enable "
			"this item, choose New or Open from the File menu.",
/* 14 */	"Prints the board position of the current document.",
/* 15 */	"Prints the board position of the current document.  To enable this item, "
			"choose New or Open from the File menu.",
/* 16 */	"Quit from this application."
	}
};

resource 'hmnu' (mFile, "File") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* File */
		HMStringResItem {
			mFile,1,				/* menu title message					*/
			mFile,1,				/* disabled title message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* New */
		HMStringResItem {
			mFile,2,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Open */
		HMStringResItem {
			mFile,3,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Close */
		HMStringResItem {
			mFile,4,				/* menu item message					*/
			mFile,5,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Save */
		HMStringResItem {
			mFile,6,				/* menu item message					*/
			mFile,7,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Save As */
		HMStringResItem {
			mFile,8,				/* menu item message					*/
			mFile,9,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Duplicate */
		HMStringResItem {
			mFile,10,				/* menu item message					*/
			mFile,11,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Page Setup */
		HMStringResItem {
			mFile,12,				/* menu item message					*/
			mFile,13,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Print */
		HMStringResItem {
			mFile,14,				/* menu item message					*/
			mFile,15,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Quit */
		HMStringResItem {
			mFile,16,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		}
	}
};


resource 'STR#' (mEdit) {
	{
/*  1 */	"Editing operations.",
/*  2 */	"Undo last edit.",
/*  3 */	"Undo last edit.  This item is disabled when there is no "
			"window, or there is no edit to undo.",
/*  4 */	"Redo last edit.",
/*  5 */	"Redo last edit.  This item is disabled when there is no "
			"window, or there is no undo to redo.",
/*  6 */	"Cuts the current selection into the clipboard.",
/*  7 */	"Cuts the current selection into the clipboard.  "
			"(There is nothing selected right now.)",
/*  8 */	"Copies the current selection into the clipboard.",
/*  9 */	"Copies the current selection into the clipboard.  "
			"(There is nothing selected right now.)",
/* 10 */	"Pastes the clipboard contents into the document.",
/* 11 */	"Pastes the current selection.  (Can't paste here.)",
/* 12 */	"Clears the current selection.",
/* 13 */	"Clears the current selection.  "
			"(There is nothing selected right now.)"
	}
};

resource 'hmnu' (mEdit, "Edit") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* Edit */
		HMStringResItem {
			mEdit,1,				/* menu title message					*/
			mEdit,1,				/* disabled title message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Undo */
		HMStringResItem {
			mEdit,2,				/* menu item message					*/
			mEdit,3,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Redo */
		HMStringResItem {
			mEdit,4,				/* menu item message					*/
			mEdit,5,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Cut */
		HMStringResItem {
			mEdit,6,				/* menu item message					*/
			mEdit,7,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Copy */
		HMStringResItem {
			mEdit,8,				/* menu item message					*/
			mEdit,9,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Paste */
		HMStringResItem {
			mEdit,10,				/* menu item message					*/
			mEdit,11,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Clear */
		HMStringResItem {
			mEdit,12,				/* menu item message					*/
			mEdit,13,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		}

	}
};




/***************************************************************************/
/***************************************************************************/
/***************************************************************************/




