#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif

#ifndef __APPLETALK__
#include <AppleTalk.h>
#endif

#ifndef __LISTS__
#include <Lists.h>
#endif

#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __PPCTOOLBOX__
#include <PPCToolbox.h>
#endif

#ifndef __STANDARDFILE__
#include <StandardFile.h>
#endif


/************** AEConnect.c **************/

void			InitConnectAppleEvents(void);
OSErr			SendConnect(FileRecHndl frHndl, char *theLocNBPType);
WindowPtr		GetAEWindow(long windID_0, long windID_1);



/************** AERequired.c **************/

OSErr			InitRequiredAppleEvents(void);



/************** AEUtils.c **************/

#ifndef         __AEUTILS__
#include		"AEUtils.h"
#endif



/************** ATUtils.c **************/

#ifndef         __ATUTILS__
#include		"ATUtils.h"
#endif



/************** CtlHandler.c **************/

#ifndef         __CTLHANDLER__
#include		"CtlHandler.h"
#endif



/************** DoEvent.c **************/

void			DoEvent(EventRecord *event);
void			DoCursor(void);
void			DoActivate(WindowPtr window);



/************** File.c **************/

OSErr			DefaultInitDocument(FileRecHndl frHndl, short version,
									short numUndos, short numSaveUndos);
OSErr			DisposeDocument(FileRecHndl frHndl);
OSErr			NewDocument(FileRecHndl *returnHndl, OSType sftype, Boolean incTitleNum);
OSErr			OpenDocument(FileRecHndl *result, FSSpecPtr fileToOpen, char permission);
OSErr			SaveDocument(FileRecHndl frHndl, WindowPtr window, short saveMode);
void			ConvertOldToNewSFReply(SFReply *oldReply, StandardFileReply *newReply);
Boolean			DisplayGetFile(StandardFileReply *reply, short typeListLen, SFTypeList typeList);
Boolean			DisplayPutFile(StandardFileReply *reply);
OSErr			UseDocResFile(FileRecHndl frHndl, short *oldRes, char perm);
OSErr			CloseDocResFile(FileRecHndl frHndl);
long			GetModNum(void);
Boolean			GetDocDirty(FileRecHndl frHndl);
Boolean			GetWindowDirty(WindowPtr window);
void			SetDocDirty(FileRecHndl frHndl);
void			SetWindowDirty(WindowPtr window);
OSErr			SetDefault(short newVRefNum, long newDirID, short *oldVRefNum, long *oldDirID);
OSErr			RestoreDefault(short oldVRefNum, long oldDirID);



/************** File2.c **************/

OSErr			InitDocument(FileRecHndl frHndl);
long			InitDocumentSize(OSType sftype);



/************** Init.c **************/

void			Initialize(short moreMasters, long minHeap, long minSpace,
						   ProcPtr init1, ProcPtr init2);
void			StartDocuments(void);



/************** GWLayers.c **************/

#ifndef         __GWLAYERS__
#include		"GWLayers.h"
#endif



/************** ListControl.c **************/

#ifndef         __LISTCONTROL__
#include		"ListControl.h"
#endif



/************** Menu.c **************/

void			DoAdjustMenus(void);
void			DoMenuCommand(long menuResult);



/************** PPC.c **************/

#ifndef         __PPC__
#include		"PPC.h"
#endif



/************** Print.c **************/

OSErr			PrintDocument(FileRecHndl frHndl, Boolean jobDlg, Boolean firstJob);
void			DonePrinting(void);
OSErr			PresentStyleDialog(FileRecHndl frHndl);



/************** TextEditControl.c **************/

#ifndef         __TEXTEDITCONTROL__
#include		"TextEditControl.h"
#endif



/************** TreeObj.c **************/

#ifndef         __TREEOBJ__
#include		"TreeObj.h"
#endif



/************** ViewHierarchy.c **************/

OSErr			VHInitDocument(FileRecHndl frHndl);
long			VHFileTypeSize(void);
void			VHRootInfo(TreeObjHndl root, char *cptr);
void			VHFileRecInfo(TreeObjHndl root, char *cptr);



/************** Window.c **************/

OSErr			DoNewWindow(FileRecHndl frHndl, WindowPtr *retWindow,
							WindowPtr relatedWindow, WindowPtr behind);
void			NewWindowTitle(WindowPtr window, StringPtr altTitle);
Boolean			DisposeAllWindows(void);
Boolean			DisposeOneWindow(WindowPtr window, short saveMode);
WindowPtr		SetFilePort(FileRecHndl frHndl);
void			DoResizeWindow(WindowPtr window, short oldh, short oldv);
void			DoUpdateSeparate(WindowPtr window, RgnHandle *contRgn, RgnHandle *frameRgn);
void			BeginContent(WindowPtr window);
void			EndContent(WindowPtr window);
void			AdjustScrollBars(WindowPtr window);
void			GetContentOrigin(WindowPtr window, Point *contOrg);
void			SetContentOrigin(WindowPtr window, long newh, long newv);
void			GetContentRect(WindowPtr window, Rect *contRct);
void			SetDocSize(FileRecHndl frHndl, long hSize, long vSize);
void			SetSidebarSize(FileRecHndl frHndl, short newLeft, short newTop);
void			SetScrollIndentSize(FileRecHndl frHndl, short newh, short newv);
FileRecHndl		GetNextDocument(WindowPtr window, OSType sftype);
WindowPtr		GetNextWindow(WindowPtr window, OSType sftype);
WindowPtr		GetPreviousWindow(WindowPtr window);
void			DoZoomWindow(WindowPtr window, EventRecord *event, short zoomDir);
RgnHandle		DoCalcFrameRgn(WindowPtr window);
RgnHandle		DoCalcScrollRgn(WindowPtr window);
void			DoContentClick(WindowPtr window, EventRecord *event, Boolean firstClick);
void			DoDragWindow(WindowPtr window, EventRecord *event, Rect bounds);
void			DoDrawFrame(WindowPtr window);
OSErr			DoFreeDocument(FileRecHndl frHndl);
OSErr			DoFreeWindow(FileRecHndl frHndl, WindowPtr window);
OSErr			DoImageDocument(FileRecHndl frHndl);
OSErr			DoInitContent(FileRecHndl frHndl, WindowPtr window);
Boolean			DoKeyDown(EventRecord *event);
void			DoMouseDown(EventRecord *event);
OSErr			DefaultFreeDocument(FileRecHndl frHndl);
OSErr			DoReadDocument(FileRecHndl frHndl);
OSErr			DoReadDocumentHeader(FileRecHndl frHndl);
OSErr			DefaultReadDocument(FileRecHndl frHndl);
OSErr			DefaultReadDocumentHeader(FileRecHndl frHndl);
OSErr			DefaultReadDocumentFixup(FileRecHndl frHndl);
OSErr			DoWriteDocument(FileRecHndl frHndl);
OSErr			DoWriteDocumentHeader(FileRecHndl frHndl);
OSErr			DefaultWriteDocument(FileRecHndl frHndl);
OSErr			DefaultWriteDocumentHeader(FileRecHndl frHndl);
void			DoResizeContent(WindowPtr window, short oldh, short oldv);
void			DoScrollFrame(WindowPtr window, long dh, long dv);
void			DoUndoFixup(FileRecHndl frHndl, Point contOrg, Boolean afterUndo);
WindowPtr		GetOldLocWindow(short id, Ptr storage, Boolean vis, WindowPtr relWindow,
								WindowPtr behind, Boolean inColor, Rect sizeInfo, long refCon);
void			CleanSendBehind(WindowPtr window, WindowPtr afterWindow);
void			CleanSendInFront(WindowPtr window, WindowPtr beforeWindow);
void			HiliteWindows(void);
void			UnhiliteWindows(void);
void			DoUpdate(WindowPtr window);
void			DoSetCursor(Cursor *cursor);
CursPtr			DoSetResCursor(short crsrID);
void			DoWindowCursor(void);
WindowPtr		FrontWindowOfType(short wkind);
short			HCenteredAlert(short alertID, WindowPtr relatedWindow, ModalFilterProcPtr filter);



/************** Window2.c **************/

void			CalcFrameRgn(FileRecHndl frHndl, WindowPtr window, RgnHandle rgn);
void			ContentClick(WindowPtr window, EventRecord *event, Boolean firstCLick);
Boolean			ContentKey(WindowPtr window, EventRecord *event, Boolean *passThrough);
void			DrawFrame(FileRecHndl frHndl, WindowPtr window);
OSErr			FreeDocument(FileRecHndl frHndl);
OSErr			FreeWindow(FileRecHndl frHndl, WindowPtr window);
OSErr			ImageDocument(FileRecHndl frHndl);
OSErr			InitContent(FileRecHndl frHndl, WindowPtr window);
OSErr			ReadDocument(FileRecHndl frHndl);
void			ResizeContent(WindowPtr window, short oldh, short oldv);
void			ScrollFrame(FileRecHndl frHndl, WindowPtr window, long dh, long dv);
void			UndoFixup(FileRecHndl frHndl, Point contOrg, Boolean afterUndo);
Boolean			WindowCursor(FileRecHndl frHndl, WindowPtr window, Point globalPt);
void			WindowGoneFixup(WindowPtr window);
OSErr			WriteDocument(FileRecHndl frHndl);



