#ifndef __LISTCONTROL__
#define __LISTCONTROL__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __LISTS__
#include <Lists.h>
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

typedef struct CLDataRec {
	short	txFont;
	Style	txFace;
	short	txMode;
	short	txSize;
	short	mode;
} CLDataRec;
typedef CLDataRec *CLDataPtr, **CLDataHndl;

void			CLInitialize(void);

void			CLActivate(Boolean active, ListHandle listHndl);
Boolean			CLClick(WindowPtr window, EventRecord *event, short *action);
ControlHandle	CLCtlHit(void);
Boolean			CLEvent(WindowPtr window, EventRecord *event, short *action);
ListHandle		CLFindActive(WindowPtr window);
Boolean			CLFindCtl(WindowPtr window, EventRecord *event, ListHandle *listHndl, ControlHandle *ctlHit);
ListHandle		CLFromScroll(ControlHandle scrollCtl, ControlHandle *retCtl);
short			CLInsert(ListHandle listHndl, char *data, short dataLen, short row, short col);
Boolean			CLKey(WindowPtr window, EventRecord *event);
ListHandle		CLNew(short viewID, Rect *vRect, short numRows, short numCols, short cellHeight, short cellWidth, short theLProc, WindowPtr window, short mode);
ControlHandle	CLNext(WindowPtr window, ListHandle *listHndl, ControlHandle ctl);
void			CLPrint(RgnHandle clipRgn, ListHandle listHndl, short *row, short *col, short leftEdge, Rect *drawRct);
short			CLRowOrColSearch(ListHandle listHndl, char *data, short dataLen, short row, short col);
void			CLUpdate(RgnHandle clipRgn, ListHandle list);
ControlHandle	CLViewFromList(ListHandle listHndl);
void			CLWindActivate(WindowPtr window);

typedef void			(*CLActivateProcPtr)(Boolean active, ListHandle listHndl);
typedef Boolean			(*CLClickProcPtr)(WindowPtr window, EventRecord *event, short *action);
typedef ControlHandle	(*CLCtlHitProcPtr)(void);
typedef Boolean			(*CLEventProcPtr)(WindowPtr window, EventRecord *event, short *action);
typedef ListHandle		(*CLFindActiveProcPtr)(WindowPtr window);
typedef Boolean			(*CLFindCtlProcPtr)(WindowPtr window, EventRecord *event, ListHandle *listHndl, ControlHandle *ctlHit);
typedef ListHandle		(*CLFromScrollProcPtr)(ControlHandle scrollCtl, ControlHandle *retCtl);
typedef short			(*CLInsertProcPtr)(ListHandle listHndl, char *data, short dataLen, short row, short col);
typedef Boolean			(*CLKeyProcPtr)(WindowPtr window, EventRecord *event);
typedef ListHandle		(*CLNewProcPtr)(short viewID, Rect *vRect, short numRows, short numCols, short cellHeight, short cellWidth, short theLProc, WindowPtr window, short mode);
typedef ControlHandle	(*CLNextProcPtr)(WindowPtr window, ListHandle *listHndl, ControlHandle ctl);
typedef void			(*CLPrintProcPtr)(RgnHandle clipRgn, ListHandle listHndl, short *row, short *col, short leftEdge, Rect *drawRct);
typedef short			(*CLRowOrColSearchProcPtr)(ListHandle listHndl, char *data, short dataLen, short row, short col);
typedef void			(*CLUpdateProcPtr)(RgnHandle clipRgn, ListHandle list);
typedef ControlHandle	(*CLViewFromListProcPtr)(ListHandle listHndl);
typedef void			(*CLWindActivateProcPtr)(WindowPtr window);

#define clHScroll		2
#define clVScroll		8
#define clActive		32
#define clShowActive	64
#define clKeyPos		128
#define clTwoStep		256
#define clDrawIt		0x8000

#endif __LISTCONTROL__

