#ifndef __TEXTEDITCONTROL__
#define __TEXTEDITCONTROL__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __TEXTEDIT__
#include <TextEdit.h>
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

typedef Boolean	(*CTEKeyFilterProcPtr)(TEHandle teHndl, EventRecord *event, Boolean *handled);

typedef struct CTEDataRec {
	short				maxTextLen;
	Boolean				newUndo;
	short				undoSelStart;
	short				undoSelEnd;
	Handle				undoText;
	short				mode;
	Rect				brdrRect;
	CTEKeyFilterProcPtr	keyFilter;
} CTEDataRec;
typedef CTEDataRec *CTEDataPtr, **CTEDataHndl;

void			CTEInitialize(void);

pascal void		ASMNOCARET(Rect *caretRect);
pascal Boolean	ASMTECLIKLOOP(void);
void			CTEActivate(Boolean active, TEHandle teHndl);
Boolean			CTEClick(WindowPtr window, EventRecord *event, short *action);
void			CTEClikLoop(void);
void			CTEClipboard(short menuID);
void			CTEConvertClipboard(Boolean convertClipboard, Boolean becomingActive);
pascal long		CTECtl(short varCode, ControlHandle ctl, short msg, long parm);
ControlHandle	CTECtlHit(void);
void			CTEDispose(TEHandle teHndl);
TEHandle		CTEDisposeView(ControlHandle viewCtl);
short			CTEDocHeight(TEHandle teHndl);
Boolean			CTEEditMenu(Boolean *activeItem, short editMenu, short undoID, short cutID);
Boolean			CTEEvent(WindowPtr window, EventRecord *event, short *action);
void			CTEFakeClick(short newStart, short newEnd, Boolean extend, TEHandle teHndl);
TEHandle		CTEFindActive(WindowPtr window);
Boolean			CTEFindCtl(WindowPtr window, EventRecord *event, TEHandle *teHndl,
						   ControlHandle *ctlHit);
TEHandle		CTEFromScroll(ControlHandle scrollCtl, ControlHandle *retCtl);
void			CTEHide(TEHandle teHndl);
void			CTEIdle(void);
short			CTEKey(WindowPtr window, EventRecord *event);
void			CTEMove(TEHandle teHndl, short newH, short newV);
OSErr			CTENew(short viewID, WindowPtr window, TEHandle *teHndl, Rect *cRect,
					   Rect *dRect, Rect *vRect, Rect *bRect, short maxTextLen, short mode);
void			CTENewUndo(ControlHandle viewCtl, Boolean alwaysNewUndo);
ControlHandle	CTENext(WindowPtr window, TEHandle *teHndl, ControlHandle ctl);
short			CTENumTextLines(TEHandle teHndl);
short			CTENumViewLines(TEHandle teHndl);
OSErr			CTEPrint(TEHandle teHndl, short *offset, Rect *rct);
Boolean			CTEReadOnly(TEHandle teHndl);
ControlHandle	CTEScrollFromTE(TEHandle teHndl, Boolean vertScroll);
ControlHandle	CTEScrollFromView(ControlHandle viewCtl, Boolean vertScroll);
void			CTESetKeyFilter(TEHandle teHndl, CTEKeyFilterProcPtr proc);
void			CTESetSelect(short start, short end, TEHandle teHndl);
void			CTEShow(TEHandle teHndl);
void			CTESize(TEHandle teHndl, short dx, short dy, Boolean newDest);
Handle			CTESwapText(TEHandle teHndl, Handle newText, Boolean update);
WindowPtr		CTETargetInfo(TEHandle *teHndl, Rect *teView);
void			CTEUndo(void);
void			CTEUpdate(TEHandle teHndl, ControlHandle ctl, Boolean justShowActive);
ControlHandle	CTEViewFromTE(TEHandle teHndl);
Boolean			CTEWindActivate(WindowPtr window);
void			CTEAdjustTEBottom(TEHandle teHndl);
void			CTEAdjustScrollValues(TEHandle teHndl);

typedef void			(*CTEActivateProcPtr)(Boolean active, TEHandle teHndl);
typedef Boolean			(*CTEClickProcPtr)(WindowPtr window, EventRecord *event, short *action);
typedef void			(*CTEClikLoopProcPtr)(void);
typedef void			(*CTEClipboardProcPtr)(short menuID);
typedef void			(*CTEConvertClipboardProcPtr)(Boolean convertClipboard, Boolean becomingActive);
typedef pascal long		(*CTECtlProcPtr)(short varCode, ControlHandle ctl, short msg, long parm);
typedef ControlHandle	(*CTECtlHitProcPtr)(void);
typedef void			(*CTEDisposeProcPtr)(TEHandle teHndl);
typedef TEHandle		(*CTEDisposeViewProcPtr)(ControlHandle viewCtl);
typedef short			(*CTEDocHeightProcPtr)(TEHandle teHndl);
typedef Boolean			(*CTEEditMenuProcPtr)(Boolean *activeItem, short editMenu, short undoID, short cutID);
typedef Boolean			(*CTEEventProcPtr)(WindowPtr window, EventRecord *event, short *action);
typedef void			(*CTEFakeClickProcPtr)(short newStart, short newEnd, Boolean extend, TEHandle teHndl);
typedef TEHandle		(*CTEFindActiveProcPtr)(WindowPtr window);
typedef Boolean			(*CTEFindCtlProcPtr)(WindowPtr window, EventRecord *event, TEHandle *teHndl, ControlHandle *ctlHit);
typedef TEHandle		(*CTEFromScrollProcPtr)(ControlHandle scrollCtl, ControlHandle *retCtl);
typedef void			(*CTEHideProcPtr)(TEHandle teHndl);
typedef void			(*CTEIdleProcPtr)(void);
typedef short			(*CTEKeyProcPtr)(WindowPtr window, EventRecord *event);
typedef void			(*CTEMoveProcPtr)(TEHandle teHndl, short newH, short newV);
typedef OSErr			(*CTENewProcPtr)(short viewID, WindowPtr window, TEHandle *teHndl, Rect *cRect, Rect *dRect, Rect *vRect, Rect *bRect, short maxTextLen, short mode);
typedef void			(*CTENewUndoProcPtr)(ControlHandle viewCtl, Boolean alwaysNewUndo);
typedef ControlHandle	(*CTENextProcPtr)(WindowPtr window, TEHandle *teHndl, ControlHandle ctl);
typedef short			(*CTENumTextLinesProcPtr)(TEHandle teHndl);
typedef short			(*CTENumViewLinesProcPtr)(TEHandle teHndl);
typedef OSErr			(*CTEPrintProcPtr)(TEHandle teHndl, short *offset, Rect *rct);
typedef Boolean			(*CTEReadOnlyProcPtr)(TEHandle teHndl);
typedef ControlHandle	(*CTEScrollFromTEProcPtr)(TEHandle teHndl, Boolean vertScroll);
typedef ControlHandle	(*CTEScrollFromViewProcPtr)(ControlHandle viewCtl, Boolean vertScroll);
typedef void			(*CTESetKeyFilterProcPtr)(TEHandle teHndl, CTEKeyFilterProcPtr proc);
typedef void			(*CTESetSelectProcPtr)(short start, short end, TEHandle teHndl);
typedef void			(*CTEShowProcPtr)(TEHandle teHndl);
typedef void			(*CTESizeProcPtr)(TEHandle teHndl, short dx, short dy, Boolean newDest);
typedef Handle			(*CTESwapTextProcPtr)(TEHandle teHndl, Handle newText, Boolean update);
typedef WindowPtr		(*CTETargetInfoProcPtr)(TEHandle *teHndl, Rect *teView);
typedef void			(*CTEUndoProcPtr)(void);
typedef void			(*CTEUpdateProcPtr)(TEHandle teHndl, ControlHandle ctl, Boolean justShowActive);
typedef ControlHandle	(*CTEViewFromTEProcPtr)(TEHandle teHndl);
typedef Boolean			(*CTEWindActivateProcPtr)(WindowPtr window);
typedef void			(*CTEAdjustTEBottomProcPtr)(TEHandle teHndl);
typedef void			(*CTEAdjustScrollValuesProcPtr)(TEHandle teHndl);

#define cteReadOnly			1
#define cteHScroll			2
#define cteHScrollLessGrow	6
#define cteVScroll			8
#define cteVScrollLessGrow	24
#define cteActive			32
#define cteNoBorder			64
#define cteShowActive		128
#define cteTabSelectAll		256
#define cteTwoStep			512
#define cteScrollFullLines	1024

#endif __TEXTEDITCONTROL__
