/*
** Apple Macintosh Developer Technical Support
**
** Program:     DTS.Lib
** File:        TUndoObj.c
** Written by:  Eric Soldan
**
** Copyright  1992 Apple Computer, Inc.
** All rights reserved.
*/



#ifndef __OSEVENTS__
#include <OSEvents.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef __STRING__
#include <String.h>
#endif

#ifndef __TREEOBJ__
#include "TreeObj.h"
#endif

#ifndef __UTILITIES__
#include "Utilities.h"
#endif



#pragma segment File
long	TUndoObj(TreeObjHndl hndl, short message, long data)
{
	char	*cptr;

	switch (message) {
		case VHMESSAGE:
			cptr = ((VHFormatDataPtr)data)->data;
			ccatchr(cptr, 13, 2);
			ccat   (cptr, "$10: TUndoObj:");
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $00: root         = $");
			ccathex(cptr, '0', 8, 8, (long)mDerefUndo(hndl)->root);
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $04: frHndl       = $");
			ccathex(cptr, '0', 8, 8, (long)mDerefUndo(hndl)->frHndl);
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $08: disabled     = ");
			ccatdec(cptr, mDerefUndo(hndl)->disabled);
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $0A: lastEditType = ");
			ccatdec(cptr, mDerefUndo(hndl)->lastEditType);
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $0C: undoDepth    = ");
			ccatdec(cptr, mDerefUndo(hndl)->undoDepth);
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $0E: maxNumUndos  = ");
			ccatdec(cptr, mDerefUndo(hndl)->maxNumUndos);
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $10: numSaveUndos = ");
			ccatdec(cptr, mDerefUndo(hndl)->numSaveUndos);
			return(true);
			break;

		default:
			break;
	}

	return(noErr);
}



