/*
** Apple Macintosh Developer Technical Support
**
** Program:     DTS.Lib
** File:        TUndoTaskObj.c
** Written by:  Eric Soldan
**
** Copyright  1992 Apple Computer, Inc.
** All rights reserved.
*/



#ifndef __OSEVENTS__
#include <OSEvents.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef __STRING__
#include <String.h>
#endif

#ifndef __TREEOBJ__
#include "TreeObj.h"
#endif

#ifndef __UTILITIES__
#include "Utilities.h"
#endif



#pragma segment File
long	TUndoTaskObj(TreeObjHndl hndl, short message, long data)
{
	short	fileRefNum;
	char	*cptr;
	Point	pt;

	switch (message) {
		case FREADMESSAGE:
			fileRefNum = data;
			return(ReadTreeObjData(hndl, fileRefNum));
			break;

		case FWRITEMESSAGE:
			fileRefNum = data;
			return(WriteTreeObjData(hndl, fileRefNum));
			break;

		case VHMESSAGE:
			cptr = ((VHFormatDataPtr)data)->data;
			ccatchr(cptr, 13, 2);
			ccat   (cptr, "$10: TUndoTaskObj:");
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $00: editType   = ");
			ccatdec(cptr, mDerefUndoTask(hndl)->editType);
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $02: undoOrigin = (");
			pt = mDerefUndoTask(hndl)->undoOrigin;
			ccatdec(cptr, pt.v);
			ccat   (cptr, ",");
			ccatdec(cptr, pt.h);
			ccat   (cptr, ")");
			ccatchr(cptr, 13, 1);
			ccat   (cptr, "  $06: redoOrigin = (");
			pt = mDerefUndoTask(hndl)->redoOrigin;
			ccatdec(cptr, pt.v);
			ccat   (cptr, ",");
			ccatdec(cptr, pt.h);
			ccat   (cptr, ")");
			return(true);
			break;

		default:
			break;
	}

	return(noErr);
}



