/*------------------------------------------------------------------------------
#
#	Apple Macintosh Developer Technical Support
#
#	Kibitz
#
#	Kibitz.r	-	Rez Source
#
#	Copyright  1989-1992 Apple Computer, Inc.
#	All rights reserved.
#
#	Version:  3.0b1
#
------------------------------------------------------------------------------*/


#include "Types.r"
#include "SysTypes.r"
#include "BalloonTypes.r"
#include "KibitzCommon.h"
#include "UtilitiesCommon.h"


include "::DTS.Lib:teCDEF" 'CDEF' ("teCDEF") as 
		'CDEF' (rTECtl, "teCDEF");

include "view.cdef" 'CDEF' ("ViewCtl") as 
		'CDEF' (rSliderCtl, "SliderCtl");



resource 'STR ' (-16396) {
	"Kibitz"
};
type 'KBTZ' as 'STR ';			/* Put all 'STR ' resources before this!! */
resource 'KBTZ' (0) {
	"Kibitz - Version 3.0b1 - System 7.0 or later"
};
resource 'vers' (1, purgeable) {
	0x02,
	0x00,
	beta,
	0x01,
	verUs,
	"3.0b1",
	"Kibitz - Version 3.0b1 - System 7.0 or later"
};




/* we use an MBAR resource to conveniently load all the menus */

resource 'MBAR' (rMenuBar, preload) {
	{ mApple, mFile, mEdit, mGame };
};




resource 'MENU' (mApple, preload) {
	mApple, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable dashed line, enable About and DAs */
	enabled, apple,
	{
		"About Kibitz 3.0",	noicon, nokey, nomark, plain;
		"-",					noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mFile, preload) {
	mFile, textMenuProc,
	AllItems,
	enabled, "File",
	{
		"New",					noicon, "N", nomark, plain;
		"Open",				noicon, "O", nomark, plain;
		"New Message",			noicon, nokey, nomark, plain;
		"-",					noicon, nokey, nomark, plain;
		"Close",				noicon, "W", nomark, plain;
		"Save",					noicon, "S", nomark, plain;
		"Save As",				noicon, nokey, nomark, plain;
		"Save Board Image",	noicon, nokey, nomark, plain;
		"Duplicate",			noicon, "D", nomark, plain;
		"Revert",				noicon, "R", nomark, plain;
		"-",					noicon, nokey, nomark, plain;
		"Page Setup",			noicon, nokey, nomark, plain;
		"Print",				noicon, "P", nomark, plain;
		"-",					noicon, nokey, nomark, plain;
		"Quit",					noicon, "Q", nomark, plain
	}
};

resource 'MENU' (mEdit, preload) {
	mEdit, textMenuProc,
	AllItems,
	enabled, "Edit",
	 {
		"Undo",			noicon, "Z", nomark, plain;
		"-",			noicon, nokey, nomark, plain;
		"Cut",			noicon, "X", nomark, plain;
		"Copy",			noicon, "C", nomark, plain;
		"Paste",		noicon, "V", nomark, plain;
		"Clear",		noicon, nokey, nomark, plain;
		"-",			noicon, nokey, nomark, plain;
		"Select All",	noicon, "A", nomark, plain;
	}
};

resource 'MENU' (mGame, preload) {
	mGame, textMenuProc,
	AllItems,
	enabled, "Game",
	 {
		"Configure Game",			noicon, "G", nomark, plain;
		"Invert Board",				noicon, "I", nomark, plain;
		"-",						noicon, nokey, nomark, plain;
		"Arrange Board",			noicon, nokey, nomark, plain;
		"1-Player Game",			noicon, "1", nomark, plain;
		"2-Player Game",			noicon, "2", nomark, plain;
		"-",						noicon, nokey, nomark, plain;
		"Find 2-Player Game",		noicon, "F", nomark, plain;
		"-",						noicon, nokey, nomark, plain;
		"Go To Move",				noicon, "M", nomark, plain;
		"List Moves to Out-Box",	noicon, nokey, nomark, plain;
		"Make Moves from Out-Box",	noicon, nokey, nomark, plain;
	}
};





/* this ALRT and DITL are used as an About screen */

resource 'ALRT' (rAboutAlert, purgeable) {
	{40, 20, 242, 358},
	rAboutAlert,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};
resource 'DITL' (rAboutAlert, purgeable) {
	{
		{167, 243, 187, 323},	Button { enabled, "OK" },
		{8, 8, 29, 328},		StaticText { disabled, "Kibitz 3.0b1 -- System 7.0 or later" },
		{40, 8, 56, 328},		StaticText { disabled, "Copyright  1989-1992 Apple Computer" },
		{71, 8, 140, 328},		StaticText { disabled,
			"Written by:  Eric Soldan\nAny problems or "
			"suggestions, let me know.\n\n"
			"    (AppleLink: SOLDAN)"
		},
		{154, 8, 188, 222},		StaticText { disabled,
			"Thanks to Suzy Heithcock for the color "
			"versions of the icons."
		}
	}
};




resource 'DLOG' (rYesNoCancel, purgeable) {
	{40, 20, 144, 400},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	rYesNoCancel,
	""
};
resource 'DITL' (rYesNoCancel, purgeable) {
	{
		{71, 315, 91, 367},		Button { enabled, "Save" },
		{0, -1000, 20, 2},		StaticText { disabled,  "=S190001,=s190001,=D190003,=d190003,=.190104,1B190004" },
		{71, 80, 91, 162},		Button { enabled, "Dont Save" },
		{71, 244, 91, 302},		Button { enabled, "Cancel" },
		{11, 78, 61, 366},		StaticText { disabled, "Save changes to the Kibitz document ^0 before ^1?" },
		{11, 23, 43, 55},		Icon { disabled, 2 }
	}
};




resource 'DLOG' (rNoYesCancel, purgeable) {
	{40, 20, 144, 400},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	rNoYesCancel,
	""
};
resource 'DITL' (rNoYesCancel, purgeable) {
	{
		{71, 307, 91, 367},		Button { enabled, "No Way" },
		{0, -1000, 20, 2},		StaticText { disabled, "=N190001,=n190001,=S190003,=s190003,=.190104,1B190004" },
		{71, 80, 91, 130},		Button { enabled, "Save" },
		{71, 236, 91, 294},		Button { enabled, "Cancel" },
		{11, 78, 61, 366},		StaticText { disabled, "Save changes to the Kibitz document ^0 before ^1?" },
		{11, 23, 43, 55},		Icon { disabled, 2 }
	}
};






resource 'DLOG' (rOpenReadOnly, purgeable) {
	{40, 20, 144, 355},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	rOpenReadOnly,
	""
};
resource 'DITL' (rOpenReadOnly, purgeable) {
	{
		{71, 261, 91, 322},		Button { enabled, "Open" },
		{0, -1000, 20, 2},		StaticText { disabled, "=.190103,1B190003" },
		{71, 174, 91, 248},		Button { enabled, "Cancel" },
		{11, 78, 61, 320},		StaticText { disabled, "Open the Kibitz document ^0 as read-only?" },
		{11, 23, 43, 55},		Icon { disabled, 2 }
	}
};






/* this ALRT and DITL are used as an error screen */

resource 'ALRT' (rErrorAlert, purgeable) {
	{40, 20, 120, 260},
	rErrorAlert,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};
resource 'DITL' (rErrorAlert, purgeable) {
	{
		{50, 150, 70, 230},	Button { enabled, "OK" },
		{10, 60, 30, 230},	StaticText { disabled, "Kibitz - Error occurred!" },
		{8, 8, 40, 40},		Icon { disabled, 2 }
	}
};





resource 'WIND' (rWindow, preload, purgeable) {
	{rWindowYPos, rWindowXPos, rWindowYPos + rWindowHeight, rWindowXPos + rWindowWidth},
	zoomNoGrow, invisible, goAway, 0x0, "Kibitz"
};
resource 'pltt' (rWindow, preload, purgeable) {
	{
		65535, 65535, 65535, pmTolerant, 0,
		0, 0, 0, pmTolerant, 0,
		13107, 39321, 26214, pmTolerant, 0
	}
};



/* here is the quintessential MultiFinder friendliness device, the SIZE resource */

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* Can properly use background null events	*/
	doesActivateOnFGSwitch,		/* We do our own activate/deactivate; dont fake us out */
	backgroundAndForeground,	/* This is definitely not a background-only application! */
	dontGetFrontClicks,			/* Change this is if you want "do first click" behavior like the Finder */
	ignoreAppDiedEvents,		/* Essentially, Im not a debugger (sub-launching) */
	is32BitCompatible,			/* This app can be run in 32-bit address space */
	isHighLevelEventAware,		/* does Post/AcceptHighLevelEvent */
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	kPrefSize * 2048,
	kMinSize * 2048
};

resource 'STR#' (rMiscStrings, purgeable) {
	{
		"Save File As:",
		"Game #",
		"closing",
		"quitting",
		"Message #",
	}
};

resource 'STR#'(rBadNewsStrings, purgeable) {
	{
	/* [1] */	"This program needs to run on a Macintosh with 128K or better";
	/* [2] */	"Your heap is too small to run this application";
	/* [3] */	"Your heap is too small to run this application";
	/* [4] */	"An error has occured";
	}
};








resource 'FREF' (130) {
	mssgFileType,
	2,
	""
};


resource 'FREF' (129) {
	gameFileType,
	1,
	""
};


resource 'FREF' (128) {
	'APPL',
	0,
	""
};


resource 'BNDL' (128) {
	gameCreator, 0, {
		'ICN#', { 0, 128, 1, 129, 2, 130 },
		'FREF', { 0, 128, 1, 129, 2, 130 }
	}
};




resource 'icl4' (128) {
	$"0000 0000 000F 00F0 0000 0000 0000 0000"
	$"0000 0000 000F F0FF 0000 0000 0000 0000"
	$"0000 0000 000F FFFF F000 0000 0000 0000"
	$"0000 0000 000F CCFC CF00 0000 0000 0000"
	$"0000 0000 000F CCFC CCFF 0000 0000 0000"
	$"0000 0000 00FC CCCC CCCC FF00 0000 0000"
	$"0000 0000 00FC CFFF CCCC FCF0 0000 0000"
	$"0000 0000 0FCC CFFC FCCC CCCF 0000 0000"
	$"0000 0000 0FCC CCCC CCCC CCFC F000 0000"
	$"0000 0000 FCCC CCCC CCCC CCFC CF00 0000"
	$"0000 000F CCCC CCCC CCCC CCFC CF00 0000"
	$"0000 000F CCCC CCCC CCCC CCCC FCF0 0000"
	$"0000 00FC CCCC CFCC CCCC CCCC FCF0 0000"
	$"0000 0FCC CCCC CCFC CCCF CCCC FCCF 0000"
	$"0000 0FCC CCCC CF0F FFFC CCCC FCCF 0000"
	$"0000 0FCF FFCC F000 0FCC CCCC CCFC F000"
	$"0000 00F0 0FCF 0000 FCCC CCCC CCFC F000"
	$"0000 0000 FCF0 000F CCCC CCCC CCFC F000"
	$"0000 0FF0 FF00 00FC CCCC CCCC CCFC CF00"
	$"0000 FF00 0000 00FC CCFF FFFF CCCC FF00"
	$"000F 00FF FFFF FFFF FF00 0000 FCCF CF00"
	$"00F0 0000 0000 0000 F000 0000 0FCC CF00"
	$"00F0 0000 0000 000F 00FF 0000 00FC CCF0"
	$"0F00 F000 F00F 000F FF00 F000 000F CCF0"
	$"0F00 0F0F 00F0 FFF0 0FFF FFFF F000 FFFF"
	$"0F00 00F0 0F00 00F0 00FF 0000 0000 0FFF"
	$"0F00 00F0 0FFF F00F 0000 0000 0000 0FFF"
	$"0F00 00F0 0F00 0000 F000 0000 0000 0FFF"
	$"00F0 0000 0000 0000 0FF0 0000 0000 0FFF"
	$"000F F000 0000 0000 000F FFFF FFF0 0FFF"
	$"0000 0FFF FFFF FFFF FFFC CCCC CCCF FFFF"
	$"0000 0000 0000 00FF FFFF FFFF FFF0 0FFF"
};

resource 'icl4' (129) {
	$"0000 0000 000F 00F0 0000 0000 0000 0000"
	$"0000 0000 000F F0FF 0000 0000 0000 0000"
	$"0000 0000 000F FFFF F000 0000 0000 0000"
	$"0000 0000 000F CCFC CF00 0000 0000 0000"
	$"0000 0000 000F CCFC CCFF 0000 0000 0000"
	$"0000 0000 00FC CCCC CCCC FF00 0000 0000"
	$"0000 0000 00FC CFFF CCCC FCF0 0000 0000"
	$"0000 0000 0FCC CFFC FCCC CCCF 0000 0000"
	$"0000 0000 0FCC CCCC CCCC CCFC F000 0000"
	$"0000 0000 FCCC CCCC CCCC CCFC CF00 0000"
	$"0000 000F CCCC CCCC CCCC CCFC CF00 0000"
	$"0000 000F CCCC CCCC CCCC CCCC FCF0 0000"
	$"0000 00FC CCCC CFCC CCCC CCCC FCF0 0000"
	$"0000 0FCC CCCC CCFC CCCF CCCC FCCF 0000"
	$"0000 0FCC CCCC CF0F FFFC CCCC FCCF 0000"
	$"0000 0FCF FFCC F000 0FCC CCCC CCFC F000"
	$"0000 00F0 0FCF 0000 FCCC CCCC CCFC F000"
	$"0000 0000 FCF0 000F CCCC CCCC CCFC F000"
	$"0000 0FF0 FF00 00FC CCCC CCCC CCFC CF00"
	$"0000 FF00 0000 00FC CCCC CCCC CCCC FF00"
	$"000F 00FF FFFF FFFF FFCC CCCC CCCF CF00"
	$"00F0 0000 0000 0000 00FF CCCC CCCF CF00"
	$"00F0 0000 0000 0000 0000 FCCC CCCF CCF0"
	$"0F00 F000 F00F 000F 00F0 0FCC CCCF CCF0"
	$"0F00 0F0F 00F0 F00F 0F00 0FCC CCCF CCF0"
	$"0F00 00F0 0F00 0F0F F000 0FCC CCCC CCF0"
	$"0F00 00F0 0FFF FF0F 0F00 0FCC CCCC CCCF"
	$"0F00 00F0 0F00 0F0F 00F0 0FCC CCCC CCCF"
	$"00F0 0000 0000 0000 0000 FCCC CCCC CCCF"
	$"000F F000 0000 0000 00FF CCCC CCCC CCCF"
	$"0000 0FFF FFFF FFFF FFCC CCCC CCCC CCCF"
	$"0000 0000 0000 00FF FFFF FFFF FFFF FFFF"
};

resource 'icl4' (130) {
	$"000F FFFF FFFF FFFF FFFF FFFF 0000 0000"
	$"000F 0000 0000 0000 0000 000F F000 0000"
	$"000F 0000 0000 0000 0000 000F 0F00 0000"
	$"000F 0000 0000 0000 0000 000F 00F0 0000"
	$"000F 0000 000F 00F0 0000 000F 000F 0000"
	$"000F 0000 000F F0FF 0000 000F 0000 F000"
	$"000F 0000 000F FFFF F000 000F FFFF FF00"
	$"000F 0000 000F CCFC CF00 0000 0000 0F00"
	$"000F 0000 000F CCFC CFF0 0000 0000 0F00"
	$"000F 0000 00FC CCCC CCCF F000 0000 0F00"
	$"000F 0000 00FC CFFF CCCF CF00 0000 0F00"
	$"000F 0000 0FCC CFFC FCCC CCF0 0000 0F00"
	$"000F 0000 0FCC CCCC CCCC CFCF 0000 0F00"
	$"000F 0000 FCCC CCCC CCCC CFCC F000 0F00"
	$"000F 000F CCCC CCCC CCCC CFCC F000 0F00"
	$"000F 000F CCCC CCCC CCCC CCCF CF00 0F00"
	$"000F 00FC CCCC CFCC CCCC CCCF CF00 0F00"
	$"000F 0FCC CCCC CCFC CCFC CCCF CCF0 0F00"
	$"000F 0FCF FFCC FF0F FFCC CCCF CFFF 0F00"
	$"000F 00F0 0FCF 0000 FCCC CCCC CFCF 0F00"
	$"000F 0000 F0F0 000F CCCC CCCC CFCF 0F00"
	$"000F 0000 FF00 00FC CCCC CCCC CFCF 0F00"
	$"000F 0000 0000 00FC CCCC CCCC CCCF 0F00"
	$"000F 0000 0000 0FCC CCCC CCCC CCCF 0F00"
	$"000F 0000 0000 0FCC CCCC CCCC CCCF 0F00"
	$"000F 0000 0000 FCCC CCCC CCCC CCCF 0F00"
	$"000F 0000 0000 FCCC CCCC CCCC CCCF 0F00"
	$"000F 0000 0000 FFFF FFFF FFFF FFFF 0F00"
	$"000F 0000 0000 0000 0000 0000 0000 0F00"
	$"000F 0000 0000 0000 0000 0000 0000 0F00"
	$"000F 0000 0000 0000 0000 0000 0000 0F00"
	$"000F FFFF FFFF FFFF FFFF FFFF FFFF FF"
};

resource 'icl8' (128) {
	$"0000 0000 0000 0000 0000 00FF 0000 FF00"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF FF00 FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF FFFF FFFF"
	$"FF00 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF F6F6 FFF6"
	$"F6FF 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF F6F6 FFF6"
	$"F6F6 FFFF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FFF6 F6F6 F6F6"
	$"F6F6 F6F6 FFFF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FFF6 F6FF FFFF"
	$"F6F6 F6F6 FFF6 FF00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FF F6F6 F6FF FFF6"
	$"FFF6 F6F6 F6F6 F6FF 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FF F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 FFF6 FF00 0000 0000 0000"
	$"0000 0000 0000 0000 FFF6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 FFF6 F6FF 0000 0000 0000"
	$"0000 0000 0000 00FF F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 FFF6 F6FF 0000 0000 0000"
	$"0000 0000 0000 00FF F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6FF F6F6"
	$"F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000 0000"
	$"0000 0000 00FF F6F6 F6F6 F6F6 F6F6 FFF6"
	$"F6F6 F6FF F6F6 F6F6 FFF6 F6FF 0000 0000"
	$"0000 0000 00FF F6F6 F6F6 F6F6 F6FF 00FF"
	$"FFFF FFF6 F6F6 F6F6 FFF6 F6FF 0000 0000"
	$"0000 0000 00FF F6FF FFFF F6F6 FF00 0000"
	$"00FF F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000"
	$"0000 0000 0000 FF00 00FF F6FF 0000 0000"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000"
	$"0000 0000 0000 0000 FFF6 FF00 0000 00FF"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000"
	$"0000 0000 00FF FF00 FFFF 0000 0000 FFF6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 FFF6 F6FF 0000"
	$"0000 0000 FFFF 0000 0000 0000 0000 FFF6"
	$"F6F6 FFFF FFFF FFFF F6F6 F6F6 FFFF 0000"
	$"0000 00FF 0000 FFFF FFFF FFFF FFFF FFFF"
	$"FFFF F5F5 F5F5 F5F5 FFF6 F6FF F6FF 0000"
	$"0000 FF00 0000 0000 0000 0000 0000 0000"
	$"FFF5 F5F5 F5F5 F5F5 F5FF F6F6 F6FF 0000"
	$"0000 FF00 0000 0000 0000 0000 0000 00FF"
	$"F5F5 FFFF F5F5 F5F5 F5F5 FFF6 F6F6 FF00"
	$"00FF 0000 FF00 0000 FF00 00FF 0000 00FF"
	$"FFFF 0000 FFF5 F5F5 F5F5 F5FF F6F6 FF00"
	$"00FF 0000 00FF 00FF 0000 FF00 FFFF FFF5"
	$"F5FF FFFF FFFF FFFF FFF5 F5F5 FFFF FFFF"
	$"00FF 0000 0000 FF00 00FF 0000 0000 FFF5"
	$"F5F5 FFFF F5F5 F5F5 F5F5 F5F5 F5FF FFFF"
	$"00FF 0000 0000 FF00 00FF FFFF FF00 00FF"
	$"F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FF FFFF"
	$"00FF 0000 0000 FF00 00FF 0000 0000 0000"
	$"FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FF FFFF"
	$"0000 FF00 0000 0000 0000 0000 0000 0000"
	$"00FF FFF5 F5F5 F5F5 F5F5 F5F5 F5FF FFFF"
	$"0000 00FF FF00 0000 0000 0000 0000 0000"
	$"0000 00FF FFFF FFFF FFFF FFF5 F5FF FFFF"
	$"0000 0000 00FF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFF6 F6F6 F6F6 F6F6 F6FF FFFF FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FF00 00FF FFFF"
};

resource 'icl8' (129) {
	$"0000 0000 0000 0000 0000 00FF 0000 FF00"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF FF00 FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF FFFF FFFF"
	$"FF00 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF F6F6 FFF6"
	$"F6FF 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF F6F6 FFF6"
	$"F6F6 FFFF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FFF6 F6F6 F6F6"
	$"F6F6 F6F6 FFFF 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FFF6 F6FF FFFF"
	$"F6F6 F6F6 FFF6 FF00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FF F6F6 F6FF FFF6"
	$"FFF6 F6F6 F6F6 F6FF 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FF F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 FFF6 FF00 0000 0000 0000"
	$"0000 0000 0000 0000 FFF6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 FFF6 F6FF 0000 0000 0000"
	$"0000 0000 0000 00FF F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 FFF6 F6FF 0000 0000 0000"
	$"0000 0000 0000 00FF F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000 0000"
	$"0000 0000 0000 FFF6 F6F6 F6F6 F6FF F6F6"
	$"F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000 0000"
	$"0000 0000 00FF F6F6 F6F6 F6F6 F6F6 FFF6"
	$"F6F6 F6FF F6F6 F6F6 FFF6 F6FF 0000 0000"
	$"0000 0000 00FF F6F6 F6F6 F6F6 F6FF 00FF"
	$"FFFF FFF6 F6F6 F6F6 FFF6 F6FF 0000 0000"
	$"0000 0000 00FF F6FF FFFF F6F6 FF00 0000"
	$"00FF F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000"
	$"0000 0000 0000 FF00 00FF F6FF 0000 0000"
	$"FFF6 F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000"
	$"0000 0000 0000 0000 FFF6 FF00 0000 00FF"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 FFF6 FF00 0000"
	$"0000 0000 00FF FF00 FFFF 0000 0000 FFF6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 FFF6 F6FF 0000"
	$"0000 0000 FFFF 0000 0000 0000 0000 FFF6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 FFFF 0000"
	$"0000 00FF 0000 FFFF FFFF FFFF FFFF FFFF"
	$"FFFF F6F6 F6F6 F6F6 F6F6 F6FF F6FF 0000"
	$"0000 FF00 0000 0000 0000 0000 0000 0000"
	$"0000 FFFF F6F6 F6F6 F6F6 F6FF F6FF 0000"
	$"0000 FF00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 FFF6 F6F6 F6F6 F6FF F6F6 FF00"
	$"00FF 0000 FF00 0000 FF00 00FF 0000 00FF"
	$"0000 FF00 00FF F6F6 F6F6 F6FF F6F6 FF00"
	$"00FF 0000 00FF 00FF 0000 FF00 FF00 00FF"
	$"00FF 0000 00FF F6F6 F6F6 F6FF F6F6 FF00"
	$"00FF 0000 0000 FF00 00FF 0000 00FF 00FF"
	$"FF00 0000 00FF F6F6 F6F6 F6F6 F6F6 FF00"
	$"00FF 0000 0000 FF00 00FF FFFF FFFF 00FF"
	$"00FF 0000 00FF F6F6 F6F6 F6F6 F6F6 F6FF"
	$"00FF 0000 0000 FF00 00FF 0000 00FF 00FF"
	$"0000 FF00 00FF F6F6 F6F6 F6F6 F6F6 F6FF"
	$"0000 FF00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 FFF6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"0000 00FF FF00 0000 0000 0000 0000 0000"
	$"0000 FFFF F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"0000 0000 00FF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FF"
	$"0000 0000 0000 0000 0000 0000 0000 FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'icl8' (130) {
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF 0000 0000 0000 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF FF00 0000 0000 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF 00FF 0000 0000 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FF 0000 FF00 0000 0000"
	$"0000 00FF 0000 0000 0000 00FF 0000 FF00"
	$"0000 0000 0000 00FF 0000 00FF 0000 0000"
	$"0000 00FF 0000 0000 0000 00FF FF00 FFFF"
	$"0000 0000 0000 00FF 0000 0000 FF00 0000"
	$"0000 00FF 0000 0000 0000 00FF FFFF FFFF"
	$"FF00 0000 0000 00FF FFFF FFFF FFFF 0000"
	$"0000 00FF 0000 0000 0000 00FF F6F6 FFF6"
	$"F6FF 0000 0000 0000 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 0000 00FF F6F6 FFF6"
	$"F6FF FF00 0000 0000 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 0000 FFF6 F6F6 F6F6"
	$"F6F6 F6FF FF00 0000 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 0000 FFF6 F6FF FFFF"
	$"F6F6 F6FF F6FF 0000 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 00FF F6F6 F6FF FFF6"
	$"FFF6 F6F6 F6F6 FF00 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 00FF F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6FF F6FF 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 FFF6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6FF F6F6 FF00 0000 00FF 0000"
	$"0000 00FF 0000 00FF F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6FF F6F6 FF00 0000 00FF 0000"
	$"0000 00FF 0000 00FF F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6FF F6FF 0000 00FF 0000"
	$"0000 00FF 0000 FFF6 F6F6 F6F6 F6FF F6F6"
	$"F6F6 F6F6 F6F6 F6FF F6FF 0000 00FF 0000"
	$"0000 00FF 00FF F6F6 F6F6 F6F6 F6F6 FFF6"
	$"F6F6 FFF6 F6F6 F6FF F6F6 FF00 00FF 0000"
	$"0000 00FF 00FF F6FF FFFF F6F6 FFFF 00FF"
	$"FFFF F6F6 F6F6 F6FF F6FF FFFF 00FF 0000"
	$"0000 00FF 0000 FF00 00FF F6FF 0000 0000"
	$"FFF6 F6F6 F6F6 F6F6 F6FF F6FF 00FF 0000"
	$"0000 00FF 0000 0000 FF00 FF00 0000 00FF"
	$"F6F6 F6F6 F6F6 F6F6 F6FF F6FF 00FF 0000"
	$"0000 00FF 0000 0000 FFFF 0000 0000 FFF6"
	$"F6F6 F6F6 F6F6 F6F6 F6FF F6FF 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 FFF6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6FF 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 00FF F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6FF 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 00FF F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6FF 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 FFF6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6FF 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 FFF6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6FF 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FF 0000"
	$"0000 00FF 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FF 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'icl8' (401, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FB"
	$"FBFB 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FB"
	$"FBFB 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB FBFB"
	$"FBFB FBFB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FB"
	$"FBFB 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FB"
	$"FBFB 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FB"
	$"FBFB 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB"
};

resource 'icl8' (402, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB 0000 FB00 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FB00 FBFB 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FB00"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 00FB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 00FB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 00FB FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 00FB FBFB FBFB FBFB FBFB 00FB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 00FB FBFB FBFB FBFB FB00 0000 00FB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 FB00 00FB FBFB 0000 0000 FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 0000 FBFB FB00 0000 00FB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 0000 FBFB 0000 0000 FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FB00 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FB00 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FB00 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FB00 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB"
};

resource 'icl8' (403, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB 0000"
	$"0000 00FB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FB00"
	$"0000 FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FB00"
	$"0000 FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB 0000"
	$"0000 00FB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB 0000"
	$"0000 00FB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FB00"
	$"0000 FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"00FB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB FBFB"
	$"FBFB FBFB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB FBFB"
	$"FBFB FBFB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"00FB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FB00"
	$"0000 FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 0000 FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FB"
};

resource 'icl8' (404, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB 0000 0000 FBFB"
	$"FBFB 0000 0000 FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB"
};

resource 'icl8' (405, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FB FBFB 0000"
	$"0000 00FB FBFB 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FB00"
	$"0000 FBFB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 FBFB FB00 0000 FBFB FBFB FB00"
	$"0000 FBFB FBFB FB00 0000 FBFB FB00 0000"
	$"0000 00FB FBFB FBFB 0000 00FB FBFB 0000"
	$"0000 00FB FBFB 0000 00FB FBFB FBFB 0000"
	$"0000 00FB FBFB FBFB 0000 0000 FB00 0000"
	$"0000 0000 FB00 0000 00FB FBFB FBFB 0000"
	$"0000 0000 FBFB FB00 0000 00FB FBFB 0000"
	$"0000 00FB FBFB 0000 0000 FBFB FB00 0000"
	$"0000 0000 00FB 0000 0000 00FB FBFB 0000"
	$"0000 00FB FBFB 0000 0000 00FB 0000 0000"
	$"0000 0000 00FB FB00 0000 FBFB FBFB FB00"
	$"0000 FBFB FBFB FB00 0000 FBFB 0000 0000"
	$"0000 0000 00FB FBFB 0000 FBFB FBFB FB00"
	$"0000 FBFB FBFB FB00 00FB FBFB 0000 0000"
	$"0000 0000 00FB FBFB FB00 FBFB FBFB FBFB"
	$"00FB FBFB FBFB FB00 FBFB FBFB 0000 0000"
	$"0000 0000 00FB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB 0000 0000"
	$"0000 0000 00FB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB FBFB"
	$"FBFB FBFB FB"
};

resource 'icl8' (406, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FB FBFB"
	$"FBFB FBFB 0000 0000 0000 0000 0000 0000"
	$"0000 0000 00FB FBFB FBFB 0000 00FB FBFB"
	$"FBFB FBFB 0000 00FB FBFB FBFB 0000 0000"
	$"0000 0000 FBFB FBFB FBFB FBFB 00FB FBFB"
	$"FBFB FBFB 00FB FBFB FBFB FBFB FB00 0000"
	$"0000 00FB FBFB FBFB FBFB FBFB FB00 0000"
	$"0000 0000 FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 00FB FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 00FB FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 FBFB FBFB FBFB FBFB FBFB FBFB FB00"
	$"0000 FBFB FBFB FBFB FBFB FBFB FBFB FB00"
	$"0000 FBFB FBFB FBFB FBFB FBFB FBFB FBFB"
	$"00FB FBFB FBFB FBFB FBFB FBFB FBFB FB00"
	$"0000 FBFB FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB FB00"
	$"0000 FBFB FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB FB00"
	$"0000 FBFB FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB FB00"
	$"0000 00FB FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 00FB FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FBFB 0000"
	$"0000 0000 FBFB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB FB00 0000"
	$"0000 0000 00FB FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FBFB 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 0000 FBFB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB FB00 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FBFB 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB FB00 0000 0000 0000"
	$"0000 0000 0000 0000 00FB FBFB FBFB FBFB"
	$"FBFB FBFB FBFB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB FBFB"
	$"FBFB FBFB FB"
};



resource 'ICN#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"0012 0000 001B 0000 001F 8000 0012 4000"
		$"0012 3000 0020 0C00 0027 0A00 0046 8100"
		$"0040 0280 0080 0240 0100 0240 0100 00A0"
		$"0204 00A0 0402 1090 0405 E090 05C8 4028"
		$"0250 8028 00A1 0028 06C2 0024 0C02 3F0C"
		$"13FF 4094 2000 8044 2001 3022 4891 C812"
		$"452E 7F8F 4242 3007 4279 0007 4240 8007"
		$"2000 6007 1800 1FE7 07FF E01F 0003 FFE7",
		/* [2] */
		$"0012 0000 001B 0000 001F 8000 001F C000"
		$"001F F000 003F FC00 003F FE00 007F FF00"
		$"007F FF80 00FF FFC0 01FF FFC0 01FF FFE0"
		$"03FF FFE0 07FF FFF0 07FD FFF0 07F8 7FF8"
		$"0270 FFF8 00E1 FFF8 06C3 FFFC 0C03 FFFC"
		$"1FFF FFFC 3FFF FFFC 3FFF FFFE 7FFF FFFE"
		$"7FFF FFFF 7FFF FFFF 7FFF FFFF 7FFF FFFF"
		$"3FFF FFFF 1FFF FFFF 07FF FFFF 0003 FFE7"
	}
};

resource 'ICN#' (129) {
	{	/* array: 2 elements */
		/* [1] */
		$"0012 0000 001B 0000 001F 8000 0012 4000"
		$"0012 3000 0020 0C00 0027 0A00 0046 8100"
		$"0040 0280 0080 0240 0100 0240 0100 00A0"
		$"0204 00A0 0402 1090 0405 E090 05C8 4028"
		$"0250 8028 00A1 0028 06C2 0024 0C02 000C"
		$"13FF C014 2000 3014 2000 0812 4891 2412"
		$"4529 4412 4245 8402 427D 4401 4245 2401"
		$"2000 0801 1800 3001 07FF C001 0003 FFFF",
		/* [2] */
		$"0012 0000 001B 0000 001F 8000 001F C000"
		$"001F F000 003F FC00 003F FE00 007F FF00"
		$"007F FF80 00FF FFC0 01FF FFC0 01FF FFE0"
		$"03FF FFE0 07FF FFF0 07FD FFF0 07F8 7FF8"
		$"0270 FFF8 00E1 FFF8 06C3 FFFC 0C03 FFFC"
		$"1FFF FFFC 3FFF FFFC 3FFF FFFE 7FFF FFFE"
		$"7FFF FFFE 7FFF FFFE 7FFF FFFF 7FFF FFFF"
		$"3FFF FFFF 1FFF FFFF 07FF FFFF 0003 FFFF"
	}
};

resource 'ICN#' (130) {
	{	/* array: 2 elements */
		/* [1] */
		$"1FFF FF00 1000 0180 1000 0140 1000 0120"
		$"1012 0110 101B 0108 101F 81FC 1012 4004"
		$"1012 6004 1020 1804 1027 1404 1046 8204"
		$"1040 0504 1080 0484 1100 0484 1100 0144"
		$"1204 0144 1402 2124 15CD C174 1250 8054"
		$"10A1 0054 10C2 0054 1002 0014 1004 0014"
		$"1004 0014 1008 0014 1008 0014 100F FFF4"
		$"1000 0004 1000 0004 1000 0004 1FFF FFFC",
		/* [2] */
		$"1FFF FF00 1FFF FF80 1FFF FFC0 1FFF FFE0"
		$"1FFF FFF0 1FFF FFF8 1FFF FFFC 1FFF FFFC"
		$"1FFF FFFC 1FFF FFFC 1FFF FFFC 1FFF FFFC"
		$"1FFF FFFC 1FFF FFFC 1FFF FFFC 1FFF FFFC"
		$"1FFF FFFC 1FFF FFFC 1FFF FFFC 1FFF FFFC"
		$"1FFF FFFC 1FFF FFFC 1FFF FFFC 1FFF FFFC"
		$"1FFF FFFC 1FFF FFFC 1FFF FFFC 1FFF FFFC"
		$"1FFF FFFC 1FFF FFFC 1FFF FFFC 1FFF FFFC"
	}
};

resource 'ICN#' (300, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 8000 0000 8030 0000 8048 0000"
		$"8084 0000 8102 0000 8201 0000 8387 0000"
		$"8084 0000 80FC 0000 8000 0000 80FC 0000"
		$"8084 0000 8387 0000 8201 0000 8102 0000"
		$"8084 0000 8048 0000 8030 0000 8000 0000"
		$"FFFF FFFF 7FFF FFFF 3FFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (301, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 0000 0000 0000 0000 0000 0000"
		$"FFFF FFFF FFFF FFFF FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (302, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFC 0000 0006 0000 3007 0000 4807"
		$"0000 8407 0001 0207 0002 0107 0003 8707"
		$"0000 8407 0000 FC07 0000 0007 0000 FC07"
		$"0000 8407 0003 8707 0002 0107 0001 0207"
		$"0000 8407 0000 4807 0000 3007 0000 0007"
		$"FFFF FFFF FFFF FFFF FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (303, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 8000 0000 8030 0000 8078 0000"
		$"80FC 0000 81FE 0000 83FF 0000 83FF 0000"
		$"80FC 0000 80FC 0000 8000 0000 80FC 0000"
		$"8084 0000 8387 0000 8201 0000 8102 0000"
		$"8084 0000 8048 0000 8030 0000 8000 0000"
		$"FFFF FFFF 7FFF FFFF 3FFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (304, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 8000 0000 8030 0000 8048 0000"
		$"8084 0000 8102 0000 8201 0000 8387 0000"
		$"8084 0000 80FC 0000 8000 0000 80FC 0000"
		$"80FC 0000 83FF 0000 83FF 0000 81FE 0000"
		$"80FC 0000 8078 0000 8030 0000 8000 0000"
		$"FFFF FFFF 7FFF FFFF 3FFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (305, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFC 0000 0006 0000 3007 0000 7807"
		$"0000 FC07 0001 FE07 0003 FF07 0003 FF07"
		$"0000 FC07 0000 FC07 0000 0007 0000 FC07"
		$"0000 8407 0003 8707 0002 0107 0001 0207"
		$"0000 8407 0000 4807 0000 3007 0000 0007"
		$"FFFF FFFF FFFF FFFF FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (306, preload) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFC 0000 0006 0000 3007 0000 4807"
		$"0000 8407 0001 0207 0002 0107 0003 8707"
		$"0000 8407 0000 FC07 0000 0007 0000 FC07"
		$"0000 FC07 0003 FF07 0003 FF07 0001 FE07"
		$"0000 FC07 0000 7807 0000 3007 0000 0007"
		$"FFFF FFFF FFFF FFFF FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};




resource 'ICON' (300) {
	$"0000 4800 0000 D800 0001 F800 0002 4800"
	$"000C 4800 0030 0400 0050 E400 0081 6200"
	$"0140 0200 0240 0100 0240 0080 0500 0080"
	$"0500 2040 0908 4020 0907 A020 1402 13A0"
	$"1401 0A40 1400 8500 2400 4360 3000 2030"
	$"283F FFC8 28C0 0004 4900 0004 4A7B 9CD2"
	$"4A00 0002 425F 76F2 8200 0002 827B E762"
	$"8100 0004 80C0 0018 803F FFE0 FFFF FC"
};

resource 'ICON' (401, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0001 C000 0003 E000 0003 E000 0003 E000"
	$"0001 C000 0007 F000 000F F800 001F FC00"
	$"001F FC00 0001 C000 0001 C000 0001 C000"
	$"0003 E000 0003 E000 0003 E000 0007 F000"
	$"0007 F000 0007 F000 0003 E000 0003 E000"
	$"001F FC00 007F FF00 00FF FF80 00FF FF80"
	$"00FF FF80"
};

resource 'ICON' (402, preload) {
	$"0000 0000 0048 0000 006C 0000 007E 0000"
	$"007F 0000 007F C000 00FF F000 00FF F800"
	$"01FF FC00 01FF FE00 03FF FF00 07FF FF00"
	$"07FF FF80 0FFF FF80 1FFF FFC0 1FF7 FFC0"
	$"1FE1 FFE0 09C3 FFE0 0387 FFE0 030F FFF0"
	$"000F FFF0 001F FFF0 001F FFF8 003F FFF8"
	$"003F FFF8 003F FFF8 007F FFFC 007F FFFC"
	$"007F FFFC 007F FFFC"
};

resource 'ICON' (403, preload) {
	$"0000 0000 0000 0000 000C 1800 001E 3C00"
	$"001E 3C00 000C 1800 000C 1800 001E 3C00"
	$"001F 7C00 003F FE00 007F FF00 007F FF00"
	$"00FF FF80 00FF FF80 00FF FF80 00FF FF80"
	$"00FF FF80 007F FF00 007F FF00 003F FE00"
	$"003F FE00 001F FC00 000F F800 001F FC00"
	$"001F FC00 001F FC00 00FF FF80 01FF 7FC0"
	$"01FE 3FC0 0080 0080"
};

resource 'ICON' (404, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"03C3 C3C0 03FF FFC0 03FF FFC0 03FF FFC0"
	$"01FF FF80 00FF FF00 007F FE00 007F FE00"
	$"007F FE00 007F FE00 007F FE00 007F FE00"
	$"007F FE00 007F FE00 007F FE00 00FF FF00"
	$"00FF FF00 00FF FF00 01FF FF80 01FF FF80"
	$"01FF FF80 03FF FFC0 03FF FFC0 03FF FFC0"
	$"03FF FFC0"
};

resource 'ICON' (405, preload) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 001C 1C00 003E 3E00 0E3E 3E38"
	$"1F1C 1C7C 1F08 087C 0E1C 1C38 041C 1C10"
	$"063E 3E30 073E 3E70 07BF 7EF0 07FF FFF0"
	$"07FF FFF0 03FF FFE0 03FF FFE0 03FF FFE0"
	$"01FF FFC0 01FF FFC0 01FF FFC0 00FF FF80"
	$"00FF FF80 00FF FF80 007F FF00 000F F8"
};

resource 'ICON' (406, preload) {
	$"0000 0000 0000 0000 0007 F000 0007 F000"
	$"0007 F000 0007 F000 0007 F000 07C7 F1F0"
	$"0FF7 F7F8 1FFF FFFC 1FFF FFFC 3FFF FFFE"
	$"3FFF FFFE 3FFF FFFE 3FFF FFFE 3FFF FFFE"
	$"1FFF FFFC 1FFF FFFC 0FFF FFF8 07FF FFF0"
	$"03FF FFE0 03FF FFE0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 00FF FF80 00FF FF80 00FF FF80"
	$"007F FF00 000F F8"
};



resource 'ics#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"0500 0780 0460 0930 0818 101C 214C 2A8E"
		$"1506 0906 3F86 4077 B5EB A447 403F 3FC3",
		/* [2] */
		$"0500 0780 07E0 0FF0 0FF8 1FFC 3FFC 3FFE"
		$"1FFE 0FFE 3FFE 7FFF FFFF FFFF 7FFF 3FC3"
	}
};

resource 'ics#' (129) {
	{	/* array: 2 elements */
		/* [1] */
		$"0500 0780 0460 0930 0818 101C 214C 2A8E"
		$"1506 0906 3FC6 4027 B497 A693 4023 3FDF",
		/* [2] */
		$"0500 0780 07E0 0FF0 0FF8 1FFC 3FFC 3FFE"
		$"1FFE 0FFE 3FFE 7FFF FFFF FFFF 7FFF 3FDF"
	}
};

resource 'ics#' (130) {
	{	/* array: 2 elements */
		/* [1] */
		$"7FF0 4018 4514 479E 4462 4932 481A 501A"
		$"554A 4A9A 448A 411A 420A 43FA 4002 7FFE",
		/* [2] */
		$"7FF0 7FF8 7FFC 7FFE 7FFE 7FFE 7FFE 7FFE"
		$"7FFE 7FFE 7FFE 7FFE 7FFE 7FFE 7FFE 7FFE"
	}
};



resource 'ics4' (128) {
	$"0000 0F0F 0000 0000 0000 0FFF F000 0000"
	$"0000 0FCC CFF0 0000 0000 FCCF CCFF 0000"
	$"0000 FCCC CCCF F000 000F CCCC CCCF FF00"
	$"00FC CCCF CFCC FF00 00FC FCF0 FCCC FFF0"
	$"000F CF0F CCCC CFF0 0000 F00F CCCC CFF0"
	$"00FF FFFF FCCC CFF0 0F00 0000 0FFF CFFF"
	$"F0FF 0F0F FFF0 FCFF F0F0 0F00 0F00 0FFF"
	$"0F00 0000 00FF FFFF 00FF FFFF FF00 00FF"
};

resource 'ics4' (129) {
	$"0000 0F0F 0000 0000 0000 0FFF F000 0000"
	$"0000 0FCC CFF0 0000 0000 FCCF CCFF 0000"
	$"0000 FCCC CCCF F000 000F CCCC CCCF FF00"
	$"00FC CCCF CFCC FF00 00FC FCF0 FCCC FFF0"
	$"000F CF0F CCCC CFF0 0000 F00F CCCC CFF0"
	$"00FF FFFF FFCC CFF0 0F00 0000 00FC CFFF"
	$"F0FF 0F00 F00F CFFF F0F0 0FF0 F00F CCFF"
	$"0F00 0000 00FC CCFF 00FF FFFF FF0F FFFF"
};

resource 'ics4' (130) {
	$"0FFF FFFF FFFF 0000 0F00 0000 000F F000"
	$"0F00 0F0F 000F 0F00 0F00 0FFF F00F FFF0"
	$"0F00 0FCC CFF0 00F0 0F00 FCCF CCFF 00F0"
	$"0F00 FCCC CCCF F0F0 0F0F CCCC CCCF F0F0"
	$"0F0F CFCF CFCC F0F0 0F00 FCF0 FCCF F0F0"
	$"0F00 0F00 FCCC F0F0 0F00 000F CCCF F0F0"
	$"0F00 00FC CCCC F0F0 0F00 00FF FFFF F0F0"
	$"0F00 0000 0000 00F0 0FFF FFFF FFFF FFF0"
};



resource 'ics8' (128) {
	$"0000 0000 00FF 00FF 0000 0000 0000 0000"
	$"0000 0000 00FF FFFF FF00 0000 0000 0000"
	$"0000 0000 00FF F6F6 F6FF FF00 0000 0000"
	$"0000 0000 FFF6 F6FF F6F6 FFFF 0000 0000"
	$"0000 0000 FFF6 F6F6 F6F6 F6FF FF00 0000"
	$"0000 00FF F6F6 F6F6 F6F6 F6FF FFFF 0000"
	$"0000 FFF6 F6F6 F6FF F6FF F6F6 FFFF 0000"
	$"0000 FFF6 FFF6 FF00 FFF6 F6F6 FFFF FF00"
	$"0000 00FF F6FF 00FF F6F6 F6F6 F6FF FF00"
	$"0000 0000 FF00 00FF F6F6 F6F6 F6FF FF00"
	$"0000 FFFF FFFF FFFF FFF6 F6F6 F6FF FF00"
	$"00FF 0000 0000 0000 00FF FFFF F6FF FFFF"
	$"FF00 FFFF 00FF 00FF FFFF FFF5 FFF6 FFFF"
	$"FF00 FF00 00FF 0000 00FF F5F5 F5FF FFFF"
	$"00FF 0000 0000 0000 0000 FFFF FFFF FFFF"
	$"0000 FFFF FFFF FFFF FFFF 0000 0000 FFFF"
};

resource 'ics8' (129) {
	$"0000 0000 00FF 00FF 0000 0000 0000 0000"
	$"0000 0000 00FF FFFF FF00 0000 0000 0000"
	$"0000 0000 00FF F6F6 F6FF FF00 0000 0000"
	$"0000 0000 FFF6 F6FF F6F6 FFFF 0000 0000"
	$"0000 0000 FFF6 F6F6 F6F6 F6FF FF00 0000"
	$"0000 00FF F6F6 F6F6 F6F6 F6FF FFFF 0000"
	$"0000 FFF6 F6F6 F6FF F6FF F6F6 FFFF 0000"
	$"0000 FFF6 FFF6 FF00 FFF6 F6F6 FFFF FF00"
	$"0000 00FF F6FF 00FF F6F6 F6F6 F6FF FF00"
	$"0000 0000 FF00 00FF F6F6 F6F6 F6FF FF00"
	$"0000 FFFF FFFF FFFF FFFF F6F6 F6FF FF00"
	$"00FF 0000 0000 0000 0000 FFF6 F6FF FFFF"
	$"FF00 FFFF 00FF 0000 FF00 00FF F6FF FFFF"
	$"FF00 FF00 00FF FF00 FF00 00FF F6F6 FFFF"
	$"00FF 0000 0000 0000 0000 FFF6 F6F6 FFFF"
	$"0000 FFFF FFFF FFFF FFFF 00FF FFFF FFFF"
};

resource 'ics8' (130) {
	$"00FF FFFF FFFF FFFF FFFF FFFF 0000 0000"
	$"00FF 0000 0000 0000 0000 00FF FF00 0000"
	$"00FF 0000 00FF 00FF 0000 00FF 00FF 0000"
	$"00FF 0000 00FF FFFF FF00 00FF FFFF FF00"
	$"00FF 0000 00FF F6F6 F6FF FF00 0000 FF00"
	$"00FF 0000 FFF6 F6FF F6F6 FFFF 0000 FF00"
	$"00FF 0000 FFF6 F6F6 F6F6 F6FF FF00 FF00"
	$"00FF 00FF F6F6 F6F6 F6F6 F6FF FF00 FF00"
	$"00FF 00FF F6FF F6FF F6FF F6F6 FF00 FF00"
	$"00FF 0000 FF2B FF00 FFF6 F6FF FF00 FF00"
	$"00FF 0000 00FF 0000 FFF6 F6F6 FF00 FF00"
	$"00FF 0000 0000 00FF F6F6 F6FF FF00 FF00"
	$"00FF 0000 0000 FFF6 F6F6 F6F6 FF00 FF00"
	$"00FF 0000 0000 FFFF FFFF FFFF FF00 FF00"
	$"00FF 0000 0000 0000 0000 0000 0000 FF00"
	$"00FF FFFF FFFF FFFF FFFF FFFF FFFF FF"
};



resource 'SICN' (128) {
	{
		$"0500 0780 0460 0930 0818 101C 214C 2A8E"
		$"1506 0906 3F86 4077 B5EB A447 403F 3FC3"
	}
};




resource 'CURS' (handCursor) {
	$"0180 1A70 2648 264A 124D 1249 6809 9801"
	$"8802 4002 2002 2004 1004 0808 0408 0408",
	$"0180 1BF0 3FF8 3FFA 1FFF 1FFF 6FFF FFFF"
	$"FFFE 7FFE 3FFE 3FFC 1FFC 0FF8 07F8 07F8",
	{8, 4}
};

resource 'CURS' (closedHandCursor) {
	$"0000 0000 0000 0000 0DB0 124C 100A 1802"
	$"2802 2002 2002 2004 1004 0808 0408 0408",
	$"0000 0000 0000 0000 0DB0 1FFC 1FFE 1FFE"
	$"3FFE 3FFE 3FFE 3FFC 1FFC 0FF8 07F8 07F8",
	{8, 4}
};

resource 'CURS' (ibeamCursor) {
	$"0C60 0280 0100 0100 0100 0100 0100 0100"
	$"0100 0100 0100 0100 0100 0100 0280 0C60",
	$"",
	{7, 7}
};



/***************************************************************************/
/***************************************************************************/
/***************************************************************************/



resource 'STR#' (mApple) {
	{
/*  1 */	"Displays version and other information about this application."
	};
};


resource 'hmnu' (mApple, "\0x14") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* Menu title */
		HMStringResItem {
			mApple,0,				/* menu item message					*/
			mApple,0,				/* disabled item message				*/
			mApple,0,				/* reserved message						*/
			mApple,0				/* reserved message						*/
		},

		/* About item */
		HMStringResItem {
			mApple,1,				/* menu item message					*/
			mApple,1,				/* disabled item message				*/
			mApple,0,				/* reserved message						*/
			mApple,0				/* reserved message						*/
		}
	};
};

resource 'STR#' (mFile) {
	{
/*  1 */	"Operations related to chess games.",
/*  2 */	"Creates a new chess game.",
/*  3 */	"Opens an existing chess game or message.",
/*  4 */	"Creates a new message.",
/*  5 */	"Closes the current chess game.",
/*  6 */	"Closes the current chess game.  To enable this item, "
			"choose New or Open from the File menu.",
/*  7 */	"Saves the current chess game.",
/*  8 */	"Saves the current chess game.  This item is enabled when a change has "
			"occured to the current game since it was opened, or since the last save.",
/*  9 */	"Saves the current game under a different name.",
/* 10 */	"Saves the current game under a different name.  To enable this item, "
			"choose New or Open from the File menu.",
/* 11 */	"Saves an image of the board that can be used in other applications.",
/* 12 */	"Saves an image of the board that can be used in other applications.  "
			"To enable this item, choose New or Open from the File menu.",
/* 13 */	"Duplicates the current game.",
/* 14 */	"Duplicates the current game.  To enable this item, "
			"choose New or Open from the File menu.",
/* 15 */	"Reverts the current game to whatever was last saved.",
/* 16 */	"Reverts the current game to whatever was last saved.  To enable this item, "
			"the current game must be different than what was last saved.",
/* 17 */	"Sets up paper size, orientation, and other printing options.",
/* 18 */	"Sets up paper size, orientation, and other printing options.  To enable "
			"this item, choose New or Open from the File menu.",
/* 19 */	"Prints a list of the game moves and the board position currently displayed.",
/* 20 */	"Prints a list of the game moves and the board position currently displayed.  "
			"To enable this item, choose New or Open from the File menu.",
/* 21 */	"Quit from this application."
	}
};

resource 'hmnu' (mFile, "File") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* File */
		HMStringResItem {
			mFile,1,				/* menu title message					*/
			mFile,1,				/* disabled title message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* New */
		HMStringResItem {
			mFile,2,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Open */
		HMStringResItem {
			mFile,3,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* New Message */
		HMStringResItem {
			mFile,4,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Close */
		HMStringResItem {
			mFile,5,				/* menu item message					*/
			mFile,6,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Save */
		HMStringResItem {
			mFile,7,				/* menu item message					*/
			mFile,8,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Save As */
		HMStringResItem {
			mFile,9,				/* menu item message					*/
			mFile,10,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Save Board Image */
		HMStringResItem {
			mFile,11,				/* menu item message					*/
			mFile,12,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Duplicate */
		HMStringResItem {
			mFile,13,				/* menu item message					*/
			mFile,14,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Revert */
		HMStringResItem {
			mFile,15,				/* menu item message					*/
			mFile,16,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Page Setup */
		HMStringResItem {
			mFile,17,				/* menu item message					*/
			mFile,18,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Print */
		HMStringResItem {
			mFile,19,				/* menu item message					*/
			mFile,20,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Quit */
		HMStringResItem {
			mFile,21,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		}
	}
};


resource 'STR#' (mEdit) {
	{
/*  1 */	"Editing operations.",

/*  2 */	"Undo last text change.",
/*  3 */	"Undo last text change.  This item is disabled when there is no "
			"game, or there is no text change to undo.",
/*  4 */	"Cuts the current selection into the clipboard.",
/*  5 */	"Cuts the current selection into the clipboard.  "
			"(There is nothing selected right now.)",
/*  6 */	"Copies the current selection into the clipboard.",
/*  7 */	"Copies the current selection into the clipboard.  "
			"(There is nothing selected right now.)",
/*  8 */	"Pastes the clipboard contents into the document.",
/*  9 */	"Pastes the current selection.  (Cant paste here.)",
/* 10 */	"Clears the current selection.",
/* 11 */	"Clears the current selection.  "
			"(There is nothing selected right now.)"
	}
};

resource 'hmnu' (mEdit, "Edit") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* Edit */
		HMStringResItem {
			mEdit,1,				/* menu title message					*/
			mEdit,1,				/* disabled title message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Undo */
		HMStringResItem {
			mEdit,2,				/* menu item message					*/
			mEdit,3,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Cut */
		HMStringResItem {
			mEdit,4,				/* menu item message					*/
			mEdit,5,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Copy */
		HMStringResItem {
			mEdit,6,				/* menu item message					*/
			mEdit,7,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Paste */
		HMStringResItem {
			mEdit,8,				/* menu item message					*/
			mEdit,9,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Clear */
		HMStringResItem {
			mEdit,10,				/* menu item message					*/
			mEdit,11,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		}

	}
};


resource 'STR#' (mGame, "Game") {
	{
/*  1 */	"Options for playing a game.",
/*	2 */	"Make various configuration changes to the current game.  ",
/*	3 */	"Make various configuration changes to the current game.  "
			"To enable this item, choose New or Open from the File menu.",
/*	4 */	"Invert the current board.",
/*	5 */	"Invert the current board.  To enable this item, "
			"choose New or Open from the File menu.",

/*	6 */	"Use this to create a custom board arrangement.",
/*	7 */	"Use this to create a custom board arrangement.",

/*	8 */	"Use this to analyze a game or to play the computer a game.",
/*	9 */	"Use this to analyze a game or to play the computer a game.  "
			"To enable this item, choose New or Open from the File menu.",
/*	10 */	"Play an opponent the current game.",
/*	11 */	"Play an opponent the current game.  To enable this item, "
			"choose New or Open from the File menu.",
/*	12 */	"Play an opponent the current game.  This option only shows machines "
			"in a zone that are running Kibitz.",
/*	13 */	"Play an opponent the current game.  This option only shows machines "
			"in a zone that are running Kibitz.  To enable this item, "
			"choose New or Open from the File menu.",
/*	14 */	"Go to a particular move number in the game.",
/*	15 */	"Go to a particular move number in the game.  To enable this item, "
			"you must have a current game that has had some moves made.",
/*	16 */	"Place a list of game moves into the out-box.  For compressed format, hold "
			"down the option key when selecting this menu item.",
/*	17 */	"Place a list of game moves into the out-box.  For compressed format, hold "
			"down the option key when selecting this menu item.  To enable this item, "
			"position the game slider so that it isnt at the end of the game.",
/*	18 */	"Automatically make the moves selected in the out-box.",
/*	19 */	"Automatically make the moves selected in the out-box.  To enable this item, "
			"select the text for some moves in the out-box.",
	}
};


resource 'hmnu' (mGame, "Game") {
	HelpMgrVersion,						/* Help Version							*/
	0,									/* options								*/
	0,									/* theProc								*/
	0,									/* variant								*/
	HMSkipItem {						/* skip missing msg						*/
		},
	{
		HMStringResItem {
			mGame,1,				/* menu title message					*/
			mGame,1,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		HMStringResItem {
			mGame,2,				/* menu title message					*/
			mGame,3,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		HMStringResItem {
			mGame,4,				/* menu title message					*/
			mGame,5,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		HMStringResItem {
			mGame,6,				/* menu title message					*/
			mGame,7,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		HMStringResItem {
			mGame,8,				/* menu title message					*/
			mGame,9,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		HMStringResItem {
			mGame,10,				/* menu title message					*/
			mGame,11,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		HMStringResItem {
			mGame,12,				/* menu title message					*/
			mGame,13,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		HMStringResItem {
			mGame,14,				/* menu title message					*/
			mGame,15,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		HMStringResItem {
			mGame,16,				/* menu title message					*/
			mGame,17,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

		HMStringResItem {
			mGame,18,				/* menu title message					*/
			mGame,19,				/* disabled title message				*/
			mGame,0,				/* reserved message						*/
			mGame,0					/* reserved message						*/
		},

	}
};

resource 'STR#' (rDynHelpStrings, purgeable) {
	{
		"Use this to send a message to the opponent.",
		"Use this to send a message to the opponent.  To activate, choose 2-player game.",

		"When checked, an incomming move produces a beep.",
		"When checked, an incomming move produces a beep.  To activate, choose 2-player game.",

		"When checked, an incomming message produces a beep.",
		"When checked, an incomming message produces a beep.  To activate, choose 2-player game.",

		"If checked, white starts arranged game.",
		"",

		"If checked, black starts arranged game.",
		"",

		"Click here if you give up.",
		"",

		"Click here to register a draw.  In 2-player mode, click here to offer or accept a draw.",
		"",

		"Click here to record a sound to be sent to your opponent.",
		"Click here to record a sound to be sent to your opponent.  You must have a "
		"sound input device for this to be available.",

		"Click here to send a recorded sound to your opponent.",
		"Click here to send a recorded sound to your opponent.  You must have recorded "
		"a sound for this to be available.",

		"This is your In-Box.  Messages from the opponent are displayed here.  You can "
		"not enter or edit any text here, but you can copy text from here to the clipboard.",
		"",

		"This is your Out-Box.  Enter text messages here to send to the opponent.",
		"",

		"This is the game slider.  It is completely useless until there are some "
		"moves made in the game.",
		"This is the game slider.  Clicking on the pointy ends move you forward or "
		"backward one move in the game.  Sliding the bead up or down moves you to "
		"anywhere in the game.  The color of the bead indicates whose move it is at "
		"that point in the game.",

		"This is the Arrange Board piece palette.  Click on a piece to "
		"add that kind of piece to the board.",
		""
	}
};



/***************************************************************************/
/***************************************************************************/
/***************************************************************************/



resource 'ALRT' (rGameStat, purgeable) {
	{40, 20, 114, 300},
	rGameStat,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'DITL' (rGameStat, purgeable) {
	{
		{44, 220, 64, 270},		Button		{ enabled, "OK" },
		{11, 85, 33, 300},		StaticText	{ disabled, "^0" },
		{11, 23, 43, 55},		Icon		{ disabled, 300 }
	}
};

resource 'ALRT' (rComputerResigns, purgeable) {
	{40, 20, 143, 302},
	rComputerResigns,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'DITL' (rComputerResigns, purgeable) {
	{
		{69, 219, 89, 269},		Button		{ enabled, "OK" },
		{9, 70, 60, 270},		StaticText	{ disabled, "^0" },
		{11, 23, 43, 55},		Icon		{ disabled, 300 }
	}
};






resource 'STR#' (rGameStat, purgeable) {
	{
		"Hey dude:  You win!",
		"Bummer dude:  You lose.",
		"    Stalemate",
		"Draw by 50 move rule.",
		"  Draw by repetition.",
		"Ding:  You win on time.",
		"Ding:  You lose on time.",
		"    White Resigns",
		"    Black Resigns ",
		"    Draw Game",
		"    White Wins",
		"    Black Wins",
		"Draw",
		"Offer Draw",
		"Draw",
		"Retract Offer",
		"Draw",
		"Accept Draw",
		" ",
		" "
	}
};

resource 'STR#' (rComputerResigns, purgeable) {
	{
		"Gratuliere - Sie haben gewonnen.",
		"Herr Ober, abservieren!",
		"Hm, schon wieder verloren.",
		"Auf ein Neues?",
		"Sie haben Glck - ich gebe auf.",
		"Kaufen Sie einen neuen Mac - dieser ist zu schwach fr Sie!",
		"Ich mag nicht mehr spielen (meine Transistoren tun mir weh).",
		"Tut mir leid, aber mir ist es zu hei im Prozessor.  Ich kann nicht mehr.",
		"Schei Spiel - schon wieder verloren.",
		"Sie haben mich ganz nervs gemacht.  Jetzt habe ich verloren!",
		"Mes flicitations, je mincline!",
		"Je laisse tomber.",
		"Pensons plutt au match de retour!",
		"Jabandonne - bien jou!",
		"Vous ne pouvez pas acheter un nouveau Mac?  Celui-ci est trop faible pour vous!",
		"Je ne veux plus jouer.  Jai mal aux transistors.",
		"Je regrette - jai trop chaud au processeur.  Je ne peux plus.",
		"Votre excitation me rend tout nerveux.  Maintenant, jai perdu!",
		"Merde - encore perdu!",
		"Vous avez de la chance que je suis bien lev, autrement",
		"I dont want to play anymore.",
		"I lose, and losing stinks.",
		"I quit.  Are you happy now?",
		"In order to deny you some pleasure, I resign.",
		"Wah.  I quit.",
		"This position is technically untenable, and therefore I am forced to resign.",
		"Congratulations.  Well played.  I succumb to the inevitable.",
		"I give up.  I cant beat luck.",
		"I could have erased your hard disk, but being the good sport I am, Ill just resign.",
		"Who cares that you win?  I prefer checkers anyway.",
		"I could have beaten you if your Mac was faster.",
		"Im a good sport, so I wont give you a bus error.",
		"Youre just lucky text-to- speech isnt included in Kibitz or Id tell you a thing or two.",
		"I dont understand how you won.  You must have been lucky.",
		"You may be smarter, but I dont have to work for a living.",
		"Lo siento, cosas ms importantes me llaman.",
		"Estoy en ventaja pero tu haces el juego tan aburrido",
		"No me gusta dejar el juego a medias pero el deber me llama.",
		"Es mejor que digan aqu corri que aqu quedo.",
		"La vida es muy corta para continuar perdiendo mi tiempo aqu.",
	}
};




/***************************************************************************/



resource 'DLOG' (rPawnPromotion, purgeable) {
	{40, 20, 178, 206},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	rPawnPromotion,
	""
};

resource 'DITL' (rPawnPromotion, purgeable) {
	{
		{103, 16, 123, 90},		Button		{ enabled, "Promote" },
		{ 0, -1000, 20, 2},		StaticText	{ disabled,
			"=K190003,"
			"=k190003,"
			"=N190003,"
			"=n190003,"
			"=B190004,"
			"=b190004,"
			"=R190005,"
			"=r190005,"
			"=Q190006,"
			"=q190006" },		/* Key equivalent data for other items. */
		{44, 101, 62, 178},		RadioButton	{ enabled, "Knight" },
		{64, 101, 82, 178},		RadioButton	{ enabled, "Bishop" },
		{84, 101, 102, 178},	RadioButton	{ enabled, "Rook" },
		{104, 101, 122, 178},	RadioButton	{ enabled, "Queen" },
		{16, 18, 37, 147},		StaticText	{ disabled, "Promote pawn to:" }
	}
};



/***************************************************************************/



resource 'STR#' (rPPCText, preload) {
	{
/* [1] */	"Choose your opponent:",
/* [2] */	"Potential victims",
	}
};



resource 'CNTL' (rSendMessage) {
	{234, 452, 254, 493},
	0,
	visible,
	0,
	0,
	pushButProc,
	1,
	"Send"
};


resource 'CNTL' (rMoveNotify) {
	{3, 366, 17, 506},
	0,
	visible,
	1,
	0,
	checkBoxProc,
	2,
	"Beep on move"
};


resource 'CNTL' (rMssgNotify) {
	{17, 366, 33, 506},
	0,
	visible,
	1,
	0,
	checkBoxProc,
	3,
	"Beep on message"
};


resource 'CNTL' (rWhiteStarts) {
	{20, 320, 33, 480},
	0,
	invisible,
	1,
	0,
	radioButProc,
	4,
	"White Starts Game"
};


resource 'CNTL' (rBlackStarts) {
	{40, 320, 53, 480},
	0,
	invisible,
	1,
	0,
	radioButProc,
	5,
	"Black Starts Game"
};


resource 'CNTL' (rResign) {
	{244, 388, 262, 440},
	0,
	visible,
	0,
	0,
	pushButProc,
	6,
	"Resign"
};


resource 'CNTL' (rDraw) {
	{244, 291, 262, 386},
	0,
	visible,
	0,
	0,
	pushButProc,
	7,
	"Draw"
};


resource 'CNTL' (rRecordSound) {
	{225, 291, 243, 350},
	0,
	visible,
	0,
	0,
	pushButProc,
	8,
	"Record"
};


resource 'CNTL' (rSendSound) {
	{225, 352, 243, 440},
	0,
	visible,
	0,
	0,
	pushButProc,
	9,
	"Send Sound"
};



/***************************************************************************/



resource 'cicn' (257) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 000F F800 000F F800 000F F800"
	$"000F F800 000F F800 0FEF FBF8 1FFF FFFC"
	$"3FFF FFFE 3FFF FFFE 7FFF FFFF 7FFF FFFF"
	$"7FFF FFFF 7FFF FFFF 7FFF FFFF 7FFF FFFF"
	$"7FFF FFFF 3FFF FFFE 3FFF FFFE 1FFF FFFC"
	$"0FFF FFF8 07FF FFF0 07FF FFF0 03FF FFE0"
	$"03FF FFE0 03FF FFE0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 00FF FF80 001F FC00 0000 0000",
	$"0000 0000 0000 0000 0007 F000 0006 3000"
	$"0005 5000 0004 9000 0005 5000 07C6 31F0"
	$"0837 F608 1008 0804 11C4 11C4 2222 2222"
	$"2411 4412 2410 8412 2408 0812 2208 0822"
	$"1204 1024 1104 1044 0884 1088 045F FD10"
	$"03E0 07E0 0200 0020 0101 C040 0160 0340"
	$"0100 0040 008F F880 00F0 0780 0080 0080"
	$"0070 0700 000F F800 0000 0000 0000 0000",
	{	/* array ColorSpec: 13 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 4369, 4369, 4369,
		/* [13] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0FFF FFFF 0000 0000 0000"
	$"0000 0000 0000 0F50 229F 0000 0000 0000"
	$"0000 0000 0000 0F06 296F 0000 0000 0000"
	$"0000 0000 0000 0F22 962F 0000 0000 0000"
	$"0000 0000 0000 0F29 692F 0000 0000 0000"
	$"0000 0FFF FF00 0F96 229F 000F FFFF 0000"
	$"0000 F000 00FF 0FFF FFFF 0FF0 0111 F000"
	$"000F 0001 1112 F000 0000 F001 2222 2F00"
	$"000F 0119 9911 2F00 000F 0129 9922 2F00"
	$"00F0 0190 0091 12F0 00F1 2290 0091 24F0"
	$"00F0 1900 0009 222F 0F12 2900 0009 24F0"
	$"00F0 1900 0009 2222 F112 2900 0009 35F0"
	$"00F0 1900 0000 9223 5122 9000 0009 35F0"
	$"00F0 1290 0000 9333 5122 9000 0093 47F0"
	$"000F 1290 0000 0934 5229 0000 0093 5F00"
	$"000F 1239 0000 0934 5229 0000 0935 7F00"
	$"0000 F223 9000 0944 5229 0000 9357 F000"
	$"0000 0F23 492F FFFF FFFF FF29 359F 0000"
	$"0000 00FF FFF3 1222 2222 27FF FFF0 0000"
	$"0000 00F0 0111 1222 2222 2334 69F0 0000"
	$"0000 000F 1111 112A AA22 2345 9F00 0000"
	$"0000 000F 0991 1122 2222 34AA 9F00 0000"
	$"0000 000F 0111 1112 2223 4456 9F00 0000"
	$"0000 0000 F011 AFFF FFFF B559 F000 0000"
	$"0000 0000 FFFF 8887 6543 2FFF F000 0000"
	$"0000 0000 FA98 7533 2211 1100 F000 0000"
	$"0000 0000 0FFA 8322 1111 08FF 0000 0000"
	$"0000 0000 0006 ABFF FFFF A600 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (258) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"003E 3E00 007F 7F00 1F7F 7F7C 3FFF 7FFE"
	$"3FFF 7FFE 3FBE 3EFE 3FBE 3EFE 1F7F 7F7C"
	$"0FFF 7FF8 0FFF FFF8 0FFF FFF8 0FFF FFF8"
	$"0FFF FFF8 0FFF FFF8 07FF FFF0 07FF FFF0"
	$"07FF FFF0 03FF FFE0 03FF FFE0 03FF FFE0"
	$"01FF FFC0 01FF FFC0 01FF FFC0 00FF FF80"
	$"001F FC00 0000 0000 0000 0000 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 001C 1C00 0022 2200 0E22 2238"
	$"111C 1C44 1108 0844 0E14 1438 0414 1410"
	$"0622 2230 0522 2250 04A1 4290 0440 8110"
	$"0400 0010 021F FC20 03E0 03E0 0200 0020"
	$"0101 C040 0160 0340 0100 0040 008F F880"
	$"00F0 0780 0080 0080 0070 0700 000F F800"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 12 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 000F FF00 000F FF00 0000 0000"
	$"0000 0000 00F0 02F0 00F0 02F0 0000 0000"
	$"0000 FFF0 00F0 25F0 00F0 26F0 00FF F000"
	$"000F 002F 000F FF00 000F FF00 0F01 4F00"
	$"000F 024F 0000 F000 0000 F000 0F14 8F00"
	$"0000 FFF0 000F 0F00 000F 2F00 00FF F000"
	$"0000 0F00 000F 0F00 000F 2F00 000F 0000"
	$"0000 0FF0 00F0 12F0 00F2 23F0 00FF 0000"
	$"0000 0F0F 00F0 12F0 00F2 23F0 0F3F 0000"
	$"0000 0F00 F0F0 123F 0F22 24F0 F38F 0000"
	$"0000 0F00 1F11 1235 F222 346F 36AF 0000"
	$"0000 0F00 1451 1235 6222 3673 48AF 0000"
	$"0000 00F0 1249 9AAA AAAA AA24 6AF0 0000"
	$"0000 00F9 9991 1222 2222 23FF FFF0 0000"
	$"0000 00F0 0011 1222 2222 2356 8AF0 0000"
	$"0000 000F 0011 122A AA22 2468 AF00 0000"
	$"0000 000F 0991 1122 2222 35FF AF00 0000"
	$"0000 000F 0011 1122 2222 4568 AF00 0000"
	$"0000 0000 F011 FFFF FFFF F68A F000 0000"
	$"0000 0000 FFFF 8765 4433 2FFF F000 0000"
	$"0000 0000 FA87 6543 2222 1000 F000 0000"
	$"0000 0000 0FFF 6432 2211 1FFF 0000 0000"
	$"0000 0000 0000 FFFF FFFF F000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (259) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 07E7 E7E0"
	$"07FF FFE0 07FF FFE0 07FF FFE0 07FF FFE0"
	$"07FF FFE0 03FF FFC0 01FF FF80 00FF FF00"
	$"00FF FF00 00FF FF00 00FF FF00 00FF FF00"
	$"00FF FF00 00FF FF00 01FF FF80 01FF FF80"
	$"01FF FF80 03FF FFC0 03FF FFC0 03FF FFC0"
	$"07FF FFE0 07FF FFE0 07FF FFE0 07FF FFE0"
	$"07FF FFE0 07FF FFE0 0000 0000 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"03C3 C3C0 023C 3C40 0200 0040 0200 0040"
	$"0100 0080 0080 0100 007F FE00 0040 0200"
	$"0040 0200 0040 0200 0040 0200 0040 0200"
	$"0040 0200 0040 0200 007F FE00 0080 0100"
	$"0080 0100 0080 0100 0100 0080 0100 0080"
	$"0100 0080 0200 0040 0200 0040 0200 0040"
	$"03FF FFC0 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 12 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 30583, 30583, 30583,
		/* [8] */
		7, 21845, 21845, 21845,
		/* [9] */
		8, 17476, 17476, 17476,
		/* [10] */
		9, 8738, 8738, 8738,
		/* [11] */
		10, 4369, 4369, 4369,
		/* [12] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FF00 00FF FF00 00FF FF00 0000"
	$"0000 00F0 01F0 0F10 11F0 0F58 6F00 0000"
	$"0000 00F0 01FF FF10 11FF FF58 6F00 0000"
	$"0000 00F0 0100 0410 1164 4867 6F00 0000"
	$"0000 000F 0010 0411 1564 6686 F000 0000"
	$"0000 0000 F001 1144 4655 866F 0000 0000"
	$"0000 0000 0FFF FFFF FFFF FFF0 0000 0000"
	$"0000 0000 0F10 0420 6529 75F0 0000 0000"
	$"0000 0000 0F10 0422 6559 77F0 0000 0000"
	$"0000 0000 0F11 1444 666A 9AF0 0000 0000"
	$"0000 0000 0F01 0042 0652 97F0 0000 0000"
	$"0000 0000 0F01 0042 2655 97F0 0000 0000"
	$"0000 0000 0F01 1144 4666 AAF0 0000 0000"
	$"0000 0000 0F10 0420 6529 75F0 0000 0000"
	$"0000 0000 0F10 0422 6559 77F0 0000 0000"
	$"0000 0000 0F11 1444 6669 9AF0 0000 0000"
	$"0000 0000 F001 0041 0642 965F 0000 0000"
	$"0000 0000 F001 1144 4666 9AAF 0000 0000"
	$"0000 000F 0010 0410 6429 65A6 F000 0000"
	$"0000 000F 0010 0411 6439 66A6 F000 0000"
	$"0000 000F 0011 1444 6649 9AAA F000 0000"
	$"0000 00F0 0001 0041 0642 965A 6F00 0000"
	$"0000 00F0 0001 0041 1644 966A 6F00 0000"
	$"0000 00F0 0001 1144 4666 AAAA AF00 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FF00 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (260) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 001E 3C00 003F 7E00 003F 7E00"
	$"003F 7E00 003F 7E00 003F 7E00 003F FE00"
	$"007F FF00 00FF FF80 00FF FF80 01FF FFC0"
	$"01FF FFC0 01FF FFC0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 01FF FFC0 00FF FF80 00FF FF80"
	$"007F FF00 007F FF00 003F FE00 003F FE00"
	$"003F FE00 01FF FFC0 03FF FFE0 03FF FFE0"
	$"03FF FFE0 03FF 7FE0 01C0 01C0 0000 0000",
	$"0000 0000 0000 0000 000C 1800 0012 2400"
	$"0012 2400 000C 1800 000C 1800 0012 2400"
	$"0011 4400 0020 8200 0040 4100 0040 2100"
	$"0080 2080 0080 1080 0080 1080 0080 0880"
	$"0080 0880 0040 0900 0040 0900 0020 1200"
	$"0020 1200 0013 E400 000C 1800 0010 8400"
	$"0014 1400 0010 0400 00FF FF80 0101 4040"
	$"017E 3F40 0080 0080 0000 0000 0000 0000",
	{	/* array ColorSpec: 10 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 21845, 21845, 21845,
		/* [9] */
		8, 8738, 8738, 8738,
		/* [10] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FF00 000F F000 0000 0000"
	$"0000 0000 000F 02F0 00F0 3F00 0000 0000"
	$"0000 0000 000F 25F0 00F3 6F00 0000 0000"
	$"0000 0000 0000 FF00 000F F000 0000 0000"
	$"0000 0000 0000 FF00 000F F000 0000 0000"
	$"0000 0000 000F 02F0 00F0 2F00 0000 0000"
	$"0000 0000 000F 022F 0F02 2F00 0000 0000"
	$"0000 0000 00F0 2022 F633 22F0 0000 0000"
	$"0000 0000 0F02 3003 2F74 222F 0000 0000"
	$"0000 0000 0F02 0000 32F6 422F 3000 0000"
	$"0000 0000 8023 0000 32F7 6225 F000 0000"
	$"0000 0000 F020 0000 032F 6422 F000 0000"
	$"0000 0000 F020 0000 032F 7622 F000 0000"
	$"0000 0000 F030 0000 0032 F732 F000 0000"
	$"0000 0000 F030 0000 0042 F754 8000 0000"
	$"0000 0000 0F23 0000 0052 F758 3000 0000"
	$"0000 0000 0F23 0000 0055 F75F 0000 0000"
	$"0000 0000 00F2 3000 052F 76F0 0000 0000"
	$"0000 0000 00F2 2335 525F 75F0 0000 0000"
	$"0000 0000 000F 55FF FFF7 6F00 0000 0000"
	$"0000 0000 0000 FF00 000F F000 0000 0000"
	$"0000 0000 000F 0002 F224 5F00 0000 0000"
	$"0000 0000 000F 0F22 222F 5F00 0000 0000"
	$"0000 0000 000F 0228 F824 5F00 0000 0000"
	$"0000 0000 FFFF FFFF FFFF FFFF F000 0000"
	$"0000 000F 0024 444F 0F44 4441 1F00 0000"
	$"0000 000F 4FFF FFF0 00FF FFFF 6F00 0000"
	$"0000 0000 F000 0000 0000 0000 F000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (261) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 00FC 0000 00FE 0000"
	$"00FF 0000 00FF 8000 00FF E000 01FF F800"
	$"01FF FC00 03FF FE00 03FF FF00 07FF FF80"
	$"0FFF FF80 0FFF FFC0 1FFF FFC0 3FFF FFE0"
	$"3FFF FFE0 3FFF FFF0 3FFF FFF0 3FFF FFF0"
	$"1FEF FFF8 07DF FFF8 079F FFF8 003F FFF8"
	$"003F FFFC 003F FFFC 007F FFFC 007F FFFC"
	$"007F FFFC 007F FFFC 007F FFFC 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0048 0000"
	$"006C 0000 007E 0000 0049 0000 0048 C000"
	$"0080 3000 009C 2800 011A 0400 0100 0A00"
	$"0200 0900 0400 0900 0400 0280 0810 0280"
	$"1008 4240 1017 8240 1721 00A0 0942 00A0"
	$"0284 00A0 0304 0090 0008 0010 0008 0050"
	$"0010 0050 0010 0048 0010 0048 0020 0048"
	$"0020 0008 003F FFF8 0000 0000 0000 0000",
	{	/* array ColorSpec: 12 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0F00 F000 0000 0000 0000 0000"
	$"0000 0000 0FA0 FA00 0000 0000 0000 0000"
	$"0000 0000 0F0F F0F0 0000 0000 0000 0000"
	$"0000 0000 0F01 F14F 0000 0000 0000 0000"
	$"0000 0000 0F04 F041 F800 0000 0000 0000"
	$"0000 0000 F012 2224 51F8 0000 0000 0000"
	$"0000 0000 F049 FF22 2550 F000 0000 0000"
	$"0000 000F 014F 80F2 4251 0F00 0000 0000"
	$"0000 000F 0122 2222 2225 50F0 0000 0000"
	$"0000 00F0 1422 2222 2242 5108 0000 0000"
	$"0000 0F01 1222 2222 2422 511F 0000 0000"
	$"0000 0F01 4222 2222 4262 2210 8000 0000"
	$"0000 F014 2222 3344 4262 2251 F000 0000"
	$"0009 0142 2227 4424 5A12 2251 0800 0000"
	$"000F 9624 225F FAFF F012 2251 0F00 0000"
	$"000F 2FF9 25F0 000F 0122 2422 1080 0000"
	$"0000 9009 2F00 00F0 1222 2222 10F0 0000"
	$"0000 00F2 F000 0F01 2422 2222 50F0 0000"
	$"0000 00FF 0000 0F12 4322 2222 5108 0000"
	$"0000 0000 0000 F012 5322 2224 210F 0000"
	$"0000 0000 0000 F124 5322 2222 210F 0000"
	$"0000 0000 000F 0124 5322 2222 251F 0000"
	$"0000 0000 000F 1245 3222 2222 2510 F000"
	$"0000 0000 000F 1245 3222 2222 2510 F000"
	$"0000 0000 00F1 2245 3322 2222 2510 F000"
	$"0000 0000 00F1 2453 3322 2222 4251 F000"
	$"0000 0000 00FF FFFF FFFF FFFF FFFF F000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (262) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0003 E000"
	$"0007 F000 0007 F000 0007 F000 0007 F000"
	$"000F F800 001F FC00 003F FE00 003F FE00"
	$"003F FE00 003F FE00 0003 E000 0007 F000"
	$"0007 F000 0007 F000 000F F800 000F F800"
	$"000F F800 000F F800 000F F800 003F FE00"
	$"00FF FF80 01FF FFC0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 01FF FFC0 0000 0000 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0001 C000 0002 2000 0002 2000 0002 2000"
	$"0001 4000 0007 7000 0008 0800 0010 0400"
	$"001F FC00 0001 4000 0001 4000 0001 4000"
	$"0002 2000 0002 2000 0002 2000 0004 1000"
	$"0004 1000 0004 1000 0002 2000 0002 2000"
	$"001C 1C00 0060 0300 0080 0080 0080 0080"
	$"00FF FF80 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 10 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 000F FF00 0000 0000 0000"
	$"0000 0000 0000 00F0 02F0 0000 0000 0000"
	$"0000 0000 0000 00F0 13F0 0000 0000 0000"
	$"0000 0000 0000 00F1 37F0 0000 0000 0000"
	$"0000 0000 0000 000F 7F00 0000 0000 0000"
	$"0000 0000 0000 0FFF 3FFF 0000 0000 0000"
	$"0000 0000 0000 F000 1227 F000 0000 0000"
	$"0000 0000 000F 0011 2224 7F00 0000 0000"
	$"0000 0000 000F FFFF FFFF FF00 0000 0000"
	$"0000 0000 0000 000F 7F00 0000 0000 0000"
	$"0000 0000 0000 000F 3F00 0000 0000 0000"
	$"0000 0000 0000 000F 2F00 0000 0000 0000"
	$"0000 0000 0000 00F2 17F0 0000 0000 0000"
	$"0000 0000 0000 00F1 27F0 0000 0000 0000"
	$"0000 0000 0000 00F1 24F0 0000 0000 0000"
	$"0000 0000 0000 0F10 014F 0000 0000 0000"
	$"0000 0000 0000 0F00 126F 0000 0000 0000"
	$"0000 0000 0000 0F01 227F 0000 0000 0000"
	$"0000 0000 0000 00F3 37F0 0000 0000 0000"
	$"0000 0000 0000 00F1 37F0 0000 0000 0000"
	$"0000 0000 000F FF10 247F FF00 0000 0000"
	$"0000 0000 0FF1 0011 1145 77FF 0000 0000"
	$"0000 0000 F100 1111 1223 3477 F000 0000"
	$"0000 0000 F001 1111 1222 3337 F000 0000"
	$"0000 0000 8FFF FFFF FFFF FFFF 8000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (263) {
	4,
	{0, 0, 32, 32},
	1,
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 2 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		0, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (264) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0003 E000"
	$"0007 F000 0007 F000 0007 F000 0007 F000"
	$"000F F800 001F FC00 003F FE00 003F FE00"
	$"003F FE00 003F FE00 0003 E000 0007 F000"
	$"0007 F000 0007 F000 000F F800 000F F800"
	$"000F F800 000F F800 000F F800 003F FE00"
	$"00FF FF80 01FF FFC0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 01FF FFC0 0000 0000 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0001 C000 0003 E000 0003 E000 0003 E000"
	$"0001 C000 0007 F000 000F F800 001F FC00"
	$"001F FC00 0001 C000 0001 C000 0001 C000"
	$"0003 E000 0003 E000 0003 E000 0007 F000"
	$"0007 F000 0007 F000 0003 E000 0003 E000"
	$"001F FC00 007F FF00 00FF FF80 00FF FF80"
	$"00FF FF80 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 11 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 52428, 52428, 52428,
		/* [4] */
		3, 48059, 48059, 48059,
		/* [5] */
		4, 43690, 43690, 43690,
		/* [6] */
		5, 30583, 30583, 30583,
		/* [7] */
		6, 21845, 21845, 21845,
		/* [8] */
		7, 17476, 17476, 17476,
		/* [9] */
		8, 8738, 8738, 8738,
		/* [10] */
		9, 4369, 4369, 4369,
		/* [11] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 000F FF00 0000 0000 0000"
	$"0000 0000 0000 00F0 27F0 0000 0000 0000"
	$"0000 0000 0000 00F2 59F0 0000 0000 0000"
	$"0000 0000 0000 00F7 9FF0 0000 0000 0000"
	$"0000 0000 0000 000F 9F00 0000 0000 0000"
	$"0000 0000 0000 0FFF 9FFF 0000 0000 0000"
	$"0000 0000 0000 F022 6678 F000 0000 0000"
	$"0000 0000 000F 0256 6889 FF00 0000 0000"
	$"0000 0000 000F FFFF FFFF FF00 0000 0000"
	$"0000 0000 0000 000F 8F00 0000 0000 0000"
	$"0000 0000 0000 000F 7F00 0000 0000 0000"
	$"0000 0000 0000 000F 7F00 0000 0000 0000"
	$"0000 0000 0000 00F4 78F0 0000 0000 0000"
	$"0000 0000 0000 00F4 78F0 0000 0000 0000"
	$"0000 0000 0000 00F2 58F0 0000 0000 0000"
	$"0000 0000 0000 0F03 578F 0000 0000 0000"
	$"0000 0000 0000 0F25 578F 0000 0000 0000"
	$"0000 0000 0000 0F45 789F 0000 0000 0000"
	$"0000 0000 0000 00F7 89F0 0000 0000 0000"
	$"0000 0000 0000 00F8 9FF0 0000 0000 0000"
	$"0000 0000 000F FF14 778F FF00 0000 0000"
	$"0000 0000 0FF0 1155 6788 88FF 0000 0000"
	$"0000 0000 F015 5566 6888 888F F000 0000"
	$"0000 0000 F455 5666 8888 889F F000 0000"
	$"0000 0000 FFFF FFFF FFFF FFFF F000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (265) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 00FC 0000 00FE 0000"
	$"00FF 0000 00FF 8000 00FF E000 01FF F800"
	$"01FF FC00 03FF FE00 03FF FF00 07FF FF80"
	$"0FFF FF80 0FFF FFC0 1FFF FFC0 3FFF FFE0"
	$"3FFF FFE0 3FFF FFF0 3FFF FFF0 3FFF FFF0"
	$"1FEF FFF8 07DF FFF8 079F FFF8 003F FFF8"
	$"003F FFFC 003F FFFC 007F FFFC 007F FFFC"
	$"007F FFFC 007F FFFC 007F FFFC 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0048 0000"
	$"006C 0000 007E 0000 0077 0000 007F C000"
	$"00FF F000 00E7 D800 01EB FC00 01FF F600"
	$"03FF F700 07FF F700 07FF FD80 0FEF FD80"
	$"19FF 7DC0 1FF6 FDC0 1FE1 FF60 09C3 FF60"
	$"0387 FF60 0307 FF70 000F FFF0 000F FFB0"
	$"001F FFB0 001F FFB8 001F FFB8 003F FFB8"
	$"003F FFF8 003F FFF8 0000 0000 0000 0000",
	{	/* array ColorSpec: 11 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 48059, 48059, 48059,
		/* [4] */
		3, 34952, 34952, 34952,
		/* [5] */
		4, 30583, 30583, 30583,
		/* [6] */
		5, 21845, 21845, 21845,
		/* [7] */
		6, 17476, 17476, 17476,
		/* [8] */
		7, 8738, 8738, 8738,
		/* [9] */
		8, 4369, 4369, 4369,
		/* [10] */
		9, 43690, 43690, 43690,
		/* [11] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0F00 F000 0000 0000 0000 0000"
	$"0000 0000 0FF0 FF00 0000 0000 0000 0000"
	$"0000 0000 0F2F F2F0 0000 0000 0000 0000"
	$"0000 0000 0F26 F26F 0000 0000 0000 0000"
	$"0000 0000 0F26 F35F FF00 0000 0000 0000"
	$"0000 0000 F127 7777 7FFF 0000 0000 0000"
	$"0000 0000 F16F FF77 7FFF F000 0000 0000"
	$"0000 000F 1369 97F7 75FF FF00 0000 0000"
	$"0000 000F 1277 7477 5F77 FFF0 0000 0000"
	$"0000 00F1 2377 7777 7775 FFFF 0000 0000"
	$"0000 0F12 2777 7777 7675 FFFF 0000 0000"
	$"0000 0F12 3777 7777 676F 77FF F000 0000"
	$"0000 F123 7777 7666 6767 77FF F000 0000"
	$"000F 1237 7777 6667 7767 75FF FF00 0000"
	$"000F 8113 377F FFFF F167 75FF FF00 0000"
	$"000F 1FF5 17F0 000F 1467 5F77 FFF0 0000"
	$"0000 F00F 1F00 00F1 2577 7777 FFF0 0000"
	$"0000 00F1 F000 0F12 3677 7775 FFF0 0000"
	$"0000 00FF 0000 0F23 5777 7775 FFFF 0000"
	$"0000 0000 0000 F123 7777 775F 7FFF 0000"
	$"0000 0000 0000 F235 7777 7777 7FFF 0000"
	$"0000 0000 000F 1235 7777 7777 7FFF 0000"
	$"0000 0000 000F 2357 7777 7777 7FFF F000"
	$"0000 0000 000F 2357 7777 7777 5FFF F000"
	$"0000 0000 00F2 2357 7777 7777 5FFF F000"
	$"0000 0000 00F2 3577 7777 7775 F7FF F000"
	$"0000 0000 00FF FFFF FFFF FFFF FFFF F000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (266) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 001E 3C00 003F 7E00 003F 7E00"
	$"003F 7E00 003F 7E00 003F 7E00 003F FE00"
	$"007F FF00 00FF FF80 00FF FF80 01FF FFC0"
	$"01FF FFC0 01FF FFC0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 01FF FFC0 00FF FF80 00FF FF80"
	$"007F FF00 007F FF00 003F FE00 003F FE00"
	$"003F FE00 01FF FFC0 03FF FFE0 03FF FFE0"
	$"03FF FFE0 03FF 7FE0 01C0 01C0 0000 0000",
	$"0000 0000 0000 0000 000C 1800 001E 3C00"
	$"001E 3C00 000C 1800 000C 1800 001E 3C00"
	$"001F 7C00 003F BE00 007F DF00 007F EF00"
	$"00FF EF80 00FF F780 00FF F780 00FF FB80"
	$"00FF FB80 007F FB00 007F FB00 003F F600"
	$"003F F600 001C 1C00 0003 E000 001F 7C00"
	$"001B EC00 001F FC00 00FC 1F80 01FF FFC0"
	$"01FE 3FC0 0080 0080 0000 0000 0000 0000",
	{	/* array ColorSpec: 12 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 48059, 48059, 48059,
		/* [5] */
		4, 43690, 43690, 43690,
		/* [6] */
		5, 34952, 34952, 34952,
		/* [7] */
		6, 30583, 30583, 30583,
		/* [8] */
		7, 21845, 21845, 21845,
		/* [9] */
		8, 17476, 17476, 17476,
		/* [10] */
		9, 8738, 8738, 8738,
		/* [11] */
		10, 4369, 4369, 4369,
		/* [12] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 FF00 000F F000 0000 0000"
	$"0000 0000 000F 05F0 00F1 6F00 0000 0000"
	$"0000 0000 000F 58F0 00F6 9F00 0000 0000"
	$"0000 0000 0000 FF00 000F F000 0000 0000"
	$"0000 0000 0000 FF00 000F F000 0000 0000"
	$"0000 0000 000F 03F0 00F1 4F00 0000 0000"
	$"0000 0000 000F 076F 0F16 6F00 0000 0000"
	$"0000 0000 00F0 7676 F967 66F0 0000 0000"
	$"0000 0000 0F07 6667 6F98 766F 0000 0000"
	$"0000 0000 0F07 6666 96F9 876F 0000 0000"
	$"0000 0000 F076 6666 97F9 8866 F000 0000"
	$"0000 0000 F075 6666 697F 9876 F000 0000"
	$"0000 0000 F076 6666 697F 9886 F000 0000"
	$"0000 0000 F076 6666 6697 F987 F000 0000"
	$"0000 0000 F176 6666 6697 F988 F000 0000"
	$"0000 0000 7576 6666 6697 F98F 8000 0000"
	$"0000 0000 0F59 6666 6697 F98F 0000 0000"
	$"0000 0000 04F7 9666 698F 98F0 0000 0000"
	$"0000 0000 00F7 8999 987F 98F0 0000 0000"
	$"0000 0000 000F 78FF FFFA 9F00 0000 0000"
	$"0000 0000 0000 FF01 133F F000 0000 0000"
	$"0000 0000 000F 0128 F888 8F00 0000 0000"
	$"0000 0000 000F 1F88 888F 8F00 0000 0000"
	$"0000 0000 000F 388F FF88 8F00 0000 0000"
	$"0000 0000 FFFF FFFF FFFF FFFF F000 0000"
	$"0000 000F 2269 999F 0F99 9998 8F00 0000"
	$"0000 000F 9FFF FFF0 00FF FFFF 9F00 0000"
	$"0000 0000 F000 0000 0000 0000 F000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (267) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 07E7 E7E0"
	$"07FF FFE0 07FF FFE0 07FF FFE0 07FF FFE0"
	$"07FF FFE0 03FF FFC0 01FF FF80 00FF FF00"
	$"00FF FF00 00FF FF00 00FF FF00 00FF FF00"
	$"00FF FF00 00FF FF00 01FF FF80 01FF FF80"
	$"01FF FF80 03FF FFC0 03FF FFC0 03FF FFC0"
	$"07FF FFE0 07FF FFE0 07FF FFE0 07FF FFE0"
	$"07FF FFE0 07FF FFE0 0000 0000 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"03C3 C3C0 03FF FFC0 03FF FFC0 03FF FFC0"
	$"01FF FF80 00FF FF00 0040 0200 007F FE00"
	$"007F FE00 007F FE00 007F FE00 007F FE00"
	$"007F FE00 007F FE00 0040 0200 00FF FF00"
	$"00FF FF00 00FF FF00 01FF FF80 01FF FF80"
	$"01FF FF80 03FF FFC0 03FF FFC0 03FF FFC0"
	$"03FF FFC0 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 9 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 52428, 52428, 52428,
		/* [3] */
		2, 48059, 48059, 48059,
		/* [4] */
		3, 34952, 34952, 34952,
		/* [5] */
		4, 30583, 30583, 30583,
		/* [6] */
		5, 21845, 21845, 21845,
		/* [7] */
		6, 17476, 17476, 17476,
		/* [8] */
		7, 8738, 8738, 8738,
		/* [9] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 00FF FF00 00FF FF00 00FF FF00 0000"
	$"0000 00F2 13F0 0F32 33F0 0F7F FF00 0000"
	$"0000 00F2 13FF FF32 33FF FF7F FF00 0000"
	$"0000 00F2 2321 1632 33F6 6FFF FF00 0000"
	$"0000 000F 2232 2633 37F6 FFFF F000 0000"
	$"0000 0000 F223 3366 6F77 FFFF 0000 0000"
	$"0000 0000 0FFF FFFF FFFF FFF0 0000 0000"
	$"0000 0000 0F32 1642 F74F F7F0 0000 0000"
	$"0000 0000 0F32 2644 F77F FFF0 0000 0000"
	$"0000 0000 0F33 3666 FFFF FFF0 0000 0000"
	$"0000 0000 0F13 2164 2F74 FFF0 0000 0000"
	$"0000 0000 0F13 2264 4F77 FFF0 0000 0000"
	$"0000 0000 0F23 3366 6FFF FFF0 0000 0000"
	$"0000 0000 0F32 1642 F74F F7F0 0000 0000"
	$"0000 0000 0F32 2644 F77F FFF0 0000 0000"
	$"0000 0000 0F33 3666 FFFF FFF0 0000 0000"
	$"0000 0000 F213 2163 2F64 FF7F 0000 0000"
	$"0000 0000 F223 3366 6FFF FFFF 0000 0000"
	$"0000 000F 2132 1632 F64F F7FF F000 0000"
	$"0000 000F 2132 2633 F65F FFFF F000 0000"
	$"0000 000F 2233 3666 FF6F FFFF F000 0000"
	$"0000 00F1 2113 2163 2F64 FF7F FF00 0000"
	$"0000 00F1 2113 2263 3F66 FFFF FF00 0000"
	$"0000 00F2 2223 3366 6FFF FFFF FF00 0000"
	$"0000 00FF FFFF FFFF FFFF FFFF FF00 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (268) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"003E 3E00 007F 7F00 1F7F 7F7C 3FFF 7FFE"
	$"3FFF 7FFE 3FBE 3EFE 3FBE 3EFE 1F7F 7F7C"
	$"0FFF 7FF8 0FFF FFF8 0FFF FFF8 0FFF FFF8"
	$"0FFF FFF8 0FFF FFF8 07FF FFF0 07FF FFF0"
	$"07FF FFF0 03FF FFE0 03FF FFE0 03FF FFE0"
	$"01FF FFC0 01FF FFC0 01FF FFC0 00FF FF80"
	$"001F FC00 0000 0000 0000 0000 0000 0000",
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 001C 1C00 003E 3E00 0E3E 3E38"
	$"1F1C 1C7C 1F08 087C 0E1C 1C38 041C 1C10"
	$"063E 3E30 073E 3E70 07BF 7EF0 07FF FFF0"
	$"07FF FFF0 03E0 03E0 021F FC20 03FE 3FE0"
	$"01FF FFC0 019F FCC0 01FF FFC0 00F0 0780"
	$"008F F880 00FF FF80 007F FF00 000F F800"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 13 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 4369, 4369, 4369,
		/* [13] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 000F FF00 000F FF00 0000 0000"
	$"0000 0000 00F0 37F0 00F0 38F0 0000 0000"
	$"0000 FFF0 00F3 79F0 00F3 8AF0 00FF F000"
	$"000F 036F 000F FF00 000F FF00 0F03 9F00"
	$"000F 268F 0000 F000 0000 F000 0F39 BF00"
	$"0000 FFF0 000F 3F00 000F 6F00 00FF F000"
	$"0000 0F00 000F 3F00 000F 6F00 000F 0000"
	$"0000 0FF0 00F3 57F0 00F6 7AA0 00FF 0000"
	$"0000 0F0F 00F3 57F0 00F6 8AF0 0FAF 0000"
	$"0000 0F03 F0F3 568F 0F67 8AF0 F9AF 0000"
	$"0000 0F03 6F34 5668 F668 8AAF 9AFF 0000"
	$"0000 0A01 4674 5678 9678 AAA8 ABF9 0000"
	$"0000 05F0 367F FFFF FFFF FF9A BFF5 0000"
	$"0000 00FF FFF4 5677 8888 9AFF FFF0 0000"
	$"0000 00F0 1444 5677 8888 9AAA BFF0 0000"
	$"0000 000F 0445 667F FF88 AAAB FF00 0000"
	$"0000 000F 0FF5 6677 8889 AAFF FF00 0000"
	$"0000 000F 0145 6667 888A AABF FF00 0000"
	$"0000 0000 F056 FFFF FFFF FFFF F000 0000"
	$"0000 0000 FFFF BBA9 8887 66FF F000 0000"
	$"0000 0000 FFFB BA98 8766 5550 F000 0000"
	$"0000 0000 0FFF BA98 7665 5FFF 0000 0000"
	$"0000 0000 0000 FFFF FFFF F000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (269) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 000F F800 000F F800 000F F800"
	$"000F F800 000F F800 0FEF FBF8 1FFF FFFC"
	$"3FFF FFFE 3FFF FFFE 7FFF FFFF 7FFF FFFF"
	$"7FFF FFFF 7FFF FFFF 7FFF FFFF 7FFF FFFF"
	$"7FFF FFFF 3FFF FFFE 3FFF FFFE 1FFF FFFC"
	$"0FFF FFF8 07FF FFF0 07FF FFF0 03FF FFE0"
	$"03FF FFE0 03FF FFE0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 00FF FF80 001F FC00 0000 0000",
	$"0000 0000 0000 0000 0007 F000 0005 D000"
	$"0006 B000 0007 7000 0006 B000 07C5 D1F0"
	$"0FF7 F7F8 1FF8 0FFC 1E3C 1E3C 3DDE 3DDE"
	$"3BEF 7BEE 3BEF FBEE 3BF7 F7EE 3DF7 F7DE"
	$"1DFB EFDC 1EFB EFBC 0F7B EF78 07A0 02F0"
	$"021F FC20 03FF FFE0 01FE 3FC0 019F FCC0"
	$"01FF FFC0 00F0 0780 008F F880 00FF FF80"
	$"007F FF00 000F F800 0000 0000 0000 0000",
	{	/* array ColorSpec: 13 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 4369, 4369, 4369,
		/* [13] */
		15, 0, 0, 0
	},
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0FFF FFFF 0000 0000 0000"
	$"0000 0000 0000 0F80 58FF 0000 0000 0000"
	$"0000 0000 0000 0F0A 8FAF 0000 0000 0000"
	$"0000 0000 0000 0F58 FA9F 0000 0000 0000"
	$"0000 0000 0000 0F8F AF9F 0000 0000 0000"
	$"0000 0FFF FF00 0FFA 99FF 000F FFFF 0000"
	$"0000 F002 33FF 0FFF FFFF 0FF2 2444 F000"
	$"000F 0055 5568 F000 0000 F224 7888 4F00"
	$"0088 055F FF68 8F00 000F 247F FF88 8780"
	$"00F0 55FA AAF8 88F0 00F2 47FA AAF8 8AF0"
	$"00F2 5FAA AAAF 888F 0F24 7FAA AAAF 8AF0"
	$"00F2 5FAA AAAF 8888 F247 7FAA AAAF 8AF0"
	$"00F3 5FAA AAAA F888 9557 FAAA AAAF 8AF0"
	$"00A3 55FA AAAA F888 9577 FAAA AAF8 AFA0"
	$"0009 55FA AAAA AF88 977F AAAA AAF8 AF00"
	$"000A 555F AAAA AF88 977F AAAA AF8A FA00"
	$"0000 F655 FAAA AFF8 97FF AAAA F8AF F000"
	$"0000 0F86 5FAF FFFF FFFF FFAF 8AFF 0000"
	$"0000 00FF FFF5 5688 8888 99FF FFF0 0000"
	$"0000 00F1 2255 6888 8888 99AA AFF0 0000"
	$"0000 000F 1256 688F FF89 9AAA AF00 0000"
	$"0000 000F 1FF6 8888 8889 9AAA FF00 0000"
	$"0000 000F 1256 8888 8899 AAAB FF00 0000"
	$"0000 0000 F168 FFFF FFFF FFBF F000 0000"
	$"0000 0000 FFFF AAA9 9888 77FF F000 0000"
	$"0000 0000 FFFA AA99 8887 7660 F000 0000"
	$"0000 0000 0FFF A998 8877 6FFF 0000 0000"
	$"0000 0000 0000 FFFF FFFF F000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (270) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0007 F000 0007 F000"
	$"0007 F000 0007 F000 0007 F000 07C7 F1F0"
	$"0FF7 F7F8 1FF8 0FFC 1FFC 1FFC 3FFE 3FFE"
	$"3FFF 7FFE 3FFF FFFE 3FFF FFFE 3FFF FFFE"
	$"1FFF FFFC 1FFF FFFC 0FFF FFF8 07FF FFF0"
	$"03FF FFE0 03FF FFE0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 00FF FF80 00FF FF80 00FF FF80"
	$"007F FF00 000F F800 0000 0000 0000 0000",
	$"1111 1111 2220 0222 4447 F444 8886 3088"
	$"1115 5111 2224 9222 4005 5404 87C6 31F0"
	$"0837 F609 1008 0804 11C4 11C4 A222 2222"
	$"2411 4412 2410 8412 2408 0812 A208 0822"
	$"1204 1024 1104 1044 4884 1088 845F FD10"
	$"13E0 03E1 2200 0022 4101 C044 8960 0348"
	$"1100 0051 208F F882 44F0 0784 8880 0088"
	$"1070 0711 220F F822 4440 0044 8888 8888",
	{	/* array ColorSpec: 14 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 4369, 4369, 4369,
		/* [13] */
		12, 13107, 39321, 26214,
		/* [14] */
		15, 0, 0, 0
	},
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CFFF FFFF CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF50 229F CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF06 296F CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF22 962F CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF29 692F CCCC CCCC CCCC"
	$"CCCC CFFF FFCC CF96 229F CCCF FFFF CCCC"
	$"CCCC F000 00FF CFFF FFFF CFF0 0111 FCCC"
	$"CCCF 0001 1112 FCCC CCCC F001 2222 2FCC"
	$"CCCF 0119 9911 2FCC CCCF 0129 9922 2FCC"
	$"CCF0 0190 0091 12FC CCF1 2290 0091 24FC"
	$"CCF0 1900 0009 222F CF12 2900 0009 24FC"
	$"CCF0 1900 0009 2222 F112 2900 0009 35FC"
	$"CCF0 1900 0000 9223 5122 9000 0009 35FC"
	$"CCF0 1290 0000 9333 5122 9000 0093 47FC"
	$"CCCF 1290 0000 0934 5229 0000 0093 5FCC"
	$"CCCF 1239 0000 0934 5229 0000 0935 7FCC"
	$"CCCC F223 9000 0944 5229 0000 9357 FCCC"
	$"CCCC CF23 492F FFFF FFFF FF29 359F CCCC"
	$"CCCC CCFF FFF3 1222 2222 27FF FFFC CCCC"
	$"CCCC CCF0 0111 1222 2222 2334 69FC CCCC"
	$"CCCC CCCF 1111 112A AA22 2345 9FCC CCCC"
	$"CCCC CCCF 0991 1122 2222 34AA 9FCC CCCC"
	$"CCCC CCCF 0111 1112 2223 4456 9FCC CCCC"
	$"CCCC CCCC F011 AFFF FFFF B559 FCCC CCCC"
	$"CCCC CCCC FFFF 8887 6543 2FFF FCCC CCCC"
	$"CCCC CCCC FA98 7533 2211 1100 FCCC CCCC"
	$"CCCC CCCC CFFA 8322 1111 08FF CCCC CCCC"
	$"CCCC CCCC CCC6 ABFF FFFF A6CC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
};

resource 'cicn' (271) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 001C 1C00 003E 3E00 0E3E 3E38"
	$"1F1C 1C7C 1F08 087C 0E1C 1C38 041C 1C10"
	$"063E 3E30 073E 3E70 07BF 7EF0 07FF FFF0"
	$"07FF FFF0 03FF FFE0 03FF FFE0 03FF FFE0"
	$"01FF FFC0 01FF FFC0 01FF FFC0 00FF FF80"
	$"00FF FF80 00FF FF80 007F FF00 000F F800"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1101 0111 221C 1C22 4022 2200 8E22 A238"
	$"111C 1C45 1108 0844 4E54 5438 8494 9490"
	$"1622 2231 2522 2252 44A1 4294 8440 8110"
	$"1400 0011 221F FC22 43E0 03E4 8A00 0028"
	$"1101 C041 2160 0342 4500 0044 888F F888"
	$"10F0 0791 2280 00A2 4470 0704 880F F808"
	$"1100 0111 2222 2222 4444 4444 8888 8888",
	{	/* array ColorSpec: 13 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 13107, 39321, 26214,
		/* [13] */
		15, 0, 0, 0
	},
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBF FFBB BBBF FFBB BBBB BBBB"
	$"BBBB BBBB BBF0 02FB BBF0 02FB BBBB BBBB"
	$"BBBB FFFB BBF0 25FB BBF0 26FB BBFF FBBB"
	$"BBBF 002F BBBF FFBB BBBF FFBB BF01 4FBB"
	$"BBBF 024F BBBB FBBB BBBB FBBB BF14 8FBB"
	$"BBBB FFFB BBBF 0FBB BBBF 2FBB BBFF FBBB"
	$"BBBB BFBB BBBF 0FBB BBBF 2FBB BBBF BBBB"
	$"BBBB BFFB BBF0 12FB BBF2 23FB BBFF BBBB"
	$"BBBB BF0F BBF0 12FB BBF2 23FB BF3F BBBB"
	$"BBBB BF00 FBF0 123F BF22 24FB F38F BBBB"
	$"BBBB BF00 1F11 1235 F222 346F 36AF BBBB"
	$"BBBB BF00 1451 1235 6222 3673 48AF BBBB"
	$"BBBB BBF0 1249 9AAA AAAA AA24 6AFB BBBB"
	$"BBBB BBF9 9991 1222 2222 23FF FFFB BBBB"
	$"BBBB BBF0 0011 1222 2222 2356 8AFB BBBB"
	$"BBBB BBBF 0011 122A AA22 2468 AFBB BBBB"
	$"BBBB BBBF 0991 1122 2222 35FF AFBB BBBB"
	$"BBBB BBBF 0011 1122 2222 4568 AFBB BBBB"
	$"BBBB BBBB F011 FFFF FFFF F68A FBBB BBBB"
	$"BBBB BBBB FFFF 8765 4433 2FFF FBBB BBBB"
	$"BBBB BBBB FA87 6543 2222 1000 FBBB BBBB"
	$"BBBB BBBB BFFF 6432 2211 1FFF BBBB BBBB"
	$"BBBB BBBB BBBB FFFF FFFF FBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
};

resource 'cicn' (272) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"03C3 C3C0 03E7 E7C0 03FF FFC0 03FF FFC0"
	$"01FF FF80 00FF FF00 007F FE00 007F FE00"
	$"007F FE00 007F FE00 007F FE00 007F FE00"
	$"007F FE00 007F FE00 007F FE00 00FF FF00"
	$"00FF FF00 00FF FF00 01FF FF80 01FF FF80"
	$"01FF FF80 03FF FFC0 03FF FFC0 03FF FFC0"
	$"03FF FFC0 0000 0000 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4444 4444 8808 0808"
	$"13C3 C3D1 223C 3C42 4200 0044 8A00 0048"
	$"1100 0091 2080 0122 447F FE44 8840 0288"
	$"1140 0211 2240 0222 4440 0244 8840 0288"
	$"1140 0211 2240 0222 447F FE44 8880 0108"
	$"1080 0111 2080 0122 4500 0084 8900 0088"
	$"1100 0091 2200 0042 4200 0044 8A00 0048"
	$"13FF FFD1 2000 0002 4444 4444 8888 8888",
	{	/* array ColorSpec: 13 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 30583, 30583, 30583,
		/* [8] */
		7, 21845, 21845, 21845,
		/* [9] */
		8, 17476, 17476, 17476,
		/* [10] */
		9, 8738, 8738, 8738,
		/* [11] */
		10, 4369, 4369, 4369,
		/* [12] */
		11, 13107, 39321, 26214,
		/* [13] */
		15, 0, 0, 0
	},
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBFF FFBB BBFF FFBB BBFF FFBB BBBB"
	$"BBBB BBF0 01FB BF10 11FB BF58 6FBB BBBB"
	$"BBBB BBF0 01FF FF10 11FF FF58 6FBB BBBB"
	$"BBBB BBF0 0100 0410 1164 4867 6FBB BBBB"
	$"BBBB BBBF 0010 0411 1564 6686 FBBB BBBB"
	$"BBBB BBBB F001 1144 4655 866F BBBB BBBB"
	$"BBBB BBBB BFFF FFFF FFFF FFFB BBBB BBBB"
	$"BBBB BBBB BF10 0420 6529 75FB BBBB BBBB"
	$"BBBB BBBB BF10 0422 6559 77FB BBBB BBBB"
	$"BBBB BBBB BF11 1444 666A 9AFB BBBB BBBB"
	$"BBBB BBBB BF01 0042 0652 97FB BBBB BBBB"
	$"BBBB BBBB BF01 0042 2655 97FB BBBB BBBB"
	$"BBBB BBBB BF01 1144 4666 AAFB BBBB BBBB"
	$"BBBB BBBB BF10 0420 6529 75FB BBBB BBBB"
	$"BBBB BBBB BF10 0422 6559 77FB BBBB BBBB"
	$"BBBB BBBB BF11 1444 6669 9AFB BBBB BBBB"
	$"BBBB BBBB F001 0041 0642 965F BBBB BBBB"
	$"BBBB BBBB F001 1144 4666 9AAF BBBB BBBB"
	$"BBBB BBBF 0010 0410 6429 65A6 FBBB BBBB"
	$"BBBB BBBF 0010 0411 6439 66A6 FBBB BBBB"
	$"BBBB BBBF 0011 1444 6649 9AAA FBBB BBBB"
	$"BBBB BBF0 0001 0041 0642 965A 6FBB BBBB"
	$"BBBB BBF0 0001 0041 1644 966A 6FBB BBBB"
	$"BBBB BBF0 0001 1144 4666 AAAA AFBB BBBB"
	$"BBBB BBFF FFFF FFFF FFFF FFFF FFBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
};

resource 'cicn' (273) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 000C 1800 001E 3C00"
	$"001E 3C00 000C 1800 000C 1800 001E 3C00"
	$"001F 7C00 003F FE00 007F FF00 007F FF00"
	$"00FF FF80 00FF FF80 00FF FF80 00FF FF80"
	$"00FF FF80 007F FF00 007F FF00 003F FE00"
	$"003F FE00 001F FC00 000F F800 001F FC00"
	$"001F FC00 001F FC00 00FF FF80 01FF 7FC0"
	$"01FE 3FC0 0080 0080 0000 0000 0000 0000",
	$"1111 1111 2220 0222 444C 1844 8892 A488"
	$"1112 2511 220C 1822 444C 1844 8892 2488"
	$"1111 4411 2220 8222 4440 4144 8840 2108"
	$"1080 2091 2280 10A2 4480 1084 8880 0888"
	$"1080 0891 2240 0922 4440 0944 8820 1208"
	$"1120 1211 2213 E422 444C 1844 8890 8488"
	$"1114 1511 2210 0422 44FF FF84 8901 4048"
	$"117E 3F51 2080 0082 4404 4404 8888 8888",
	{	/* array ColorSpec: 11 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 21845, 21845, 21845,
		/* [9] */
		8, 8738, 8738, 8738,
		/* [10] */
		9, 13107, 39321, 26214,
		/* [11] */
		15, 0, 0, 0
	},
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 FF99 999F F999 9999 9999"
	$"9999 9999 999F 02F9 99F0 3F99 9999 9999"
	$"9999 9999 999F 25F9 99F3 6F99 9999 9999"
	$"9999 9999 9999 FF99 999F F999 9999 9999"
	$"9999 9999 9999 FF99 999F F999 9999 9999"
	$"9999 9999 999F 02F9 99F0 2F99 9999 9999"
	$"9999 9999 999F 022F 9F02 2F99 9999 9999"
	$"9999 9999 99F0 2022 F633 22F9 9999 9999"
	$"9999 9999 9F02 3003 2F74 222F 9999 9999"
	$"9999 9999 9F02 0000 32F6 422F 9999 9999"
	$"9999 9999 8023 0000 32F7 6225 F999 9999"
	$"9999 9999 F020 0000 032F 6422 F999 9999"
	$"9999 9999 F020 0000 032F 7622 F999 9999"
	$"9999 9999 F030 0000 0032 F732 F999 9999"
	$"9999 9999 F030 0000 0042 F754 8999 9999"
	$"9999 9999 9F23 0000 0052 F758 9999 9999"
	$"9999 9999 9F23 0000 0055 F75F 9999 9999"
	$"9999 9999 99F2 3000 052F 76F9 9999 9999"
	$"9999 9999 99F2 2335 525F 75F9 9999 9999"
	$"9999 9999 999F 55FF FFF7 6F99 9999 9999"
	$"9999 9999 9999 FF00 000F F999 9999 9999"
	$"9999 9999 999F 0002 F224 5F99 9999 9999"
	$"9999 9999 999F 0F22 222F 5F99 9999 9999"
	$"9999 9999 999F 0228 F824 5F99 9999 9999"
	$"9999 9999 FFFF FFFF FFFF FFFF F999 9999"
	$"9999 999F 0024 444F 9F44 4441 1F99 9999"
	$"9999 999F 4FFF FFF9 99FF FFFF 6F99 9999"
	$"9999 9999 F999 9999 9999 9999 F999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
};

resource 'cicn' (274) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0048 0000"
	$"006C 0000 007E 0000 007F 0000 007F C000"
	$"00FF F000 00FF F800 01FF FC00 01FF FE00"
	$"03FF FF00 07FF FF00 07FF FF80 0FFF FF80"
	$"1FFF FFC0 1FF7 FFC0 1FE1 FFE0 09C3 FFE0"
	$"0387 FFE0 0307 FFF0 000F FFF0 000F FFF0"
	$"001F FFF0 001F FFF8 001F FFF8 003F FFF8"
	$"003F FFF8 003F FFF8 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4400 4444 8848 8888"
	$"116C 1111 227E 2222 4449 0444 8848 C088"
	$"1080 3111 209C 2822 451A 0444 8900 0A08"
	$"1200 0911 2400 0922 4400 0284 8810 0288"
	$"1008 4251 1017 8242 5721 00A4 8942 00A8"
	$"1284 00A1 2124 0092 4448 0034 8888 0050"
	$"1110 0051 2210 004A 4410 0048 88A0 0048"
	$"1120 0009 223F FFFA 4400 0000 8888 8888",
	{	/* array ColorSpec: 13 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 13107, 39321, 26214,
		/* [13] */
		15, 0, 0, 0
	},
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BFBB FBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BFAB FABB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BF0F F0FB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BF01 F14F BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BF04 F041 F8BB BBBB BBBB BBBB"
	$"BBBB BBBB F012 2224 51F8 BBBB BBBB BBBB"
	$"BBBB BBBB F049 FF22 2550 FBBB BBBB BBBB"
	$"BBBB BBBF 014F 80F2 4251 0FBB BBBB BBBB"
	$"BBBB BBBF 0122 2222 2225 50FB BBBB BBBB"
	$"BBBB BBF0 1422 2222 2242 5108 BBBB BBBB"
	$"BBBB BF01 1222 2222 2422 511F BBBB BBBB"
	$"BBBB BF01 4222 2222 4262 2210 8BBB BBBB"
	$"BBBB F014 2222 3344 4262 2251 FBBB BBBB"
	$"BBB9 0142 2227 4424 5A12 2251 08BB BBBB"
	$"BBBF 9624 225F FAFF F012 2251 0FBB BBBB"
	$"BBBF 2FF9 25FB BBBF 0122 2422 108B BBBB"
	$"BBBB 9BB9 2FBB BBF0 1222 2222 10FB BBBB"
	$"BBBB BBF2 FBBB BF01 2422 2222 50FB BBBB"
	$"BBBB BBFF BBBB BF12 4322 2222 5108 BBBB"
	$"BBBB BBBB BBBB F012 5322 2224 210F BBBB"
	$"BBBB BBBB BBBB F124 5322 2222 210F BBBB"
	$"BBBB BBBB BBBF 0124 5322 2222 251F BBBB"
	$"BBBB BBBB BBBF 1245 3222 2222 2510 8BBB"
	$"BBBB BBBB BBBF 1245 3222 2222 2510 FBBB"
	$"BBBB BBBB BBF1 1245 3322 2222 2510 FBBB"
	$"BBBB BBBB BBF1 2453 3322 2222 4251 FBBB"
	$"BBBB BBBB BBFF FFFF FFFF FFFF FFFF FBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
};

resource 'cicn' (275) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0001 C000 0003 E000 0003 E000 0003 E000"
	$"0001 C000 0007 F000 000F F800 001F FC00"
	$"001F FC00 0001 C000 0001 C000 0001 C000"
	$"0003 E000 0003 E000 0003 E000 0007 F000"
	$"0007 F000 0007 F000 0003 E000 0003 E000"
	$"001F FC00 007F FF00 00FF FF80 00FF FF80"
	$"00FF FF80 0000 0000 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4444 4444 8888 0888"
	$"1111 C111 2222 2222 4442 2444 888A 2888"
	$"1111 4111 2227 7222 4448 0844 8890 0488"
	$"111F FD11 2201 4022 4445 4444 8889 4888"
	$"1112 2111 2222 2222 4442 2444 8884 1088"
	$"1114 1111 2224 1222 4442 2444 8882 2088"
	$"111C 1C11 2260 0322 4480 0084 8880 0088"
	$"10FF FF91 2200 0022 4444 4444 8888 8888",
	{	/* array ColorSpec: 11 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 13107, 39321, 26214,
		/* [11] */
		15, 0, 0, 0
	},
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 999F FF99 9999 9999 9999"
	$"9999 9999 9999 99F0 02F9 9999 9999 9999"
	$"9999 9999 9999 99F0 13F9 9999 9999 9999"
	$"9999 9999 9999 99F1 37F9 9999 9999 9999"
	$"9999 9999 9999 999F 7F99 9999 9999 9999"
	$"9999 9999 9999 9FFF 3FFF 9999 9999 9999"
	$"9999 9999 9999 F000 1227 F999 9999 9999"
	$"9999 9999 999F 0011 2224 7F99 9999 9999"
	$"9999 9999 999F FFFF FFFF FF99 9999 9999"
	$"9999 9999 9999 999F 7F99 9999 9999 9999"
	$"9999 9999 9999 999F 3F99 9999 9999 9999"
	$"9999 9999 9999 999F 2F99 9999 9999 9999"
	$"9999 9999 9999 99F2 17F9 9999 9999 9999"
	$"9999 9999 9999 99F1 27F9 9999 9999 9999"
	$"9999 9999 9999 99F1 24F9 9999 9999 9999"
	$"9999 9999 9999 9F10 014F 9999 9999 9999"
	$"9999 9999 9999 9F00 126F 9999 9999 9999"
	$"9999 9999 9999 9F01 227F 9999 9999 9999"
	$"9999 9999 9999 99F3 37F9 9999 9999 9999"
	$"9999 9999 9999 99F1 37F9 9999 9999 9999"
	$"9999 9999 999F FF10 247F FF99 9999 9999"
	$"9999 9999 9FF1 0011 1145 77FF 9999 9999"
	$"9999 9999 F100 1111 1223 3477 F999 9999"
	$"9999 9999 F001 1111 1222 3337 F999 9999"
	$"9999 9999 8FFF FFFF FFFF FFFF 8999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
};

resource 'cicn' (276) {
	8,
	{0, 0, 32, 32},
	2,
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1111 1111 2222 2222 4444 4444 8888 8888",
	{	/* array ColorSpec: 3 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 13107, 39321, 26214,
		/* [3] */
		3, 0, 0, 0
	},
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
	$"5555 5555 5555 5555 5555 5555 5555 5555"
};

resource 'cicn' (277) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0001 C000 0003 E000 0003 E000 0003 E000"
	$"0001 C000 0007 F000 000F F800 001F FC00"
	$"001F FC00 0001 C000 0001 C000 0001 C000"
	$"0003 E000 0003 E000 0003 E000 0007 F000"
	$"0007 F000 0007 F000 0003 E000 0003 E000"
	$"001F FC00 007F FF00 00FF FF80 00FF FF80"
	$"00FF FF80 0000 0000 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4444 4444 8888 0888"
	$"1111 C111 2223 E222 4443 E444 888B E888"
	$"1111 C111 2227 F222 444F F844 889F FC88"
	$"111F FD11 2201 C022 4445 C444 8889 C888"
	$"1113 E111 2223 E222 4443 E444 8887 F088"
	$"1117 F111 2227 F222 4443 E444 8883 E088"
	$"111F FC11 227F FF22 44FF FF84 88FF FF88"
	$"10FF FF91 2200 0022 4444 4444 8888 8888",
	{	/* array ColorSpec: 12 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 52428, 52428, 52428,
		/* [4] */
		3, 48059, 48059, 48059,
		/* [5] */
		4, 43690, 43690, 43690,
		/* [6] */
		5, 30583, 30583, 30583,
		/* [7] */
		6, 21845, 21845, 21845,
		/* [8] */
		7, 17476, 17476, 17476,
		/* [9] */
		8, 8738, 8738, 8738,
		/* [10] */
		9, 4369, 4369, 4369,
		/* [11] */
		10, 13107, 39321, 26214,
		/* [12] */
		15, 0, 0, 0
	},
	$"AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAF FFAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF0 27FA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF2 59FA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF7 9FFA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAF 9FAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AFFF 9FFF AAAA AAAA AAAA"
	$"AAAA AAAA AAAA F022 6678 FAAA AAAA AAAA"
	$"AAAA AAAA AAAF 0256 6889 FFAA AAAA AAAA"
	$"AAAA AAAA AAAF FFFF FFFF FFAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAF 8FAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAF 7FAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAF 7FAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF4 78FA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF4 78FA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF2 58FA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AF03 578F AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AF25 578F AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AF45 789F AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF7 89FA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAF8 9FFA AAAA AAAA AAAA"
	$"AAAA AAAA AAAF FF14 778F FFAA AAAA AAAA"
	$"AAAA AAAA AFF0 1155 6788 88FF AAAA AAAA"
	$"AAAA AAAA F015 5566 6888 888F FAAA AAAA"
	$"AAAA AAAA F455 5666 8888 889F FAAA AAAA"
	$"AAAA AAAA FFFF FFFF FFFF FFFF FAAA AAAA"
	$"AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA"
	$"AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA"
};

resource 'cicn' (278) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0048 0000"
	$"006C 0000 007E 0000 007F 0000 007F C000"
	$"00FF F000 00FF F800 01FF FC00 01FF FE00"
	$"03FF FF00 07FF FF00 07FF FF80 0FFF FF80"
	$"1FFF FFC0 1FF7 FFC0 1FE1 FFE0 09C3 FFE0"
	$"0387 FFE0 0307 FFF0 000F FFF0 000F FFF0"
	$"001F FFF0 001F FFF8 001F FFF8 003F FFF8"
	$"003F FFF8 003F FFF8 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4400 4444 8848 8888"
	$"116C 1111 227E 2222 4477 0444 887F C088"
	$"10FF F111 20E7 D822 45EB FC44 89FF F608"
	$"13FF F711 27FF F722 47FF FD84 8FEF FD88"
	$"19FF 7DD1 1FF6 FDC2 5FE1 FF64 89C3 FF68"
	$"0387 FF61 2127 FF72 444F FFF4 888F FFB0"
	$"111F FFB1 221F FFBA 441F FFB8 88BF FFB8"
	$"113F FFF9 223F FFFA 4400 0000 8888 8888",
	{	/* array ColorSpec: 11 elements */
		/* [1] */
		0, 56797, 56797, 56797,
		/* [2] */
		1, 48059, 48059, 48059,
		/* [3] */
		2, 34952, 34952, 34952,
		/* [4] */
		3, 30583, 30583, 30583,
		/* [5] */
		4, 21845, 21845, 21845,
		/* [6] */
		5, 17476, 17476, 17476,
		/* [7] */
		6, 8738, 8738, 8738,
		/* [8] */
		7, 4369, 4369, 4369,
		/* [9] */
		8, 43690, 43690, 43690,
		/* [10] */
		9, 13107, 39321, 26214,
		/* [11] */
		15, 0, 0, 0
	},
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9F99 F999 9999 9999 9999 9999"
	$"9999 9999 9FF9 FF99 9999 9999 9999 9999"
	$"9999 9999 9F1F F1F9 9999 9999 9999 9999"
	$"9999 9999 9F15 F15F 9999 9999 9999 9999"
	$"9999 9999 9F15 F24F FF99 9999 9999 9999"
	$"9999 9999 F016 6666 6FFF 9999 9999 9999"
	$"9999 9999 F05F FF66 6FFF F999 9999 9999"
	$"9999 999F 0258 86F6 64FF FF99 9999 9999"
	$"9999 999F 0166 6366 4F66 FFF9 9999 9999"
	$"9999 99F0 1266 6666 6664 FFFF 9999 9999"
	$"9999 9F01 1666 6666 6564 FFFF 9999 9999"
	$"9999 9F01 2666 6666 565F 66FF F999 9999"
	$"9999 F012 6666 6555 5656 66FF F999 9999"
	$"999F 0126 6666 5556 6656 64FF FF99 9999"
	$"999F 7002 266F FFFF F056 64FF FF99 9999"
	$"999F 0FF4 06F9 999F 0356 4F66 FFF9 9999"
	$"9999 F99F 0F99 99F0 1466 6666 FFF9 9999"
	$"9999 99F0 F999 9F01 2566 6664 FFF9 9999"
	$"9999 99FF 9999 9F12 4666 6664 FFFF 9999"
	$"9999 9999 9999 F012 6666 664F 6FFF 9999"
	$"9999 9999 9999 F124 6666 6666 6FFF 9999"
	$"9999 9999 999F 0124 6666 6666 6FFF 9999"
	$"9999 9999 999F 1246 6666 6666 6FFF F999"
	$"9999 9999 999F 1246 6666 6666 4FFF F999"
	$"9999 9999 99F1 1246 6666 6666 4FFF F999"
	$"9999 9999 99F1 2466 6666 6664 F6FF F999"
	$"9999 9999 99FF FFFF FFFF FFFF FFFF F999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
	$"9999 9999 9999 9999 9999 9999 9999 9999"
};

resource 'cicn' (279) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 000C 1800 001E 3C00"
	$"001E 3C00 000C 1800 000C 1800 001E 3C00"
	$"001F 7C00 003F FE00 007F FF00 007F FF00"
	$"00FF FF80 00FF FF80 00FF FF80 00FF FF80"
	$"00FF FF80 007F FF00 007F FF00 003F FE00"
	$"003F FE00 001F FC00 000F F800 001F FC00"
	$"001F FC00 001F FC00 00FF FF80 01FF FFC0"
	$"01FE 3FC0 0080 0080 0000 0000 0000 0000",
	$"1111 1111 2220 0222 444C 1844 889E BC88"
	$"111E 3D11 220C 1822 444C 1844 889E 3C88"
	$"111F 7C11 223F BE22 447F DF44 887F EF08"
	$"10FF EF91 22FF F7A2 44FF F784 88FF FB88"
	$"10FF FB91 227F FB22 447F FB44 883F F608"
	$"113F F611 221C 1C22 4443 E044 889F 7C88"
	$"111B ED11 221F FC22 44FC 1F84 89FF FFC8"
	$"11FE 3FD1 2080 0082 4404 4404 8888 8888",
	{	/* array ColorSpec: 13 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 48059, 48059, 48059,
		/* [5] */
		4, 43690, 43690, 43690,
		/* [6] */
		5, 34952, 34952, 34952,
		/* [7] */
		6, 30583, 30583, 30583,
		/* [8] */
		7, 21845, 21845, 21845,
		/* [9] */
		8, 17476, 17476, 17476,
		/* [10] */
		9, 8738, 8738, 8738,
		/* [11] */
		10, 4369, 4369, 4369,
		/* [12] */
		11, 13107, 39321, 26214,
		/* [13] */
		15, 0, 0, 0
	},
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB FFBB BBBF FBBB BBBB BBBB"
	$"BBBB BBBB BBBF 05FB BBF1 6FBB BBBB BBBB"
	$"BBBB BBBB BBBF 58FB BBF6 9FBB BBBB BBBB"
	$"BBBB BBBB BBBB FFBB BBBF FBBB BBBB BBBB"
	$"BBBB BBBB BBBB FFBB BBBF FBBB BBBB BBBB"
	$"BBBB BBBB BBBF 03FB BBF1 4FBB BBBB BBBB"
	$"BBBB BBBB BBBF 076F BF16 6FBB BBBB BBBB"
	$"BBBB BBBB BBF0 7676 F967 66FB BBBB BBBB"
	$"BBBB BBBB BF07 6667 6F98 766F BBBB BBBB"
	$"BBBB BBBB BF07 6666 96F9 876F BBBB BBBB"
	$"BBBB BBBB F076 6666 97F9 8866 FBBB BBBB"
	$"BBBB BBBB F075 6666 697F 9876 FBBB BBBB"
	$"BBBB BBBB F076 6666 697F 9886 FBBB BBBB"
	$"BBBB BBBB F076 6666 6697 F987 FBBB BBBB"
	$"BBBB BBBB F176 6666 6697 F988 FBBB BBBB"
	$"BBBB BBBB BF76 6666 6697 F98F BBBB BBBB"
	$"BBBB BBBB BF59 6666 6697 F98F BBBB BBBB"
	$"BBBB BBBB BBF7 9666 698F 98FB BBBB BBBB"
	$"BBBB BBBB BBF7 8999 987F 98FB BBBB BBBB"
	$"BBBB BBBB BBBF 78FF FFFA 9FBB BBBB BBBB"
	$"BBBB BBBB BBBB FF01 133F FBBB BBBB BBBB"
	$"BBBB BBBB BBBF 0128 F888 8FBB BBBB BBBB"
	$"BBBB BBBB BBBF 1F88 888F 8FBB BBBB BBBB"
	$"BBBB BBBB BBBF 388F FF88 8FBB BBBB BBBB"
	$"BBBB BBBB FFFF FFFF FFFF FFFF FBBB BBBB"
	$"BBBB BBBF 2269 999F BF99 9998 8FBB BBBB"
	$"BBBB BBBF 9FFF FFFB BBFF FFFF 9FBB BBBB"
	$"BBBB BBBB FBBB BBBB BBBB BBBB FBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
	$"BBBB BBBB BBBB BBBB BBBB BBBB BBBB BBBB"
};

resource 'cicn' (280) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"03C3 C3C0 03E7 E7C0 03FF FFC0 03FF FFC0"
	$"01FF FF80 00FF FF00 007F FE00 007F FE00"
	$"007F FE00 007F FE00 007F FE00 007F FE00"
	$"007F FE00 007F FE00 007F FE00 00FF FF00"
	$"00FF FF00 00FF FF00 01FF FF80 01FF FF80"
	$"01FF FF80 03FF FFC0 03FF FFC0 03FF FFC0"
	$"03FF FFC0 0000 0000 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4444 4444 8808 0808"
	$"13C3 C3D1 23FF FFC2 43FF FFC4 8BFF FFC8"
	$"11FF FF91 20FF FF22 4440 0244 887F FE88"
	$"117F FE11 227F FE22 447F FE44 887F FE88"
	$"117F FE11 227F FE22 4440 0244 88FF FF08"
	$"10FF FF11 20FF FF22 45FF FF84 89FF FF88"
	$"11FF FF91 23FF FFC2 43FF FFC4 8BFF FFC8"
	$"13FF FFD1 2000 0002 4444 4444 8888 8888",
	{	/* array ColorSpec: 9 elements */
		/* [1] */
		0, 52428, 52428, 52428,
		/* [2] */
		1, 48059, 48059, 48059,
		/* [3] */
		2, 34952, 34952, 34952,
		/* [4] */
		3, 30583, 30583, 30583,
		/* [5] */
		4, 21845, 21845, 21845,
		/* [6] */
		5, 17476, 17476, 17476,
		/* [7] */
		6, 8738, 8738, 8738,
		/* [8] */
		7, 13107, 39321, 26214,
		/* [9] */
		15, 0, 0, 0
	},
	$"7777 7777 7777 7777 7777 7777 7777 7777"
	$"7777 7777 7777 7777 7777 7777 7777 7777"
	$"7777 7777 7777 7777 7777 7777 7777 7777"
	$"7777 7777 7777 7777 7777 7777 7777 7777"
	$"7777 77FF FF77 77FF FF77 77FF FF77 7777"
	$"7777 77F1 02F7 7F21 22F7 7F6F FF77 7777"
	$"7777 77F1 02FF FF21 22FF FF6F FF77 7777"
	$"7777 77F1 1210 0521 22F5 5FFF FF77 7777"
	$"7777 777F 1121 1522 26F5 FFFF F777 7777"
	$"7777 7777 F112 2255 5F66 FFFF 7777 7777"
	$"7777 7777 7FFF FFFF FFFF FFF7 7777 7777"
	$"7777 7777 7F21 0531 F63F F6F7 7777 7777"
	$"7777 7777 7F21 1533 F66F FFF7 7777 7777"
	$"7777 7777 7F22 2555 FFFF FFF7 7777 7777"
	$"7777 7777 7F02 1053 1F63 FFF7 7777 7777"
	$"7777 7777 7F02 1153 3F66 FFF7 7777 7777"
	$"7777 7777 7F12 2255 5FFF FFF7 7777 7777"
	$"7777 7777 7F21 0531 F63F F6F7 7777 7777"
	$"7777 7777 7F21 1533 F66F FFF7 7777 7777"
	$"7777 7777 7F22 2555 FFFF FFF7 7777 7777"
	$"7777 7777 F102 1052 1F53 FF6F 7777 7777"
	$"7777 7777 F112 2255 5FFF FFFF 7777 7777"
	$"7777 777F 1021 0521 F53F F6FF F777 7777"
	$"7777 777F 1021 1522 F54F FFFF F777 7777"
	$"7777 777F 1122 2555 FF5F FFFF F777 7777"
	$"7777 77F0 1002 1052 1F53 FF6F FF77 7777"
	$"7777 77F0 1002 1152 2F55 FFFF FF77 7777"
	$"7777 77F1 1112 2255 5FFF FFFF FF77 7777"
	$"7777 77FF FFFF FFFF FFFF FFFF FF77 7777"
	$"7777 7777 7777 7777 7777 7777 7777 7777"
	$"7777 7777 7777 7777 7777 7777 7777 7777"
	$"7777 7777 7777 7777 7777 7777 7777 7777"
};

resource 'cicn' (281) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 001C 1C00 003E 3E00 0E3E 3E38"
	$"1F1C 1C7C 1F08 087C 0E1C 1C38 041C 1C10"
	$"063E 3E30 073E 3E70 07BF 7EF0 07FF FFF0"
	$"07FF FFF0 03FF FFE0 03FF FFE0 03FF FFE0"
	$"01FF FFC0 01FF FFC0 01FF FFC0 00FF FF80"
	$"00FF FF80 00FF FF80 007F FF00 000F F800"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	$"1111 1111 2222 2222 4444 4444 8888 8888"
	$"1101 0111 221C 1C22 403E 3E00 8E3E BE38"
	$"1F1C 1C7D 1F08 087C 4E5C 5C38 849C 9C90"
	$"163E 3E31 273E 3E72 47BF 7EF4 87FF FFF0"
	$"17FF FFF1 23E0 03E2 421F FC24 8BFE 3FE8"
	$"11FF FFC1 219F FCC2 45FF FFC4 88F0 0788"
	$"108F F891 22FF FFA2 447F FF04 880F F808"
	$"1100 0111 2222 2222 4444 4444 8888 8888",
	{	/* array ColorSpec: 14 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 4369, 4369, 4369,
		/* [13] */
		12, 13107, 39321, 26214,
		/* [14] */
		15, 0, 0, 0
	},
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCF FFCC CCCF FFCC CCCC CCCC"
	$"CCCC CCCC CCF0 37FC CCF0 38FC CCCC CCCC"
	$"CCCC FFFC CCF3 79FC CCF3 8AFC CCFF FCCC"
	$"CCCF 036F CCCF FFCC CCCF FFCC CF03 9FCC"
	$"CCCF 268F CCCC FCCC CCCC FCCC CF39 BFCC"
	$"CCCC FFFC CCCF 3FCC CCCF 6FCC CCFF FCCC"
	$"CCCC CFCC CCCF 3FCC CCCF 6FCC CCCF CCCC"
	$"CCCC CFFC CCF3 57FC CCF6 7AAC CCFF CCCC"
	$"CCCC CF0F CCF3 57FC CCF6 8AFC CFAF CCCC"
	$"CCCC CF03 FCF3 568F CF67 8AFC F9AF CCCC"
	$"CCCC CF03 6F34 5668 F668 8AAF 9AFF CCCC"
	$"CCCC CA01 4674 5678 9678 AAA8 ABF9 CCCC"
	$"CCCC CCF0 367F FFFF FFFF FF9A BFFC CCCC"
	$"CCCC CCFF FFF4 5677 8888 9AFF FFFC CCCC"
	$"CCCC CCF0 1444 5677 8888 9AAA BFFC CCCC"
	$"CCCC CCCF 0445 667F FF88 AAAB FFCC CCCC"
	$"CCCC CCCF 0FF5 6677 8889 AAFF FFCC CCCC"
	$"CCCC CCCF 0145 6667 888A AABF FFCC CCCC"
	$"CCCC CCCC F056 FFFF FFFF FFFF FCCC CCCC"
	$"CCCC CCCC FFFF BBA9 8887 66FF FCCC CCCC"
	$"CCCC CCCC FFFB BA98 8766 5551 FCCC CCCC"
	$"CCCC CCCC CFFF BA98 7665 5FFF CCCC CCCC"
	$"CCCC CCCC CCCC FFFF FFFF FCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
};

resource 'cicn' (282) {
	16,
	{0, 0, 32, 32},
	4,
	$"0000 0000 0000 0000 0007 F000 0007 F000"
	$"0007 F000 0007 F000 0007 F000 07C7 F1F0"
	$"0FF7 F7F8 1FF8 0FFC 1FFC 1FFC 3FFE 3FFE"
	$"3FFF 7FFE 3FFF FFFE 3FFF FFFE 3FFF FFFE"
	$"1FFF FFFC 1FFF FFFC 0FFF FFF8 07FF FFF0"
	$"03FF FFE0 03FF FFE0 01FF FFC0 01FF FFC0"
	$"01FF FFC0 00FF FF80 00FF FF80 00FF FF80"
	$"007F FF00 000F F800 0000 0000 0000 0000",
	$"1111 1111 2220 0222 4447 F444 8885 D088"
	$"1116 B111 2227 7222 4006 B404 87C5 D1F0"
	$"0FF7 F7F9 1FF8 0FFC 1E3C 1E3C BDDE 3DDE"
	$"3BEF 7BEE 3BEF FBEE 3BF7 F7EE BDF7 F7DE"
	$"1DFB EFDC 1EFB EFBC 4F7B EF78 87A0 02F0"
	$"121F FC21 23FF FFE2 41FE 3FC4 899F FCC8"
	$"11FF FFD1 20F0 0782 448F F884 88FF FF88"
	$"107F FF11 220F F822 4440 0044 8888 8888",
	{	/* array ColorSpec: 14 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 61166, 61166, 61166,
		/* [3] */
		2, 56797, 56797, 56797,
		/* [4] */
		3, 52428, 52428, 52428,
		/* [5] */
		4, 48059, 48059, 48059,
		/* [6] */
		5, 43690, 43690, 43690,
		/* [7] */
		6, 34952, 34952, 34952,
		/* [8] */
		7, 30583, 30583, 30583,
		/* [9] */
		8, 21845, 21845, 21845,
		/* [10] */
		9, 17476, 17476, 17476,
		/* [11] */
		10, 8738, 8738, 8738,
		/* [12] */
		11, 4369, 4369, 4369,
		/* [13] */
		12, 13107, 39321, 26214,
		/* [14] */
		15, 0, 0, 0
	},
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CFFF FFFF CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF80 58FF CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF0A 8FAF CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF58 FA9F CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CF8F AF9F CCCC CCCC CCCC"
	$"CCCC CFFF FFCC CFFA 99FF CCCF FFFF CCCC"
	$"CCCC F002 33FF CFFF FFFF CFF2 2444 FCCC"
	$"CCCF 0055 5568 FCCC CCCC F224 7888 4FCC"
	$"CC88 055F FF68 8FCC CCCF 247F FF88 878C"
	$"CCF0 55FA AAF8 88FC CCF2 47FA AAF8 8AFC"
	$"CCF2 5FAA AAAF 888F CF24 7FAA AAAF 8AFC"
	$"CCF2 5FAA AAAF 8888 F247 7FAA AAAF 8AFC"
	$"CCF3 5FAA AAAA F888 9557 FAAA AAAF 8AFC"
	$"CCA3 55FA AAAA F888 9577 FAAA AAF8 AFAC"
	$"CCC9 55FA AAAA AF88 977F AAAA AAF8 AFCC"
	$"CCCA 555F AAAA AF88 977F AAAA AF8A FACC"
	$"CCCC F655 FAAA AFF8 97FF AAAA F8AF FCCC"
	$"CCCC CF86 5FAF FFFF FFFF FFAF 8AFF CCCC"
	$"CCCC CCFF FFF5 5688 8888 99FF FFFC CCCC"
	$"CCCC CCF1 2255 6888 8888 99AA AFFC CCCC"
	$"CCCC CCCF 1256 688F FF89 9AAA AFCC CCCC"
	$"CCCC CCCF 1FF6 8888 8889 9AAA FFCC CCCC"
	$"CCCC CCCF 1256 8888 8899 AAAB FFCC CCCC"
	$"CCCC CCCC F168 FFFF FFFF FFBF FCCC CCCC"
	$"CCCC CCCC FFFF AAA9 9888 77FF FCCC CCCC"
	$"CCCC CCCC FFFA AA99 8887 7662 FCCC CCCC"
	$"CCCC CCCC CFFF A998 8877 6FFF CCCC CCCC"
	$"CCCC CCCC CCCC FFFF FFFF FCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
	$"CCCC CCCC CCCC CCCC CCCC CCCC CCCC CCCC"
};

resource 'cicn' (310) {
	16,
	{0, 0, 32, 32},
	4,
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	$"0200 0000 0500 0000 0880 0000 1040 0000"
	$"2020 0000 4030 0000 8018 0000 8018 0000"
	$"8038 0000 7FF0 0000 0980 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 8 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 48059, 48059, 48059,
		/* [4] */
		3, 43690, 43690, 43690,
		/* [5] */
		4, 34952, 34952, 34952,
		/* [6] */
		5, 30583, 30583, 30583,
		/* [7] */
		6, 21845, 21845, 21845,
		/* [8] */
		15, 0, 0, 0
	},
	$"0000 00F0 0000 0000 0000 0000 0000 0000"
	$"0000 0F2F 0000 0000 0000 0000 0000 0000"
	$"0000 F324 F000 0000 0000 0000 0000 0000"
	$"000F 3122 4F00 0000 0000 0000 0000 0000"
	$"00F3 1122 44F0 0000 0000 0000 0000 0000"
	$"0F31 1022 246F 0000 0000 0000 0000 0000"
	$"F331 1022 2446 F000 0000 0000 0000 0000"
	$"F331 1022 2446 F000 0000 0000 0000 0000"
	$"F333 3222 4466 F000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"0000 F205 F000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (311) {
	16,
	{0, 0, 32, 32},
	4,
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	$"0980 0000 7FF0 0000 8038 0000 8018 0000"
	$"8018 0000 4030 0000 2020 0000 1040 0000"
	$"0880 0000 0500 0000 0200 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 8 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 48059, 48059, 48059,
		/* [4] */
		3, 43690, 43690, 43690,
		/* [5] */
		4, 34952, 34952, 34952,
		/* [6] */
		5, 30583, 30583, 30583,
		/* [7] */
		6, 21845, 21845, 21845,
		/* [8] */
		15, 0, 0, 0
	},
	$"0000 F205 F000 0000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"F330 0002 4466 F000 0000 0000 0000 0000"
	$"F331 0012 2446 F000 0000 0000 0000 0000"
	$"F331 1122 2446 F000 0000 0000 0000 0000"
	$"0F33 1122 246F 0000 0000 0000 0000 0000"
	$"00F3 3122 44F0 0000 0000 0000 0000 0000"
	$"000F 3322 4F00 0000 0000 0000 0000 0000"
	$"0000 F324 F000 0000 0000 0000 0000 0000"
	$"0000 0F2F 0000 0000 0000 0000 0000 0000"
	$"0000 00F0 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (312) {
	8,
	{0, 0, 32, 32},
	2,
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000",
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000",
	{	/* array ColorSpec: 4 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 48059, 48059, 48059,
		/* [3] */
		2, 30583, 30583, 30583,
		/* [4] */
		3, 0, 0, 0
	},
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
	$"00D2 C000 0000 0000 00D2 C000 0000 0000"
};

resource 'cicn' (313) {
	16,
	{0, 0, 32, 32},
	4,
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000",
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"7FF0 0000 8008 0000 8008 0000 8008 0000"
	$"8008 0000 8008 0000 7FF0 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000",
	{	/* array ColorSpec: 8 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 48059, 48059, 48059,
		/* [4] */
		3, 43690, 43690, 43690,
		/* [5] */
		4, 34952, 34952, 34952,
		/* [6] */
		5, 21845, 21845, 21845,
		/* [7] */
		6, 30583, 30583, 30583,
		/* [8] */
		15, 0, 0, 0
	},
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"F310 0000 0245 F000 0000 0000 0000 0000"
	$"F100 0000 0024 F000 0000 0000 0000 0000"
	$"F100 0000 0024 F000 0000 0000 0000 0000"
	$"F100 0000 0024 F000 0000 0000 0000 0000"
	$"F310 0000 0245 F000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
	$"0000 F206 F000 0000 0000 0000 0000 0000"
};

resource 'cicn' (314) {
	16,
	{0, 0, 32, 32},
	4,
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000",
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"7FF0 0000 FFF8 0000 E7F8 0000 CFF8 0000"
	$"FFF8 0000 FFF8 0000 7FF0 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000"
	$"0980 0000 0980 0000 0980 0000 0980 0000",
	{	/* array ColorSpec: 8 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 34952, 34952, 34952,
		/* [4] */
		3, 30583, 30583, 30583,
		/* [5] */
		4, 21845, 21845, 21845,
		/* [6] */
		5, 17476, 17476, 17476,
		/* [7] */
		6, 48059, 48059, 48059,
		/* [8] */
		15, 0, 0, 0
	},
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"FF43 4FFF FFFF F000 0000 0000 0000 0000"
	$"F541 14FF FFFF F000 0000 0000 0000 0000"
	$"F521 34FF FFFF F000 0000 0000 0000 0000"
	$"FF43 4FFF FFFF F000 0000 0000 0000 0000"
	$"FFFF FFFF FFFF F000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
	$"0000 F603 F000 0000 0000 0000 0000 0000"
};

resource 'cicn' (315) {
	16,
	{0, 0, 32, 32},
	4,
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	$"0200 0000 0700 0000 0F80 0000 1FC0 0000"
	$"3FE0 0000 7BF0 0000 F3F8 0000 F7F8 0000"
	$"FFF8 0000 7FF0 0000 0980 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 6 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 48059, 48059, 48059,
		/* [3] */
		2, 43690, 43690, 43690,
		/* [4] */
		3, 30583, 30583, 30583,
		/* [5] */
		4, 21845, 21845, 21845,
		/* [6] */
		15, 0, 0, 0
	},
	$"0000 00F0 0000 0000 0000 0000 0000 0000"
	$"0000 0FFF 0000 0000 0000 0000 0000 0000"
	$"0000 FFFF F000 0000 0000 0000 0000 0000"
	$"000F FFFF FF00 0000 0000 0000 0000 0000"
	$"00FF FFFF FFF0 0000 0000 0000 0000 0000"
	$"0FF4 2FFF FFFF 0000 0000 0000 0000 0000"
	$"FF42 04FF FFFF F000 0000 0000 0000 0000"
	$"FF40 24FF FFFF F000 0000 0000 0000 0000"
	$"FFFF 44FF FFFF F000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"0000 F103 F000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};

resource 'cicn' (316) {
	16,
	{0, 0, 32, 32},
	4,
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 FFF8 0000"
	$"FFF8 0000 FFF8 0000 FFF8 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	$"0980 0000 7FF0 0000 F3F8 0000 E7F8 0000"
	$"FFF8 0000 7FF0 0000 3FE0 0000 1FC0 0000"
	$"0F80 0000 0700 0000 0200 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000",
	{	/* array ColorSpec: 6 elements */
		/* [1] */
		0, 65535, 65535, 65535,
		/* [2] */
		1, 56797, 56797, 56797,
		/* [3] */
		2, 48059, 48059, 48059,
		/* [4] */
		3, 30583, 30583, 30583,
		/* [5] */
		4, 21845, 21845, 21845,
		/* [6] */
		15, 0, 0, 0
	},
	$"0000 F203 F000 0000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"FF44 14FF FFFF F000 0000 0000 0000 0000"
	$"FF41 44FF FFFF F000 0000 0000 0000 0000"
	$"FFF4 4FFF FFFF F000 0000 0000 0000 0000"
	$"0FFF FFFF FFFF 0000 0000 0000 0000 0000"
	$"00FF FFFF FFF0 0000 0000 0000 0000 0000"
	$"000F FFFF FF00 0000 0000 0000 0000 0000"
	$"0000 FFFF F000 0000 0000 0000 0000 0000"
	$"0000 0FFF 0000 0000 0000 0000 0000 0000"
	$"0000 00F0 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
};










resource 'DLOG' (rConfigureGame) {
	{40, 40, 363, 355},
	dBoxProc,
	visible,
	goAway,
	0x0,
	rConfigureGame,
	"Configure Game"
};
resource 'DITL' (rConfigureGame) {
	{
		{290, 244, 310, 302},	Button { enabled, "Done" },
		{0, -1000, 20, 2},		StaticText { disabled, "=.190103,1B190003" },
		{290, 166, 310, 228},	Button { enabled, "Cancel" },
		{9, 12, 27, 157},		RadioButton { enabled, "Play White Pieces" },
		{27, 12, 45, 157},		RadioButton { enabled, "Play Black Pieces" },
		{57, 12, 75, 307},		CheckBox { enabled, "Let Computer Move White Pieces (badly)" },
		{75, 12, 93, 307},		CheckBox { enabled, "Let Computer Move Black Pieces (badly)" },
		{105, 12, 123, 118},	CheckBox { enabled, "Time Game" },
		{50, 10, 51, 305},		UserItem { disabled },
		{98, 10, 99, 305},		UserItem { disabled },
		{190, 10, 191, 305},	UserItem { disabled },
		{129, 14, 152, 94},		UserItem { enabled },
		{157, 14, 180, 94},		UserItem { enabled },
		{132, 113, 148, 390},	StaticText { disabled, "Time (HH:MM) For White" },
		{161, 113, 177, 390},	StaticText { disabled, "Time (HH:MM) For Black" },
		{199, 68, 217, 306},	StaticText { disabled, "Zone: ^0" },
		{217, 45, 235, 306},	StaticText { disabled, "Machine: ^1" },
		{235, 38, 253, 306},	StaticText { disabled, "Opponent: ^2" },
		{253, 13, 271, 306},	StaticText { disabled, "Connect Time: ^3" },
		{0, 0, 0, 0},			helpItem {disabled, HMScanhdlg {rConfigureGame},}
	}
};
resource 'hdlg' (rConfigureGame, purgeable) {
	HelpMgrVersion, 0, hmDefaultOptions, 0, 1, HMSkipItem {},
	{
		HMStringItem {
			{14, 3},{0, 0, 0, 0},
			"When you have set everything the way you want, click here.",
			"",
			"When you have set everything the way you want, click here.",
			"",
		},
		HMStringItem {{5, 5},{0, 0, 0, 0},"","","","",},
		HMStringItem {
			{14, 3},{0, 0, 0, 0},
			"If you change your mind about the changes, click here.",
			"",
			"If you change your mind about the changes, click here.",
			"",
		},
		HMStringItem {
			{9, 4},{0, 0, 0, 0},
			"You are currently playing the black pieces.  If you want to play the "
			"white pieces, click here.",
			"",
			"This is selected, which means that you are currently playing the white pieces.",
			"",
		},
		HMStringItem {
			{9, 4},{0, 0, 0, 0},
			"You are currently playing the white pieces.  If you want to play the "
			"black pieces, click here.",
			"",
			"This is selected, which means that you are currently playing the black pieces.",
			"",
		},
		HMStringItem {
			{10, 3},{0, 0, 0, 0},
			"If you want the computer to move the white pieces less than well, click here.",
			"",
			"The computer is currently set to move the white pieces.  If you dont want "
			"it to, click here.",
			"",
		},
		HMStringItem {
			{10, 3},{0, 0, 0, 0},
			"If you want the computer to move the black pieces less than well, click here.",
			"",
			"The computer is currently set to move the black pieces.  If you dont want "
			"it to, click here.",
			"",
		},
		HMStringItem {
			{10, 3},{0, 0, 0, 0},
			"If you want to play a timed game, click here.",
			"",
			"If you want to play an untimed game, click here.",
			"",
		},
		HMStringItem {{5, 5},{0, 0, 0, 0},"","","","",},
		HMStringItem {{5, 5},{0, 0, 0, 0},"","","","",},
		HMStringItem {{5, 5},{0, 0, 0, 0},"","","","",},
		HMStringItem {
			{16, 2},{0, 0, 0, 0},
			"If you are timing the game, you can adjust the amount of "
			"time for white using the arrows.",
			"",
			"If you are timing the game, you can adjust the amount of "
			"time for white using the arrows.",
			"",
		},
		HMStringItem {
			{16, 2},{0, 0, 0, 0},
			"If you are timing the game, you can adjust the amount of "
			"time for black using the arrows.",
			"",
			"If you are timing the game, you can adjust the amount of "
			"time for black using the arrows.",
			"",
		},
		HMStringItem {{5, 5},{0, 0, 0, 0},"","","","",},
		HMStringItem {{5, 5},{0, 0, 0, 0},"","","","",},
		HMStringItem {
			{5, 38},{0, 0, 0, 0},
			"",
			"If you are playing an opponent over the network, this is the opponents zone.",
			"",
			"",
		},
		HMStringItem {
			{5, 61},{0, 0, 0, 0},
			"",
			"If you are playing an opponent over the network, this is the opponents machine.",
			"",
			"",
		},
	}
};

/* The below could as easily be included in the above 'hdlg' for the dialog.  However, it is
** done this way as an example of using an 'hwin' resource to add help items to a dialog.
** This technique is particularly useful for adding help to items added to print job dialogs. */

resource 'hwin' (9999, purgeable) {
	HelpMgrVersion, hmDefaultOptions,
	{
		9999,
		'hrct',
		14,					/* Must use the window title technique, as using a windowKind of 2 */
		"Configure Game",	/* would mean that this help item would show up for all dialogs. */
	}
};
resource 'hrct' (9999, purgeable) {
	HelpMgrVersion, hmDefaultOptions, 0, 1,
	{
		HMStringResItem {
			{240, 106},
			{238, 41, 253, 306},
			9999, 1
		},
	}
};
resource 'STR#' (9999, purgeable) {
	{
		"If you are playing an opponent over the network, this is the opponents name.",
	}
};




resource 'DLOG' (rArrangeWarning) {
	{40, 40, 134, 338},
	dBoxProc,
	visible,
	goAway,
	0x0,
	rArrangeWarning,
	""
};
resource 'DITL' (rArrangeWarning) {
	{
		{61, 238, 81, 283},		Button		{ enabled, "OK" },
		{0, -1000, 20, 2},		StaticText	{ disabled, "=.190103,1B190003" },
		{61, 161, 81, 219},		Button		{ enabled, "Cancel" },
		{10, 23, 42, 55},		Icon		{ disabled, 0 },
		{10, 78, 50, 288},		StaticText	{ disabled,
								"Arranging the board will cause the game "
								"moves to be lost." }
	}
};






resource 'DLOG' (rPrStatusDlg) {
	{110, 40, 219, 423},
	dBoxProc,
	visible,
	goAway,
	0x0,
	rPrStatusDlg,
	""
};
resource 'DITL' (rPrStatusDlg) {
	{
		{72, 24, 92, 104},		Button { enabled, "Proceed" },
		{72, 128, 92, 208},		Button { enabled, "Pause" },
		{72, 232, 92, 362},		Button { enabled, "Cancel Printing" },
		{16, 24, 56, 300},		StaticText { disabled, "Document ^0 is being printed." }
	}
};




resource 'DLOG' (rRevertWarning) {
	{40, 40, 134, 338},
	dBoxProc,
	visible,
	goAway,
	0x0,
	rRevertWarning,
	""
};
resource 'DITL' (rRevertWarning) {
	{
		{61, 238, 81, 283},		Button		{ enabled, "OK" },
		{0, -1000, 20, 2},		StaticText	{ disabled, "=.190103,1B190003" },
		{61, 161, 81, 219},		Button		{ enabled, "Cancel" },
		{10, 23, 42, 55},		Icon		{ disabled, 0 },
		{10, 78, 50, 288},		StaticText	{ disabled,
								"Reverting to saved will cause the current "
								"game to be lost." }
	}
};




resource 'DLOG' (rGoToMove) {
	{40, 40, 161, 210},
	dBoxProc,
	visible,
	goAway,
	0x0,
	rGoToMove,
	""
};
resource 'DITL' (rGoToMove) {
	{
		{56, 94, 76, 152},		Button { enabled, "Okay" },
		{ 0, -1000, 20, 2},		StaticText	{ disabled,
			"03190801,0D190801,=.190103,1B190003,=W190006,=w190006,=B190007,=b190007"
		},
		{86, 95, 106, 153},		Button { enabled, "Cancel" },
		{19, 11, 35, 93},		StaticText { disabled, "Go To Move:" },
		{19, 100, 35, 144},		EditText { enabled, "" },
		{62, 16, 80, 76},		RadioButton { enabled, "White" },
		{82, 16, 100, 74},		RadioButton { enabled, "Black" }
	}
};













